/*
 * inkjet - JPEG-image decoding, encoding & EXIF reading library for browser and node.js
 * @version v2.0.1
 * @author Grigoriy Chudnov <g.chudnov@gmail.com> (https://github.com/gchudnov)
 * @link https://github.com/gchudnov/inkjet
 * @license MIT
 */
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var t;t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,t.inkjet=e()}}(function(){return function e(t,r,n){function i(o,s){if(!r[o]){if(!t[o]){var c="function"==typeof require&&require;if(!s&&c)return c(o,!0);if(a)return a(o,!0);var u=new Error("Cannot find module '"+o+"'");throw u.code="MODULE_NOT_FOUND",u}var f=r[o]={exports:{}};t[o][0].call(f.exports,function(e){var r=t[o][1][e];return i(r?r:e)},f,f.exports,e,t,r,n)}return r[o].exports}for(var a="function"==typeof require&&require,o=0;o<n.length;o++)i(n[o]);return i}({1:[function(e,t,r){"use strict";function n(t,r,n){"function"==typeof r&&(n=r,r={});try{if(t=u.toUint8Array(t),c){var i=e("webworkify")(m);i.onmessage=function(e){var t=e.data,r=t.err?new Error(t.err):void 0;n(r,t.result)};var a={buf:t,options:r};r.transferable?i.postMessage(a,[t]):i.postMessage(a)}else l(t,r,n)}catch(o){n(o)}}function i(t,r,n){"function"==typeof r&&(n=r,r={});try{if(t=u.toArrayLike(t),!r.hasOwnProperty("width")||!r.hasOwnProperty("height"))return n(new Error("Provide width & height of the buffer"));if(c){var i=e("webworkify")(v);i.onmessage=function(e){var t=e.data,r=t.err?new Error(t.err):void 0;n(r,t.result)};var a={buf:t,options:r};r.transferable?i.postMessage(a,[t]):i.postMessage(a)}else h(t,r,n)}catch(o){n(o)}}function a(t,r,n){"function"==typeof r&&(n=r,r={});try{if(t=u.toArrayBuffer(t),c){var i=e("webworkify")(g);i.onmessage=function(e){var t=e.data,r=t.err?new Error(t.err):void 0;n(r,t.result)};var a={buf:t};r.transferable?i.postMessage(a,[t]):i.postMessage(a)}else f(t,r,n)}catch(o){n(o)}}function o(e,t){try{e=u.toBuffer(e),d.lookup(e,t)}catch(r){t(r)}}function s(e,t){try{e=u.toBuffer(e),p.collect(e,t)}catch(r){t(r)}}var c=e("./lib/has-worker").HAS_WORKER,u=e("./lib/buffer-utils"),f=e("./lib/exif"),l=e("./lib/decode"),h=e("./lib/encode"),d=e("./lib/magic"),p=e("./lib/info"),g=e("./lib/exif-worker"),m=e("./lib/decode-worker"),v=e("./lib/encode-worker");t.exports.decode=n,t.exports.encode=i,t.exports.exif=a,t.exports.magic=o,t.exports.info=s},{"./lib/buffer-utils":5,"./lib/decode":7,"./lib/decode-worker":6,"./lib/encode":9,"./lib/encode-worker":8,"./lib/exif":11,"./lib/exif-worker":10,"./lib/has-worker":12,"./lib/info":13,"./lib/magic":15,webworkify:59}],2:[function(e,t,r){(function(){("undefined"!=typeof r&&null!==r?r:this).ExifReader=function(){function e(){var e=this;this._getTagValueAt={1:function(t){return e._getByteAt(t)},2:function(t){return e._getAsciiAt(t)},3:function(t){return e._getShortAt(t)},4:function(t){return e._getLongAt(t)},5:function(t){return e._getRationalAt(t)},7:function(t){return e._getUndefinedAt(t)},9:function(t){return e._getSlongAt(t)},10:function(t){return e._getSrationalAt(t)}},this._tiffHeaderOffset=0}return e.prototype._MIN_DATA_BUFFER_LENGTH=2,e.prototype._JPEG_ID_SIZE=2,e.prototype._JPEG_ID=65496,e.prototype._APP_MARKER_SIZE=2,e.prototype._APP0_MARKER=65504,e.prototype._APP1_MARKER=65505,e.prototype._APP15_MARKER=65519,e.prototype._APP_ID_OFFSET=4,e.prototype._BYTES_Exif=1165519206,e.prototype._TIFF_HEADER_OFFSET=10,e.prototype._BYTE_ORDER_BIG_ENDIAN=18761,e.prototype._BYTE_ORDER_LITTLE_ENDIAN=19789,e.prototype.load=function(e){return this.loadView(new DataView(e))},e.prototype.loadView=function(e){return this._dataView=e,this._tags={},this._checkImageHeader(),this._readTags(),this._dataView=null},e.prototype._checkImageHeader=function(){if(this._dataView.byteLength<this._MIN_DATA_BUFFER_LENGTH||this._dataView.getUint16(0,!1)!==this._JPEG_ID)throw new Error("Invalid image format");if(this._parseAppMarkers(this._dataView),!this._hasExifData())throw new Error("No Exif data")},e.prototype._parseAppMarkers=function(e){var t,r,n;for(t=this._JPEG_ID_SIZE,n=[];;){if(e.byteLength<t+this._APP_ID_OFFSET+5)break;if(this._isApp1ExifMarker(e,t))r=e.getUint16(t+this._APP_MARKER_SIZE,!1),this._tiffHeaderOffset=t+this._TIFF_HEADER_OFFSET;else{if(!this._isAppMarker(e,t))break;r=e.getUint16(t+this._APP_MARKER_SIZE,!1)}n.push(t+=this._APP_MARKER_SIZE+r)}return n},e.prototype._isApp1ExifMarker=function(e,t){return e.getUint16(t,!1)===this._APP1_MARKER&&e.getUint32(t+this._APP_ID_OFFSET,!1)===this._BYTES_Exif&&0===e.getUint8(t+this._APP_ID_OFFSET+4,!1)},e.prototype._isAppMarker=function(e,t){var r;return r=e.getUint16(t,!1),r>=this._APP0_MARKER&&r<=this._APP15_MARKER},e.prototype._hasExifData=function(){return 0!==this._tiffHeaderOffset},e.prototype._readTags=function(){return this._setByteOrder(),this._read0thIfd(),this._readExifIfd(),this._readGpsIfd(),this._readInteroperabilityIfd()},e.prototype._setByteOrder=function(){if(this._dataView.getUint16(this._tiffHeaderOffset)===this._BYTE_ORDER_BIG_ENDIAN)return this._littleEndian=!0;if(this._dataView.getUint16(this._tiffHeaderOffset)===this._BYTE_ORDER_LITTLE_ENDIAN)return this._littleEndian=!1;throw new Error("Illegal byte order value. Faulty image.")},e.prototype._read0thIfd=function(){var e;return e=this._getIfdOffset(),this._readIfd("0th",e)},e.prototype._getIfdOffset=function(){return this._tiffHeaderOffset+this._getLongAt(this._tiffHeaderOffset+4)},e.prototype._readExifIfd=function(){var e;return null!=this._tags["Exif IFD Pointer"]?(e=this._tiffHeaderOffset+this._tags["Exif IFD Pointer"].value,this._readIfd("exif",e)):void 0},e.prototype._readGpsIfd=function(){var e;return null!=this._tags["GPS Info IFD Pointer"]?(e=this._tiffHeaderOffset+this._tags["GPS Info IFD Pointer"].value,this._readIfd("gps",e)):void 0},e.prototype._readInteroperabilityIfd=function(){var e;return null!=this._tags["Interoperability IFD Pointer"]?(e=this._tiffHeaderOffset+this._tags["Interoperability IFD Pointer"].value,this._readIfd("interoperability",e)):void 0},e.prototype._readIfd=function(e,t){var r,n,i,a,o;for(n=this._getShortAt(t),t+=2,o=[],r=a=0;n>=0?n>a:a>n;r=n>=0?++a:--a)i=this._readTag(e,t),void 0!==i&&(this._tags[i.name]={value:i.value,description:i.description}),o.push(t+=12);return o},e.prototype._readTag=function(e,t){var r,n,i,a,o,s,c;return r=this._getShortAt(t),o=this._getShortAt(t+2),n=this._getLongAt(t+4),void 0!==this._typeSizes[o]?(this._typeSizes[o]*n<=4?s=this._getTagValue(t+8,o,n):(c=this._getLongAt(t+8),s=this._getTagValue(this._tiffHeaderOffset+c,o,n)),o===this._tagTypes.ASCII&&(s=this._splitNullSeparatedAsciiString(s)),null!=this._tagNames[e][r]?(null!=this._tagNames[e][r].name&&null!=this._tagNames[e][r].description?(a=this._tagNames[e][r].name,i=this._tagNames[e][r].description(s)):(a=this._tagNames[e][r],i=s instanceof Array?s.join(", "):s),{name:a,value:s,description:i}):{name:"undefined-"+r,value:s,description:s}):void 0},e.prototype._getTagValue=function(e,t,r){var n,i,a;return i=function(){var i,o;for(o=[],a=i=0;r>=0?r>i:i>r;a=r>=0?++i:--i)n=this._getTagValueAt[t](e),e+=this._typeSizes[t],o.push(n);return o}.call(this),1===i.length?i=i[0]:t===this._tagTypes.ASCII&&(i=this._getAsciiValue(i)),i},e.prototype._getAsciiValue=function(e){var t,r;return r=function(){var r,n,i;for(i=[],r=0,n=e.length;n>r;r++)t=e[r],i.push(String.fromCharCode(t));return i}()},e.prototype._getByteAt=function(e){return this._dataView.getUint8(e)},e.prototype._getAsciiAt=function(e){return this._dataView.getUint8(e)},e.prototype._getShortAt=function(e){return this._dataView.getUint16(e,this._littleEndian)},e.prototype._getLongAt=function(e){return this._dataView.getUint32(e,this._littleEndian)},e.prototype._getRationalAt=function(e){return this._getLongAt(e)/this._getLongAt(e+4)},e.prototype._getUndefinedAt=function(e){return this._getByteAt(e)},e.prototype._getSlongAt=function(e){return this._dataView.getInt32(e,this._littleEndian)},e.prototype._getSrationalAt=function(e){return this._getSlongAt(e)/this._getSlongAt(e+4)},e.prototype._splitNullSeparatedAsciiString=function(e){var t,r,n,i,a;for(n=[],r=0,i=0,a=e.length;a>i;i++)t=e[i],"\x00"!==t?(null==n[r]&&(n[r]=""),n[r]+=t):r++;return n},e.prototype._typeSizes={1:1,2:1,3:2,4:4,5:8,7:1,9:4,10:8},e.prototype._tagTypes={BYTE:1,ASCII:2,SHORT:3,LONG:4,RATIONAL:5,UNDEFINED:7,SLONG:9,SRATIONAL:10},e.prototype._tagNames={"0th":{256:"ImageWidth",257:"ImageLength",258:"BitsPerSample",259:"Compression",262:"PhotometricInterpretation",270:"ImageDescription",271:"Make",272:"Model",273:"StripOffsets",274:{name:"Orientation",description:function(e){switch(e){case 1:return"top-left";case 2:return"top-right";case 3:return"bottom-right";case 4:return"bottom-left";case 5:return"left-top";case 6:return"right-top";case 7:return"right-bottom";case 8:return"left-bottom";default:return"Undefined"}}},277:"SamplesPerPixel",278:"RowsPerStrip",279:"StripByteCounts",282:"XResolution",283:"YResolution",284:"PlanarConfiguration",296:{name:"ResolutionUnit",description:function(e){switch(e){case 2:return"inches";case 3:return"centimeters";default:return"Unknown"}}},301:"TransferFunction",305:"Software",306:"DateTime",315:"Artist",318:"WhitePoint",319:"PrimaryChromaticities",513:"JPEGInterchangeFormat",514:"JPEGInterchangeFormatLength",529:"YCbCrCoefficients",530:"YCbCrSubSampling",531:{name:"YCbCrPositioning",description:function(e){switch(e){case 1:return"centered";case 2:return"co-sited";default:return"undefied "+e}}},532:"ReferenceBlackWhite",33432:{name:"Copyright",description:function(e){return e.join("; ")}},34665:"Exif IFD Pointer",34853:"GPS Info IFD Pointer"},exif:{33434:"ExposureTime",33437:"FNumber",34850:{name:"ExposureProgram",description:function(e){switch(e){case 0:return"Undefined";case 1:return"Manual";case 2:return"Normal program";case 3:return"Aperture priority";case 4:return"Shutter priority";case 5:return"Creative program";case 6:return"Action program";case 7:return"Portrait mode";case 8:return"Landscape mode";default:return"Unknown"}}},34852:"SpectralSensitivity",34855:"ISOSpeedRatings",34856:{name:"OECF",description:function(e){return"[Raw OECF table data]"}},36864:{name:"ExifVersion",description:function(e){var t,r,n,i;for(r="",n=0,i=e.length;i>n;n++)t=e[n],r+=String.fromCharCode(t);return r}},36867:"DateTimeOriginal",36868:"DateTimeDigitized",37121:{name:"ComponentsConfiguration",description:function(e){var t,r,n,i;for(r="",n=0,i=e.length;i>n;n++)switch(t=e[n]){case 49:r+="Y";break;case 50:r+="Cb";break;case 51:r+="Cr";break;case 52:r+="R";break;case 53:r+="G";break;case 54:r+="B"}return r}},37122:"CompressedBitsPerPixel",37377:"ShutterSpeedValue",37378:"ApertureValue",37379:"BrightnessValue",37380:"ExposureBiasValue",37381:"MaxApertureValue",37382:"SubjectDistance",37383:{name:"MeteringMode",description:function(e){switch(e){case 1:return"Average";case 2:return"CenterWeightedAverage";case 3:return"Spot";case 4:return"MultiSpot";case 5:return"Pattern";case 6:return"Partial";case 255:return"Other";default:return"Unknown"}}},37384:{name:"LightSource",description:function(e){switch(e){case 1:return"Daylight";case 2:return"Fluorescent";case 3:return"Tungsten (incandescent light)";case 4:return"Flash";case 9:return"Fine weather";case 10:return"Cloudy weather";case 11:return"Shade";case 12:return"Daylight fluorescent (D 5700 – 7100K)";case 13:return"Day white fluorescent (N 4600 – 5400K)";case 14:return"Cool white fluorescent (W 3900 – 4500K)";case 15:return"White fluorescent (WW 3200 – 3700K)";case 17:return"Standard light A";case 18:return"Standard light B";case 19:return"Standard light C";case 20:return"D55";case 21:return"D65";case 22:return"D75";case 23:return"D50";case 24:return"ISO studio tungsten";case 255:return"Other light source";default:return"Unknown"}}},37385:{name:"Flash",description:function(e){switch(e){case 0:return"Flash did not fire";case 1:return"Flash fired";case 5:return"Strobe return light not detected";case 7:return"Strobe return light detected";case 9:return"Flash fired, compulsory flash mode";case 13:return"Flash fired, compulsory flash mode, return light not detected";case 15:return"Flash fired, compulsory flash mode, return light detected";case 16:return"Flash did not fire, compulsory flash mode";case 24:return"Flash did not fire, auto mode";case 25:return"Flash fired, auto mode";case 29:return"Flash fired, auto mode, return light not detected";case 31:return"Flash fired, auto mode, return light detected";case 32:return"No flash function";case 65:return"Flash fired, red-eye reduction mode";case 69:return"Flash fired, red-eye reduction mode, return light not detected";case 71:return"Flash fired, red-eye reduction mode, return light detected";case 73:return"Flash fired, compulsory flash mode, red-eye reduction mode";case 77:return"Flash fired, compulsory flash mode, red-eye reduction mode, return light not detected";case 79:return"Flash fired, compulsory flash mode, red-eye reduction mode, return light detected";case 89:return"Flash fired, auto mode, red-eye reduction mode";case 93:return"Flash fired, auto mode, return light not detected, red-eye reduction mode";case 95:return"Flash fired, auto mode, return light detected, red-eye reduction mode";default:return"Unknown"}}},37386:"FocalLength",37396:{name:"SubjectArea",description:function(e){switch(e.length){case 2:return"Location; X: "+e[0]+", Y: "+e[1];case 3:return"Circle; X: "+e[0]+", Y: "+e[1]+", diameter: "+e[2];case 4:return"Rectangle; X: "+e[0]+", Y: "+e[1]+", width: "+e[2]+", height: "+e[3];default:return"Unknown"}}},37500:{name:"MakerNote",description:function(e){return"[Raw maker note data]"}},37510:{name:"UserComment",description:function(e){switch(e.slice(0,8).map(function(e){return String.fromCharCode(e)}).join("")){case"ASCII\x00\x00\x00":return e.slice(8,e.length).map(function(e){return String.fromCharCode(e)}).join("");case"JIS\x00\x00\x00\x00\x00":return"[JIS encoded text]";case"UNICODE\x00":return"[Unicode encoded text]";case"\x00\x00\x00\x00\x00\x00\x00\x00":return"[Undefined encoding]"}}},37520:"SubSecTime",37521:"SubSecTimeOriginal",37522:"SubSecTimeDigitized",40960:{name:"FlashpixVersion",description:function(e){var t,r,n,i;for(r="",n=0,i=e.length;i>n;n++)t=e[n],r+=String.fromCharCode(t);return r}},40961:{name:"ColorSpace",description:function(e){switch(e){case 1:return"sRGB";case 65535:return"Uncalibrated";default:return"Unknown"}}},40962:"PixelXDimension",40963:"PixelYDimension",40964:"RelatedSoundFile",40965:"Interoperability IFD Pointer",41483:"FlashEnergy",41484:{name:"SpatialFrequencyResponse",description:function(e){return"[Raw SFR table data]"}},41486:"FocalPlaneXResolution",41487:"FocalPlaneYResolution",41488:{name:"FocalPlaneResolutionUnit",description:function(e){switch(e){case 2:return"inches";case 3:return"centimeters";default:return"Unknown"}}},41492:{name:"SubjectLocation",description:function(e){return"X: "+e[0]+", Y: "+e[1]}},41493:"ExposureIndex",41495:{name:"SensingMethod",description:function(e){switch(e){case 1:return"Undefined";case 2:return"One-chip color area sensor";case 3:return"Two-chip color area sensor";case 4:return"Three-chip color area sensor";case 5:return"Color sequential area sensor";case 7:return"Trilinear sensor";case 8:return"Color sequential linear sensor";default:return"Unknown"}}},41728:{name:"FileSource",description:function(e){switch(e){case 3:return"DSC";default:return"Unknown"}}},41729:{name:"SceneType",description:function(e){switch(e){case 1:return"A directly photographed image";default:return"Unknown"}}},41730:{name:"CFAPattern",description:function(e){return"[Raw CFA pattern table data]"}},41985:{name:"CustomRendered",description:function(e){switch(e){case 0:return"Normal process";case 1:return"Custom process";default:return"Unknown"}}},41986:{name:"ExposureMode",description:function(e){switch(e){case 0:return"Auto exposure";case 1:return"Manual exposure";case 2:return"Auto bracket";default:return"Unknown"}}},41987:{name:"WhiteBalance",description:function(e){switch(e){case 0:return"Auto white balance";case 1:return"Manual white balance";default:return"Unknown"}}},41988:{name:"DigitalZoomRatio",description:function(e){switch(e){case 0:return"Digital zoom was not used";default:return e}}},41989:{name:"FocalLengthIn35mmFilm",description:function(e){switch(e){case 0:return"Unknown";default:return e}}},41990:{name:"SceneCaptureType",description:function(e){switch(e){case 0:return"Standard";case 1:return"Landscape";case 2:return"Portrait";case 3:return"Night scene";default:return"Unknown"}}},41991:{name:"GainControl",description:function(e){switch(e){case 0:return"None";case 1:return"Low gain up";case 2:return"High gain up";case 3:return"Low gain down";case 4:return"High gain down";default:return"Unknown"}}},41992:{name:"Contrast",description:function(e){switch(e){case 0:return"Normal";case 1:return"Soft";case 2:return"Hard";default:return"Unknown"}}},41993:{name:"Saturation",description:function(e){switch(e){case 0:return"Normal";case 1:return"Low saturation";case 2:return"High saturation";default:return"Unknown"}}},41994:{name:"Sharpness",description:function(e){switch(e){case 0:return"Normal";case 1:return"Soft";case 2:return"Hard";default:return"Unknown"}}},41995:{name:"DeviceSettingDescription",description:function(e){return"[Raw device settings table data]"}},41996:{name:"SubjectDistanceRange",description:function(e){switch(e){case 1:return"Macro";case 2:return"Close view";case 3:return"Distant view";default:return"Unknown"}}},42016:"ImageUniqueID"},gps:{0:{name:"GPSVersionID",description:function(e){var t,r;return e[0]===(t=e[1])&&2===t&&e[2]===(r=e[3])&&0===r?"Version 2.2":"Unknown"}},1:{name:"GPSLatitudeRef",description:function(e){switch(e.join("")){case"N":return"North latitude";case"S":return"South latitude";default:return"Unknown"}}},2:{name:"GPSLatitude",description:function(e){return e[0]+e[1]/60+e[2]/3600}},3:{name:"GPSLongitudeRef",description:function(e){switch(e.join("")){case"E":return"East longitude";case"W":return"West longitude";default:return"Unknown"}}},4:{name:"GPSLongitude",description:function(e){return e[0]+e[1]/60+e[2]/3600}},5:{name:"GPSAltitudeRef",description:function(e){switch(e){case 0:return"Sea level";case 1:return"Sea level reference (negative value)";default:return"Unknown"}}},6:{name:"GPSAltitude",description:function(e){return e+" m"}},7:{name:"GPSTimeStamp",description:function(e){var t;return t=function(e){var t;return function(){var r,n,i;for(i=[],t=r=0,n=2-(""+Math.floor(e)).length;n>=0?n>r:r>n;t=n>=0?++r:--r)i.push("0");return i}()+e},e.map(t).join(":")}},8:"GPSSatellites",9:{name:"GPSStatus",description:function(e){switch(e.join("")){case"A":return"Measurement in progress";case"V":return"Measurement Interoperability";default:return"Unknown"}}},10:{name:"GPSMeasureMode",description:function(e){switch(e.join("")){case"2":return"2-dimensional measurement";case"3":return"3-dimensional measurement";default:return"Unknown"}}},11:"GPSDOP",12:{name:"GPSSpeedRef",description:function(e){switch(e.join("")){case"K":return"Kilometers per hour";case"M":return"Miles per hour";case"N":return"Knots";default:return"Unknown"}}},13:"GPSSpeed",14:{name:"GPSTrackRef",description:function(e){switch(e.join("")){case"T":return"True direction";case"M":return"Magnetic direction";default:return"Unknown"}}},15:"GPSTrack",16:{name:"GPSImgDirectionRef",description:function(e){switch(e.join("")){case"T":return"True direction";case"M":return"Magnetic direction";default:return"Unknown"}}},17:"GPSImgDirection",18:"GPSMapDatum",19:{name:"GPSDestLatitudeRef",description:function(e){switch(e.join("")){case"N":return"North latitude";case"S":return"South latitude";default:return"Unknown"}}},20:{name:"GPSDestLatitude",description:function(e){return e[0]+e[1]/60+e[2]/3600}},21:{name:"GPSDestLongitudeRef",description:function(e){switch(e.join("")){case"E":return"East longitude";case"W":return"West longitude";default:return"Unknown"}}},22:{name:"GPSDestLongitude",description:function(e){return e[0]+e[1]/60+e[2]/3600}},23:{name:"GPSDestBearingRef",description:function(e){switch(e.join("")){case"T":return"True direction";case"M":return"Magnetic direction";default:return"Unknown"}}},24:"GPSDestBearing",25:{name:"GPSDestDistanceRef",description:function(e){switch(e.join("")){case"K":return"Kilometers";case"M":return"Miles";case"N":return"Knots";default:return"Unknown"}}},26:"GPSDestDistance",27:{name:"GPSProcessingMethod",description:function(e){if(0===e)return"Undefined";switch(e.slice(0,8).map(function(e){return String.fromCharCode(e)}).join("")){case"ASCII\x00\x00\x00":return e.slice(8,e.length).map(function(e){return String.fromCharCode(e)}).join("");case"JIS\x00\x00\x00\x00\x00":return"[JIS encoded text]";case"UNICODE\x00":return"[Unicode encoded text]";case"\x00\x00\x00\x00\x00\x00\x00\x00":return"[Undefined encoding]"}}},28:{name:"GPSAreaInformation",description:function(e){if(0===e)return"Undefined";switch(e.slice(0,8).map(function(e){return String.fromCharCode(e)}).join("")){case"ASCII\x00\x00\x00":return e.slice(8,e.length).map(function(e){return String.fromCharCode(e)}).join("");case"JIS\x00\x00\x00\x00\x00":return"[JIS encoded text]";case"UNICODE\x00":return"[Unicode encoded text]";case"\x00\x00\x00\x00\x00\x00\x00\x00":return"[Undefined encoding]"}}},29:"GPSDateStamp",30:{name:"GPSDifferential",description:function(e){switch(e){case 0:return"Measurement without differential correction";case 1:return"Differential correction applied";default:return"Unknown"}}}},interoperability:{1:"InteroperabilityIndex",2:"UnknownInteroperabilityTag0x0002",4097:"UnknownInteroperabilityTag0x1001",4098:"UnknownInteroperabilityTag0x1002"}},e.prototype.getTagValue=function(e){return null!=this._tags[e]?this._tags[e].value:void 0},e.prototype.getTagDescription=function(e){return null!=this._tags[e]?this._tags[e].description:void 0},e.prototype.getAllTags=function(){return this._tags},e.prototype.deleteTag=function(e){return delete this._tags[e]},e}()}).call(this)},{}],3:[function(e,t,r){function n(e){function t(e){for(var t=[16,11,10,16,24,40,51,61,12,12,14,19,26,58,60,55,14,13,16,24,40,57,69,56,14,17,22,29,51,87,80,62,18,22,37,56,68,109,103,77,24,35,55,64,81,104,113,92,49,64,78,87,103,121,120,101,72,92,95,98,112,100,103,99],r=0;64>r;r++){var n=E((t[r]*e+50)/100);1>n?n=1:n>255&&(n=255),S[j[r]]=n}for(var i=[17,18,24,47,99,99,99,99,18,21,26,66,99,99,99,99,24,26,56,99,99,99,99,99,47,66,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99],a=0;64>a;a++){var o=E((i[a]*e+50)/100);1>o?o=1:o>255&&(o=255),A[j[a]]=o}for(var s=[1,1.387039845,1.306562965,1.175875602,1,.785694958,.5411961,.275899379],c=0,u=0;8>u;u++)for(var f=0;8>f;f++)I[c]=1/(S[j[c]]*s[u]*s[f]*8),R[c]=1/(A[j[c]]*s[u]*s[f]*8),c++}function r(e,t){for(var r=0,n=0,i=new Array,a=1;16>=a;a++){for(var o=1;o<=e[a];o++)i[t[n]]=[],i[t[n]][0]=r,i[t[n]][1]=a,n++,r++;r*=2}return i}function n(){b=r(Z,q),w=r(Y,W),y=r(G,H),x=r(X,J)}function i(){for(var e=1,t=2,r=1;15>=r;r++){for(var n=e;t>n;n++)T[32767+n]=r,P[32767+n]=[],P[32767+n][1]=r,P[32767+n][0]=n;for(var i=-(t-1);-e>=i;i++)T[32767+i]=r,P[32767+i]=[],P[32767+i][1]=r,P[32767+i][0]=t-1+i;e<<=1,t<<=1}}function a(){for(var e=0;256>e;e++)N[e]=19595*e,N[e+256>>0]=38470*e,N[e+512>>0]=7471*e+32768,N[e+768>>0]=-11059*e,N[e+1024>>0]=-21709*e,N[e+1280>>0]=32768*e+8421375,N[e+1536>>0]=-27439*e,N[e+1792>>0]=-5329*e}function o(e){for(var t=e[0],r=e[1]-1;r>=0;)t&1<<r&&(O|=1<<D),r--,D--,0>D&&(255==O?(s(255),s(0)):s(O),D=7,O=0)}function s(e){C.push(e)}function c(e){s(e>>8&255),s(255&e)}function u(e,t){var r,n,i,a,o,s,c,u,f,l=0,h=8,d=64;for(f=0;h>f;++f){r=e[l],n=e[l+1],i=e[l+2],a=e[l+3],o=e[l+4],s=e[l+5],c=e[l+6],u=e[l+7];var p=r+u,g=r-u,m=n+c,v=n-c,_=i+s,b=i-s,w=a+o,y=a-o,x=p+w,k=p-w,E=m+_,S=m-_;e[l]=x+E,e[l+4]=x-E;var A=.707106781*(S+k);e[l+2]=k+A,e[l+6]=k-A,x=y+b,E=b+v,S=v+g;var I=.382683433*(x-S),R=.5411961*x+I,P=1.306562965*S+I,T=.707106781*E,L=g+T,C=g-T;e[l+5]=C+R,e[l+3]=C-R,e[l+1]=L+P,e[l+7]=L-P,l+=8}for(l=0,f=0;h>f;++f){r=e[l],n=e[l+8],i=e[l+16],a=e[l+24],o=e[l+32],s=e[l+40],c=e[l+48],u=e[l+56];var O=r+u,D=r-u,U=n+c,z=n-c,B=i+s,F=i-s,N=a+o,j=a-o,Z=O+N,q=O-N,G=U+B,H=U-B;e[l]=Z+G,e[l+32]=Z-G;var Y=.707106781*(H+q);e[l+16]=q+Y,e[l+48]=q-Y,Z=j+F,G=F+z,H=z+D;var W=.382683433*(Z-H),X=.5411961*Z+W,J=1.306562965*H+W,V=.707106781*G,K=D+V,Q=D-V;e[l+40]=Q+X,e[l+24]=Q-X,e[l+8]=K+J,e[l+56]=K-J,l++}var $;for(f=0;d>f;++f)$=e[f]*t[f],M[f]=$>0?$+.5|0:$-.5|0;return M}function f(){c(65504),c(16),s(74),s(70),s(73),s(70),s(0),s(1),s(1),s(0),c(1),c(1),s(0),s(0)}function l(e,t){c(65472),c(17),s(8),c(t),c(e),s(3),s(1),s(17),s(0),s(2),s(17),s(1),s(3),s(17),s(1)}function h(){c(65499),c(132),s(0);for(var e=0;64>e;e++)s(S[e]);s(1);for(var t=0;64>t;t++)s(A[t])}function d(){c(65476),c(418),s(0);for(var e=0;16>e;e++)s(Z[e+1]);for(var t=0;11>=t;t++)s(q[t]);s(16);for(var r=0;16>r;r++)s(G[r+1]);for(var n=0;161>=n;n++)s(H[n]);s(1);for(var i=0;16>i;i++)s(Y[i+1]);for(var a=0;11>=a;a++)s(W[a]);s(17);for(var o=0;16>o;o++)s(X[o+1]);for(var u=0;161>=u;u++)s(J[u])}function p(){c(65498),c(12),s(3),s(1),s(0),s(2),s(17),s(3),s(17),s(0),s(63),s(0)}function g(e,t,r,n,i){for(var a,s=i[0],c=i[240],f=16,l=63,h=64,d=u(e,t),p=0;h>p;++p)L[j[p]]=d[p];var g=L[0]-r;r=L[0],0==g?o(n[0]):(a=32767+g,o(n[T[a]]),o(P[a]));for(var m=63;m>0&&0==L[m];m--);if(0==m)return o(s),r;for(var v,_=1;m>=_;){for(var b=_;0==L[_]&&m>=_;++_);var w=_-b;if(w>=f){v=w>>4;for(var y=1;v>=y;++y)o(c);w=15&w}a=32767+L[_],o(i[(w<<4)+T[a]]),o(P[a]),_++}return m!=l&&o(s),r}function m(){for(var e=String.fromCharCode,t=0;256>t;t++)F[t]=e(t)}function v(e){if(0>=e&&(e=1),e>100&&(e=100),k!=e){var r=0;r=50>e?Math.floor(5e3/e):Math.floor(200-2*e),t(r),k=e}}function _(){var t=(new Date).getTime();e||(e=50),m(),n(),i(),a(),v(e);(new Date).getTime()-t}var b,w,y,x,k,E=(Math.round,Math.floor),S=new Array(64),A=new Array(64),I=new Array(64),R=new Array(64),P=new Array(65535),T=new Array(65535),M=new Array(64),L=new Array(64),C=[],O=0,D=7,U=new Array(64),z=new Array(64),B=new Array(64),F=new Array(256),N=new Array(2048),j=[0,1,5,6,14,15,27,28,2,4,7,13,16,26,29,42,3,8,12,17,25,30,41,43,9,11,18,24,31,40,44,53,10,19,23,32,39,45,52,54,20,22,33,38,46,51,55,60,21,34,37,47,50,56,59,61,35,36,48,49,57,58,62,63],Z=[0,0,1,5,1,1,1,1,1,1,0,0,0,0,0,0,0],q=[0,1,2,3,4,5,6,7,8,9,10,11],G=[0,0,2,1,3,3,2,4,3,5,5,4,4,0,0,1,125],H=[1,2,3,0,4,17,5,18,33,49,65,6,19,81,97,7,34,113,20,50,129,145,161,8,35,66,177,193,21,82,209,240,36,51,98,114,130,9,10,22,23,24,25,26,37,38,39,40,41,42,52,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,225,226,227,228,229,230,231,232,233,234,241,242,243,244,245,246,247,248,249,250],Y=[0,0,3,1,1,1,1,1,1,1,1,1,0,0,0,0,0],W=[0,1,2,3,4,5,6,7,8,9,10,11],X=[0,0,2,1,2,4,4,3,4,7,5,4,4,0,1,2,119],J=[0,1,2,3,17,4,5,33,49,6,18,65,81,7,97,113,19,34,50,129,8,20,66,145,161,177,193,9,35,51,82,240,21,98,114,209,10,22,36,52,225,37,241,23,24,25,26,38,39,40,41,42,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,130,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,226,227,228,229,230,231,232,233,234,242,243,244,245,246,247,248,249,250];this.encode=function(e,t){(new Date).getTime();t&&v(t),C=new Array,O=0,D=7,c(65496),f(),h(),l(e.width,e.height),d(),p();var r=0,n=0,i=0;O=0,D=7,this.encode.displayName="_encode_";for(var a,s,u,m,_,k,E,S,A,P=e.data,T=e.width,M=e.height,L=4*T,F=0;M>F;){for(a=0;L>a;){for(_=L*F+a,k=_,E=-1,S=0,A=0;64>A;A++)S=A>>3,E=4*(7&A),k=_+S*L+E,F+S>=M&&(k-=L*(F+1+S-M)),a+E>=L&&(k-=a+E-L+4),s=P[k++],u=P[k++],m=P[k++],U[A]=(N[s]+N[u+256>>0]+N[m+512>>0]>>16)-128,z[A]=(N[s+768>>0]+N[u+1024>>0]+N[m+1280>>0]>>16)-128,B[A]=(N[s+1280>>0]+N[u+1536>>0]+N[m+1792>>0]>>16)-128;r=g(U,I,r,b,y),n=g(z,R,n,w,x),i=g(B,R,i,w,x),a+=32}F+=8}if(D>=0){var j=[];j[1]=D+1,j[0]=(1<<D+1)-1,o(j)}return c(65497),new Uint8Array(C)},_()}function i(e,t){"undefined"==typeof t&&(t=50);var r=new n(t),i=r.encode(e,t);return{data:i,width:e.width,height:e.height}}t.exports=i},{}],4:[function(e,t,r){function n(e,t){if(0===e.indexOf("data:")){for(var r=e.indexOf("base64,")+7,n=atob(e.substring(r)),i=new Uint8Array(n.length),a=n.length-1;a>=0;a--)i[a]=n.charCodeAt(a);return void t(i.buffer)}var o=new XMLHttpRequest;o.open("GET",e,!0),o.responseType="arraybuffer",o.onload=function(){t(o.response)},o.send(null)}var i=function(){function e(){this._src=null,this._parser=new a.JpegImage,this.onload=null}return e.prototype={get src(){return this._src},set src(e){this.load(e)},get width(){return this._parser.width},get height(){return this._parser.height},load:function(e){this._src=e,n(e,function(e){this.parse(new Uint8Array(e)),this.onload&&this.onload()}.bind(this))},parse:function(e){this._parser.parse(e)},getData:function(e,t){return this._parser.getData(e,t,!1)},copyToImageData:function(e){if(2===this._parser.numComponents||this._parser.numComponents>4)throw new Error("Unsupported amount of components");var t,r,n=e.width,i=e.height,a=n*i*4,o=e.data;if(1!==this._parser.numComponents){var s=this._parser.getData(n,i,!0);for(t=0,r=0;a>t;)o[t++]=s[r++],o[t++]=s[r++],o[t++]=s[r++],o[t++]=255}else{var c=this._parser.getData(n,i,!1);for(t=0,r=0;a>t;){var u=c[r++];o[t++]=u,o[t++]=u,o[t++]=u,o[t++]=255}}}},e}();t.exports={JpegImage:i,JpegDecoder:o,JpxDecoder:s,Jbig2Decoder:c};var a;!function(e){"use strict";function t(e){for(var t=1,r=0;e>t;)t<<=1,r++;return r}function r(e,t){return e[t]<<24>>24}function n(e,t){return e[t]<<8|e[t+1]}function i(e,t){return(e[t]<<24|e[t+1]<<16|e[t+2]<<8|e[t+3])>>>0}function a(e,t,r){return Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!1}),r}var o=function(){function e(){}function t(e,t){for(var r,n,i=0,a=[],o=16;o>0&&!e[o-1];)o--;a.push({children:[],index:0});var s,c=a[0];for(r=0;o>r;r++){for(n=0;n<e[r];n++){for(c=a.pop(),c.children[c.index]=t[i];c.index>0;)c=a.pop();for(c.index++,a.push(c);a.length<=r;)a.push(s={children:[],index:0}),c.children[c.index]=s.children,c=s;i++}o>r+1&&(a.push(s={children:[],index:0}),c.children[c.index]=s.children,c=s)}return a[0].children}function r(e,t,r){return 64*((e.blocksPerLine+1)*t+r)}function n(e,t,n,i,a,o,c,u,f){function l(){if(C>0)return C--,L>>C&1;if(L=e[t++],255===L){var r=e[t++];if(r)throw"unexpected marker: "+(L<<8|r).toString(16)}return C=7,L>>>7}function h(e){for(var t=e;;){if(t=t[l()],"number"==typeof t)return t;if("object"!=typeof t)throw"invalid huffman sequence"}}function d(e){for(var t=0;e>0;)t=t<<1|l(),e--;return t}function p(e){if(1===e)return 1===l()?1:-1;var t=d(e);return t>=1<<e-1?t:t+(-1<<e)+1}function g(e,t){var r=h(e.huffmanTableDC),n=0===r?0:p(r);e.blockData[t]=e.pred+=n;for(var i=1;64>i;){var a=h(e.huffmanTableAC),o=15&a,c=a>>4;if(0!==o){i+=c;var u=s[i];e.blockData[t+u]=p(o),i++}else{if(15>c)break;i+=16}}}function m(e,t){var r=h(e.huffmanTableDC),n=0===r?0:p(r)<<f;e.blockData[t]=e.pred+=n}function v(e,t){e.blockData[t]|=l()<<f}function _(e,t){if(O>0)return void O--;for(var r=o,n=c;n>=r;){var i=h(e.huffmanTableAC),a=15&i,u=i>>4;if(0!==a){r+=u;var l=s[r];e.blockData[t+l]=p(a)*(1<<f),r++}else{if(15>u){O=d(u)+(1<<u)-1;break}r+=16}}}function b(e,t){for(var r,n,i=o,a=c,u=0;a>=i;){var g=s[i];switch(D){case 0:if(n=h(e.huffmanTableAC),r=15&n,u=n>>4,0===r)15>u?(O=d(u)+(1<<u),D=4):(u=16,D=1);else{if(1!==r)throw"invalid ACn encoding";x=p(r),D=u?2:3}continue;case 1:case 2:e.blockData[t+g]?e.blockData[t+g]+=l()<<f:(u--,0===u&&(D=2===D?3:0));break;case 3:e.blockData[t+g]?e.blockData[t+g]+=l()<<f:(e.blockData[t+g]=x<<f,D=0);break;case 4:e.blockData[t+g]&&(e.blockData[t+g]+=l()<<f)}i++}4===D&&(O--,0===O&&(D=0))}function w(e,t,n,i,a){var o=n/P|0,s=n%P,c=o*e.v+i,u=s*e.h+a,f=r(e,c,u);t(e,f)}function y(e,t,n){
var i=n/e.blocksPerLine|0,a=n%e.blocksPerLine,o=r(e,i,a);t(e,o)}var x,k,E,S,A,I,R,P=(n.precision,n.samplesPerLine,n.scanLines,n.mcusPerLine),T=n.progressive,M=(n.maxH,n.maxV,t),L=0,C=0,O=0,D=0,U=i.length;R=T?0===o?0===u?m:v:0===u?_:b:g;var z,B,F=0;B=1===U?i[0].blocksPerLine*i[0].blocksPerColumn:P*n.mcusPerColumn,a||(a=B);for(var N,j;B>F;){for(E=0;U>E;E++)i[E].pred=0;if(O=0,1===U)for(k=i[0],I=0;a>I;I++)y(k,R,F),F++;else for(I=0;a>I;I++){for(E=0;U>E;E++)for(k=i[E],N=k.h,j=k.v,S=0;j>S;S++)for(A=0;N>A;A++)w(k,R,F,S,A);F++}if(C=0,z=e[t]<<8|e[t+1],65280>=z)throw"marker was not found";if(!(z>=65488&&65495>=z))break;t+=2}return t-M}function i(e,t,r){for(var n,i,a,o,s,m,v,_,b,w,y,x,k,E,S,A,I,R=e.quantizationTable,P=e.blockData,T=0;64>T;T+=8)b=P[t+T],w=P[t+T+1],y=P[t+T+2],x=P[t+T+3],k=P[t+T+4],E=P[t+T+5],S=P[t+T+6],A=P[t+T+7],b*=R[T],0!==(w|y|x|k|E|S|A)?(w*=R[T+1],y*=R[T+2],x*=R[T+3],k*=R[T+4],E*=R[T+5],S*=R[T+6],A*=R[T+7],n=p*b+128>>8,i=p*k+128>>8,a=y,o=S,s=g*(w-A)+128>>8,_=g*(w+A)+128>>8,m=x<<4,v=E<<4,n=n+i+1>>1,i=n-i,I=a*d+o*h+128>>8,a=a*h-o*d+128>>8,o=I,s=s+v+1>>1,v=s-v,_=_+m+1>>1,m=_-m,n=n+o+1>>1,o=n-o,i=i+a+1>>1,a=i-a,I=s*l+_*f+2048>>12,s=s*f-_*l+2048>>12,_=I,I=m*u+v*c+2048>>12,m=m*c-v*u+2048>>12,v=I,r[T]=n+_,r[T+7]=n-_,r[T+1]=i+v,r[T+6]=i-v,r[T+2]=a+m,r[T+5]=a-m,r[T+3]=o+s,r[T+4]=o-s):(I=p*b+512>>10,r[T]=I,r[T+1]=I,r[T+2]=I,r[T+3]=I,r[T+4]=I,r[T+5]=I,r[T+6]=I,r[T+7]=I);for(var M=0;8>M;++M)b=r[M],w=r[M+8],y=r[M+16],x=r[M+24],k=r[M+32],E=r[M+40],S=r[M+48],A=r[M+56],0!==(w|y|x|k|E|S|A)?(n=p*b+2048>>12,i=p*k+2048>>12,a=y,o=S,s=g*(w-A)+2048>>12,_=g*(w+A)+2048>>12,m=x,v=E,n=(n+i+1>>1)+4112,i=n-i,I=a*d+o*h+2048>>12,a=a*h-o*d+2048>>12,o=I,s=s+v+1>>1,v=s-v,_=_+m+1>>1,m=_-m,n=n+o+1>>1,o=n-o,i=i+a+1>>1,a=i-a,I=s*l+_*f+2048>>12,s=s*f-_*l+2048>>12,_=I,I=m*u+v*c+2048>>12,m=m*c-v*u+2048>>12,v=I,b=n+_,A=n-_,w=i+v,S=i-v,y=a+m,E=a-m,x=o+s,k=o-s,b=16>b?0:b>=4080?255:b>>4,w=16>w?0:w>=4080?255:w>>4,y=16>y?0:y>=4080?255:y>>4,x=16>x?0:x>=4080?255:x>>4,k=16>k?0:k>=4080?255:k>>4,E=16>E?0:E>=4080?255:E>>4,S=16>S?0:S>=4080?255:S>>4,A=16>A?0:A>=4080?255:A>>4,P[t+M]=b,P[t+M+8]=w,P[t+M+16]=y,P[t+M+24]=x,P[t+M+32]=k,P[t+M+40]=E,P[t+M+48]=S,P[t+M+56]=A):(I=p*b+8192>>14,I=-2040>I?0:I>=2024?255:I+2056>>4,P[t+M]=I,P[t+M+8]=I,P[t+M+16]=I,P[t+M+24]=I,P[t+M+32]=I,P[t+M+40]=I,P[t+M+48]=I,P[t+M+56]=I)}function a(e,t){for(var n=t.blocksPerLine,a=t.blocksPerColumn,o=new Int16Array(64),s=0;a>s;s++)for(var c=0;n>c;c++){var u=r(t,s,c);i(t,u,o)}return t.blockData}function o(e){return 0>=e?0:e>=255?255:e}var s=new Uint8Array([0,1,8,16,9,2,3,10,17,24,32,25,18,11,4,5,12,19,26,33,40,48,41,34,27,20,13,6,7,14,21,28,35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51,58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63]),c=4017,u=799,f=3406,l=2276,h=1567,d=3784,p=5793,g=2896;return e.prototype={parse:function(e){function r(){var t=e[f]<<8|e[f+1];return f+=2,t}function i(){var t=r(),n=e.subarray(f,f+t-2);return f+=n.length,n}function o(e){for(var t=Math.ceil(e.samplesPerLine/8/e.maxH),r=Math.ceil(e.scanLines/8/e.maxV),n=0;n<e.components.length;n++){B=e.components[n];var i=Math.ceil(Math.ceil(e.samplesPerLine/8)*B.h/e.maxH),a=Math.ceil(Math.ceil(e.scanLines/8)*B.v/e.maxV),o=t*B.h,s=r*B.v,c=64*s*(o+1);B.blockData=new Int16Array(c),B.blocksPerLine=i,B.blocksPerColumn=a}e.mcusPerLine=t,e.mcusPerColumn=r}var c,u,f=0,l=(e.length,null),h=null,d=[],p=[],g=[],m=r();if(65496!==m)throw"SOI not found";for(m=r();65497!==m;){var v,_,b;switch(m){case 65504:case 65505:case 65506:case 65507:case 65508:case 65509:case 65510:case 65511:case 65512:case 65513:case 65514:case 65515:case 65516:case 65517:case 65518:case 65519:case 65534:var w=i();65504===m&&74===w[0]&&70===w[1]&&73===w[2]&&70===w[3]&&0===w[4]&&(l={version:{major:w[5],minor:w[6]},densityUnits:w[7],xDensity:w[8]<<8|w[9],yDensity:w[10]<<8|w[11],thumbWidth:w[12],thumbHeight:w[13],thumbData:w.subarray(14,14+3*w[12]*w[13])}),65518===m&&65===w[0]&&100===w[1]&&111===w[2]&&98===w[3]&&101===w[4]&&(h={version:w[5]<<8|w[6],flags0:w[7]<<8|w[8],flags1:w[9]<<8|w[10],transformCode:w[11]});break;case 65499:for(var y,x=r(),k=x+f-2;k>f;){var E=e[f++],S=new Uint16Array(64);if(E>>4===0)for(_=0;64>_;_++)y=s[_],S[y]=e[f++];else{if(E>>4!==1)throw"DQT: invalid table spec";for(_=0;64>_;_++)y=s[_],S[y]=r()}d[15&E]=S}break;case 65472:case 65473:case 65474:if(c)throw"Only single frame JPEGs supported";r(),c={},c.extended=65473===m,c.progressive=65474===m,c.precision=e[f++],c.scanLines=r(),c.samplesPerLine=r(),c.components=[],c.componentIds={};var A,I=e[f++],R=0,P=0;for(v=0;I>v;v++){A=e[f];var T=e[f+1]>>4,M=15&e[f+1];T>R&&(R=T),M>P&&(P=M);var L=e[f+2];b=c.components.push({h:T,v:M,quantizationTable:d[L]}),c.componentIds[A]=b-1,f+=3}c.maxH=R,c.maxV=P,o(c);break;case 65476:var C=r();for(v=2;C>v;){var O=e[f++],D=new Uint8Array(16),U=0;for(_=0;16>_;_++,f++)U+=D[_]=e[f];var z=new Uint8Array(U);for(_=0;U>_;_++,f++)z[_]=e[f];v+=17+U,(O>>4===0?g:p)[15&O]=t(D,z)}break;case 65501:r(),u=r();break;case 65498:var B,F=(r(),e[f++]),N=[];for(v=0;F>v;v++){var j=c.componentIds[e[f++]];B=c.components[j];var Z=e[f++];B.huffmanTableDC=g[Z>>4],B.huffmanTableAC=p[15&Z],N.push(B)}var q=e[f++],G=e[f++],H=e[f++],Y=n(e,f,c,N,u,q,G,H>>4,15&H);f+=Y;break;case 65535:255!==e[f]&&f--;break;default:if(255===e[f-3]&&e[f-2]>=192&&e[f-2]<=254){f-=3;break}throw"unknown JPEG marker "+m.toString(16)}m=r()}for(this.width=c.samplesPerLine,this.height=c.scanLines,this.jfif=l,this.adobe=h,this.components=[],v=0;v<c.components.length;v++)B=c.components[v],this.components.push({output:a(c,B),scaleX:B.h/c.maxH,scaleY:B.v/c.maxV,blocksPerLine:B.blocksPerLine,blocksPerColumn:B.blocksPerColumn});this.numComponents=this.components.length},_getLinearizedBlockData:function(e,t){var r,n,i,a,o,s,c,u,f,l,h,d=this.width/e,p=this.height/t,g=0,m=this.components.length,v=e*t*m,_=new Uint8Array(v),b=new Uint32Array(e),w=4294967288;for(c=0;m>c;c++){for(r=this.components[c],n=r.scaleX*d,i=r.scaleY*p,g=c,h=r.output,a=r.blocksPerLine+1<<3,o=0;e>o;o++)u=0|o*n,b[o]=(u&w)<<3|7&u;for(s=0;t>s;s++)for(u=0|s*i,l=a*(u&w)|(7&u)<<3,o=0;e>o;o++)_[g]=h[l+b[o]],g+=m}var y=this.decodeTransform;if(y)for(c=0;v>c;)for(u=0,f=0;m>u;u++,c++,f+=2)_[c]=(_[c]*y[f]>>8)+y[f+1];return _},_isColorConversionNeeded:function(){return this.adobe&&this.adobe.transformCode?!0:3===this.numComponents},_convertYccToRgb:function(e){for(var t,r,n,i=0,a=e.length;a>i;i+=3)t=e[i],r=e[i+1],n=e[i+2],e[i]=o(t-179.456+1.402*n),e[i+1]=o(t+135.459-.344*r-.714*n),e[i+2]=o(t-226.816+1.772*r);return e},_convertYcckToRgb:function(e){for(var t,r,n,i,a=0,s=0,c=e.length;c>s;s+=4){t=e[s],r=e[s+1],n=e[s+2],i=e[s+3];var u=-122.67195406894+r*(-660635669420364e-19*r+.000437130475926232*n-54080610064599e-18*t+.00048449797120281*i-.154362151871126)+n*(-.000957964378445773*n+.000817076911346625*t-.00477271405408747*i+1.53380253221734)+t*(.000961250184130688*t-.00266257332283933*i+.48357088451265)+i*(-.000336197177618394*i+.484791561490776),f=107.268039397724+r*(219927104525741e-19*r-.000640992018297945*n+.000659397001245577*t+.000426105652938837*i-.176491792462875)+n*(-.000778269941513683*n+.00130872261408275*t+.000770482631801132*i-.151051492775562)+t*(.00126935368114843*t-.00265090189010898*i+.25802910206845)+i*(-.000318913117588328*i-.213742400323665),l=-20.810012546947+r*(-.000570115196973677*r-263409051004589e-19*n+.0020741088115012*t-.00288260236853442*i+.814272968359295)+n*(-153496057440975e-19*n-.000132689043961446*t+.000560833691242812*i-.195152027534049)+t*(.00174418132927582*t-.00255243321439347*i+.116935020465145)+i*(-.000343531996510555*i+.24165260232407);e[a++]=o(u),e[a++]=o(f),e[a++]=o(l)}return e},_convertYcckToCmyk:function(e){for(var t,r,n,i=0,a=e.length;a>i;i+=4)t=e[i],r=e[i+1],n=e[i+2],e[i]=o(434.456-t-1.402*n),e[i+1]=o(119.541-t+.344*r+.714*n),e[i+2]=o(481.816-t-1.772*r);return e},_convertCmykToRgb:function(e){for(var t,r,n,i,a=0,o=-16581375,s=1/255/255,c=0,u=e.length;u>c;c+=4){t=e[c],r=e[c+1],n=e[c+2],i=e[c+3];var f=t*(-4.387332384609988*t+54.48615194189176*r+18.82290502165302*n+212.25662451639585*i-72734.4411664936)+r*(1.7149763477362134*r-5.6096736904047315*n-17.873870861415444*i-1401.7366389350734)+n*(-2.5217340131683033*n-21.248923337353073*i+4465.541406466231)-i*(21.86122147463605*i+48317.86113160301),l=t*(8.841041422036149*t+60.118027045597366*r+6.871425592049007*n+31.159100130055922*i-20220.756542821975)+r*(-15.310361306967817*r+17.575251261109482*n+131.35250912493976*i-48691.05921601825)+n*(4.444339102852739*n+9.8632861493405*i-6341.191035517494)-i*(20.737325471181034*i+47890.15695978492),h=t*(.8842522430003296*t+8.078677503112928*r+30.89978309703729*n-.23883238689178934*i-3616.812083916688)+r*(10.49593273432072*r+63.02378494754052*n+50.606957656360734*i-28620.90484698408)+n*(.03296041114873217*n+115.60384449646641*i-49363.43385999684)-i*(22.33816807309886*i+45932.16563550634);e[a++]=f>=0?255:o>=f?0:255+f*s|0,e[a++]=l>=0?255:o>=l?0:255+l*s|0,e[a++]=h>=0?255:o>=h?0:255+h*s|0}return e},getData:function(e,t,r){if(this.numComponents>4)throw"Unsupported color mode";var n=this._getLinearizedBlockData(e,t);if(3===this.numComponents)return this._convertYccToRgb(n);if(4===this.numComponents){if(this._isColorConversionNeeded())return r?this._convertYcckToRgb(n):this._convertYcckToCmyk(n);if(r)return this._convertCmykToRgb(n)}return n}},e}(),s=function(){function e(e,t,r){this.data=e,this.bp=t,this.dataEnd=r,this.chigh=e[t],this.clow=0,this.byteIn(),this.chigh=this.chigh<<7&65535|this.clow>>9&127,this.clow=this.clow<<7&65535,this.ct-=7,this.a=32768}var t=[{qe:22017,nmps:1,nlps:1,switchFlag:1},{qe:13313,nmps:2,nlps:6,switchFlag:0},{qe:6145,nmps:3,nlps:9,switchFlag:0},{qe:2753,nmps:4,nlps:12,switchFlag:0},{qe:1313,nmps:5,nlps:29,switchFlag:0},{qe:545,nmps:38,nlps:33,switchFlag:0},{qe:22017,nmps:7,nlps:6,switchFlag:1},{qe:21505,nmps:8,nlps:14,switchFlag:0},{qe:18433,nmps:9,nlps:14,switchFlag:0},{qe:14337,nmps:10,nlps:14,switchFlag:0},{qe:12289,nmps:11,nlps:17,switchFlag:0},{qe:9217,nmps:12,nlps:18,switchFlag:0},{qe:7169,nmps:13,nlps:20,switchFlag:0},{qe:5633,nmps:29,nlps:21,switchFlag:0},{qe:22017,nmps:15,nlps:14,switchFlag:1},{qe:21505,nmps:16,nlps:14,switchFlag:0},{qe:20737,nmps:17,nlps:15,switchFlag:0},{qe:18433,nmps:18,nlps:16,switchFlag:0},{qe:14337,nmps:19,nlps:17,switchFlag:0},{qe:13313,nmps:20,nlps:18,switchFlag:0},{qe:12289,nmps:21,nlps:19,switchFlag:0},{qe:10241,nmps:22,nlps:19,switchFlag:0},{qe:9217,nmps:23,nlps:20,switchFlag:0},{qe:8705,nmps:24,nlps:21,switchFlag:0},{qe:7169,nmps:25,nlps:22,switchFlag:0},{qe:6145,nmps:26,nlps:23,switchFlag:0},{qe:5633,nmps:27,nlps:24,switchFlag:0},{qe:5121,nmps:28,nlps:25,switchFlag:0},{qe:4609,nmps:29,nlps:26,switchFlag:0},{qe:4353,nmps:30,nlps:27,switchFlag:0},{qe:2753,nmps:31,nlps:28,switchFlag:0},{qe:2497,nmps:32,nlps:29,switchFlag:0},{qe:2209,nmps:33,nlps:30,switchFlag:0},{qe:1313,nmps:34,nlps:31,switchFlag:0},{qe:1089,nmps:35,nlps:32,switchFlag:0},{qe:673,nmps:36,nlps:33,switchFlag:0},{qe:545,nmps:37,nlps:34,switchFlag:0},{qe:321,nmps:38,nlps:35,switchFlag:0},{qe:273,nmps:39,nlps:36,switchFlag:0},{qe:133,nmps:40,nlps:37,switchFlag:0},{qe:73,nmps:41,nlps:38,switchFlag:0},{qe:37,nmps:42,nlps:39,switchFlag:0},{qe:21,nmps:43,nlps:40,switchFlag:0},{qe:9,nmps:44,nlps:41,switchFlag:0},{qe:5,nmps:45,nlps:42,switchFlag:0},{qe:1,nmps:45,nlps:43,switchFlag:0},{qe:22017,nmps:46,nlps:46,switchFlag:0}];return e.prototype={byteIn:function(){var e=this.data,t=this.bp;if(255===e[t]){var r=e[t+1];r>143?(this.clow+=65280,this.ct=8):(t++,this.clow+=e[t]<<9,this.ct=7,this.bp=t)}else t++,this.clow+=t<this.dataEnd?e[t]<<8:65280,this.ct=8,this.bp=t;this.clow>65535&&(this.chigh+=this.clow>>16,this.clow&=65535)},readBit:function(e,r){var n,i=e[r]>>1,a=1&e[r],o=t[i],s=o.qe,c=this.a-s;if(this.chigh<s)s>c?(c=s,n=a,i=o.nmps):(c=s,n=1^a,1===o.switchFlag&&(a=n),i=o.nlps);else{if(this.chigh-=s,0!==(32768&c))return this.a=c,a;s>c?(n=1^a,1===o.switchFlag&&(a=n),i=o.nlps):(n=a,i=o.nmps)}do 0===this.ct&&this.byteIn(),c<<=1,this.chigh=this.chigh<<1&65535|this.clow>>15&1,this.clow=this.clow<<1&65535,this.ct--;while(0===(32768&c));return this.a=c,e[r]=i<<1|a,n}},e}(),c=function(){function e(){this.failOnCorruptedImage=!1}function r(e,t){e.x0=Math.ceil(t.XOsiz/e.XRsiz),e.x1=Math.ceil(t.Xsiz/e.XRsiz),e.y0=Math.ceil(t.YOsiz/e.YRsiz),e.y1=Math.ceil(t.Ysiz/e.YRsiz),e.width=e.x1-e.x0,e.height=e.y1-e.y0}function a(e,t){for(var r,n=e.SIZ,i=[],a=Math.ceil((n.Xsiz-n.XTOsiz)/n.XTsiz),o=Math.ceil((n.Ysiz-n.YTOsiz)/n.YTsiz),s=0;o>s;s++)for(var c=0;a>c;c++)r={},r.tx0=Math.max(n.XTOsiz+c*n.XTsiz,n.XOsiz),r.ty0=Math.max(n.YTOsiz+s*n.YTsiz,n.YOsiz),r.tx1=Math.min(n.XTOsiz+(c+1)*n.XTsiz,n.Xsiz),r.ty1=Math.min(n.YTOsiz+(s+1)*n.YTsiz,n.Ysiz),r.width=r.tx1-r.tx0,r.height=r.ty1-r.ty0,r.components=[],i.push(r);e.tiles=i;for(var u=n.Csiz,f=0,l=u;l>f;f++)for(var h=t[f],d=0,p=i.length;p>d;d++){var g={};r=i[d],g.tcx0=Math.ceil(r.tx0/h.XRsiz),g.tcy0=Math.ceil(r.ty0/h.YRsiz),g.tcx1=Math.ceil(r.tx1/h.XRsiz),g.tcy1=Math.ceil(r.ty1/h.YRsiz),g.width=g.tcx1-g.tcx0,g.height=g.tcy1-g.tcy0,r.components[f]=g}}function o(e,t,r){var n=t.codingStyleParameters,i={};return n.entropyCoderWithCustomPrecincts?(i.PPx=n.precinctsSizes[r].PPx,i.PPy=n.precinctsSizes[r].PPy):(i.PPx=15,i.PPy=15),i.xcb_=r>0?Math.min(n.xcb,i.PPx-1):Math.min(n.xcb,i.PPx),i.ycb_=r>0?Math.min(n.ycb,i.PPy-1):Math.min(n.ycb,i.PPy),i}function c(e,t,r){var n=1<<r.PPx,i=1<<r.PPy,a=0===t.resLevel,o=1<<r.PPx+(a?0:-1),s=1<<r.PPy+(a?0:-1),c=t.trx1>t.trx0?Math.ceil(t.trx1/n)-Math.floor(t.trx0/n):0,u=t.try1>t.try0?Math.ceil(t.try1/i)-Math.floor(t.try0/i):0,f=c*u;t.precinctParameters={precinctWidth:n,precinctHeight:i,numprecinctswide:c,numprecinctshigh:u,numprecincts:f,precinctWidthInSubband:o,precinctHeightInSubband:s}}function u(e,t,r){var n,i,a,o,s=r.xcb_,c=r.ycb_,u=1<<s,f=1<<c,l=t.tbx0>>s,h=t.tby0>>c,d=t.tbx1+u-1>>s,p=t.tby1+f-1>>c,g=t.resolution.precinctParameters,m=[],v=[];for(i=h;p>i;i++)for(n=l;d>n;n++){a={cbx:n,cby:i,tbx0:u*n,tby0:f*i,tbx1:u*(n+1),tby1:f*(i+1)},a.tbx0_=Math.max(t.tbx0,a.tbx0),a.tby0_=Math.max(t.tby0,a.tby0),a.tbx1_=Math.min(t.tbx1,a.tbx1),a.tby1_=Math.min(t.tby1,a.tby1);var _=Math.floor((a.tbx0_-t.tbx0)/g.precinctWidthInSubband),b=Math.floor((a.tby0_-t.tby0)/g.precinctHeightInSubband);if(o=_+b*g.numprecinctswide,a.precinctNumber=o,a.subbandType=t.type,a.Lblock=3,!(a.tbx1_<=a.tbx0_||a.tby1_<=a.tby0_)){m.push(a);var w=v[o];void 0!==w?(n<w.cbxMin?w.cbxMin=n:n>w.cbxMax&&(w.cbxMax=n),i<w.cbyMin?w.cbxMin=i:i>w.cbyMax&&(w.cbyMax=i)):v[o]=w={cbxMin:n,cbyMin:i,cbxMax:n,cbyMax:i},a.precinct=w}}t.codeblockParameters={codeblockWidth:s,codeblockHeight:c,numcodeblockwide:d-l+1,numcodeblockhigh:p-h+1},t.codeblocks=m,t.precincts=v}function f(e,t,r){for(var n=[],i=e.subbands,a=0,o=i.length;o>a;a++)for(var s=i[a],c=s.codeblocks,u=0,f=c.length;f>u;u++){var l=c[u];l.precinctNumber===t&&n.push(l)}return{layerNumber:r,codeblocks:n}}function d(e){for(var t=e.SIZ,r=e.currentTile.index,n=e.tiles[r],i=n.codingStyleDefaultParameters.layersCount,a=t.Csiz,o=0,s=0;a>s;s++)o=Math.max(o,n.components[s].codingStyleParameters.decompositionLevelsCount);var c=0,u=0,l=0,h=0;this.nextPacket=function(){for(;i>c;c++){for(;o>=u;u++){for(;a>l;l++){var e=n.components[l];if(!(u>e.codingStyleParameters.decompositionLevelsCount)){for(var t=e.resolutions[u],r=t.precinctParameters.numprecincts;r>h;){var s=f(t,h,c);return h++,s}h=0}}l=0}u=0}throw new Error("JPX Error: Out of packets")}}function p(e){for(var t=e.SIZ,r=e.currentTile.index,n=e.tiles[r],i=n.codingStyleDefaultParameters.layersCount,a=t.Csiz,o=0,s=0;a>s;s++)o=Math.max(o,n.components[s].codingStyleParameters.decompositionLevelsCount);var c=0,u=0,l=0,h=0;this.nextPacket=function(){for(;o>=c;c++){for(;i>u;u++){for(;a>l;l++){var e=n.components[l];if(!(c>e.codingStyleParameters.decompositionLevelsCount)){for(var t=e.resolutions[c],r=t.precinctParameters.numprecincts;r>h;){var s=f(t,h,u);return h++,s}h=0}}l=0}u=0}throw new Error("JPX Error: Out of packets")}}function g(e){var t,r,n,i,a=e.SIZ,o=e.currentTile.index,s=e.tiles[o],c=s.codingStyleDefaultParameters.layersCount,u=a.Csiz,l=0;for(n=0;u>n;n++){var h=s.components[n];l=Math.max(l,h.codingStyleParameters.decompositionLevelsCount)}var d=new Int32Array(l+1);for(r=0;l>=r;++r){var p=0;for(n=0;u>n;++n){var g=s.components[n].resolutions;r<g.length&&(p=Math.max(p,g[r].precinctParameters.numprecincts))}d[r]=p}t=0,r=0,n=0,i=0,this.nextPacket=function(){for(;l>=r;r++){for(;i<d[r];i++){for(;u>n;n++){var e=s.components[n];if(!(r>e.codingStyleParameters.decompositionLevelsCount)){var a=e.resolutions[r],o=a.precinctParameters.numprecincts;if(!(i>=o)){for(;c>t;){var h=f(a,i,t);return t++,h}t=0}}}n=0}i=0}throw new Error("JPX Error: Out of packets")}}function m(e){var t=e.SIZ,r=e.currentTile.index,n=e.tiles[r],i=n.codingStyleDefaultParameters.layersCount,a=t.Csiz,o=b(n),s=o,c=0,u=0,l=0,h=0,d=0;this.nextPacket=function(){for(;d<s.maxNumHigh;d++){for(;h<s.maxNumWide;h++){for(;a>l;l++){for(var e=n.components[l],t=e.codingStyleParameters.decompositionLevelsCount;t>=u;u++){var r=e.resolutions[u],p=o.components[l].resolutions[u],g=_(h,d,p,s,r);if(null!==g){for(;i>c;){var m=f(r,g,c);return c++,m}c=0}}u=0}l=0}h=0}throw new Error("JPX Error: Out of packets")}}function v(e){var t=e.SIZ,r=e.currentTile.index,n=e.tiles[r],i=n.codingStyleDefaultParameters.layersCount,a=t.Csiz,o=b(n),s=0,c=0,u=0,l=0,h=0;this.nextPacket=function(){for(;a>u;++u){for(var e=n.components[u],t=o.components[u],r=e.codingStyleParameters.decompositionLevelsCount;h<t.maxNumHigh;h++){for(;l<t.maxNumWide;l++){for(;r>=c;c++){var d=e.resolutions[c],p=t.resolutions[c],g=_(l,h,p,t,d);if(null!==g){for(;i>s;){var m=f(d,g,s);return s++,m}s=0}}c=0}l=0}h=0}throw new Error("JPX Error: Out of packets")}}function _(e,t,r,n,i){var a=e*n.minWidth,o=t*n.minHeight;if(a%r.width!==0||o%r.height!==0)return null;var s=o/r.width*i.precinctParameters.numprecinctswide;return a/r.height+s}function b(e){for(var t=e.components.length,r=Number.MAX_VALUE,n=Number.MAX_VALUE,i=0,a=0,o=new Array(t),s=0;t>s;s++){for(var c=e.components[s],u=c.codingStyleParameters.decompositionLevelsCount,f=new Array(u+1),l=Number.MAX_VALUE,h=Number.MAX_VALUE,d=0,p=0,g=1,m=u;m>=0;--m){var v=c.resolutions[m],_=g*v.precinctParameters.precinctWidth,b=g*v.precinctParameters.precinctHeight;l=Math.min(l,_),h=Math.min(h,b),d=Math.max(d,v.precinctParameters.numprecinctswide),p=Math.max(p,v.precinctParameters.numprecinctshigh),f[m]={width:_,height:b},g<<=1}r=Math.min(r,l),n=Math.min(n,h),i=Math.max(i,d),a=Math.max(a,p),o[s]={resolutions:f,minWidth:l,minHeight:h,maxNumWide:d,maxNumHigh:p}}return{components:o,minWidth:r,minHeight:n,maxNumWide:i,maxNumHigh:a}}function w(e){for(var t=e.SIZ,r=e.currentTile.index,n=e.tiles[r],i=t.Csiz,a=0;i>a;a++){for(var s=n.components[a],f=s.codingStyleParameters.decompositionLevelsCount,l=[],h=[],_=0;f>=_;_++){var b=o(e,s,_),w={},y=1<<f-_;w.trx0=Math.ceil(s.tcx0/y),w.try0=Math.ceil(s.tcy0/y),w.trx1=Math.ceil(s.tcx1/y),w.try1=Math.ceil(s.tcy1/y),w.resLevel=_,c(e,w,b),l.push(w);var x;if(0===_)x={},x.type="LL",x.tbx0=Math.ceil(s.tcx0/y),x.tby0=Math.ceil(s.tcy0/y),x.tbx1=Math.ceil(s.tcx1/y),x.tby1=Math.ceil(s.tcy1/y),x.resolution=w,u(e,x,b),h.push(x),w.subbands=[x];else{var k=1<<f-_+1,E=[];x={},x.type="HL",x.tbx0=Math.ceil(s.tcx0/k-.5),x.tby0=Math.ceil(s.tcy0/k),x.tbx1=Math.ceil(s.tcx1/k-.5),x.tby1=Math.ceil(s.tcy1/k),x.resolution=w,u(e,x,b),h.push(x),E.push(x),x={},x.type="LH",x.tbx0=Math.ceil(s.tcx0/k),x.tby0=Math.ceil(s.tcy0/k-.5),x.tbx1=Math.ceil(s.tcx1/k),x.tby1=Math.ceil(s.tcy1/k-.5),x.resolution=w,u(e,x,b),h.push(x),E.push(x),x={},x.type="HH",x.tbx0=Math.ceil(s.tcx0/k-.5),x.tby0=Math.ceil(s.tcy0/k-.5),x.tbx1=Math.ceil(s.tcx1/k-.5),x.tby1=Math.ceil(s.tcy1/k-.5),x.resolution=w,u(e,x,b),h.push(x),E.push(x),w.subbands=E}}s.resolutions=l,s.subbands=h}var S=n.codingStyleDefaultParameters.progressionOrder;switch(S){case 0:n.packetsIterator=new d(e);break;case 1:n.packetsIterator=new p(e);break;case 2:n.packetsIterator=new g(e);break;case 3:n.packetsIterator=new m(e);break;case 4:n.packetsIterator=new v(e);break;default:throw new Error("JPX Error: Unsupported progression order "+S)}}function y(e,r,n,i){function a(e){for(;e>h;){var t=r[n+l];l++,d?(f=f<<7|t,h+=7,d=!1):(f=f<<8|t,h+=8),255===t&&(d=!0)}return h-=e,f>>>h&(1<<e)-1}function o(e){return 255===r[n+l-1]&&r[n+l]===e?(s(1),!0):255===r[n+l]&&r[n+l+1]===e?(s(2),!0):!1}function s(e){l+=e}function c(){h=0,d&&(l++,d=!1)}function u(){if(0===a(1))return 1;if(0===a(1))return 2;var e=a(2);return 3>e?e+3:(e=a(5),31>e?e+6:(e=a(7),e+37))}for(var f,l=0,h=0,d=!1,p=e.currentTile.index,g=e.tiles[p],m=e.COD.sopMarkerUsed,v=e.COD.ephMarkerUsed,_=g.packetsIterator;i>l;){c(),m&&o(145)&&s(4);var b=_.nextPacket();if(a(1)){for(var w,y=b.layerNumber,x=[],k=0,E=b.codeblocks.length;E>k;k++){w=b.codeblocks[k];var S,A=w.precinct,P=w.cbx-A.cbxMin,T=w.cby-A.cbyMin,M=!1,L=!1;if(void 0!==w.included)M=!!a(1);else{A=w.precinct;var C,O;if(void 0!==A.inclusionTree)C=A.inclusionTree;else{var D=A.cbxMax-A.cbxMin+1,U=A.cbyMax-A.cbyMin+1;C=new R(D,U,y),O=new I(D,U),A.inclusionTree=C,A.zeroBitPlanesTree=O}if(C.reset(P,T,y))for(;;){if(!a(1)){C.incrementValue(y);break}if(S=!C.nextLevel()){w.included=!0,M=L=!0;break}}}if(M){if(L){for(O=A.zeroBitPlanesTree,O.reset(P,T);;)if(a(1)){if(S=!O.nextLevel())break}else O.incrementValue();w.zeroBitPlanes=O.value}for(var z=u();a(1);)w.Lblock++;var B=t(z),F=(1<<B>z?B-1:B)+w.Lblock,N=a(F);x.push({codeblock:w,codingpasses:z,dataLength:N})}}for(c(),v&&o(146);x.length>0;){var j=x.shift();w=j.codeblock,void 0===w.data&&(w.data=[]),w.data.push({data:r,start:n+l,end:n+l+j.dataLength,codingpasses:j.codingpasses}),l+=j.dataLength}}}return l}function x(e,t,r,n,i,a,o,c){for(var u=n.tbx0,f=n.tby0,l=n.tbx1-n.tbx0,h=n.codeblocks,d="H"===n.type.charAt(0)?1:0,p="H"===n.type.charAt(1)?t:0,g=0,m=h.length;m>g;++g){var v=h[g],_=v.tbx1_-v.tbx0_,b=v.tby1_-v.tby0_;if(0!==_&&0!==b&&void 0!==v.data){var w,y;w=new P(_,b,v.subbandType,v.zeroBitPlanes,a),y=2;var x,k,E,S=v.data,A=0,I=0;for(x=0,k=S.length;k>x;x++)E=S[x],A+=E.end-E.start,I+=E.codingpasses;var R=new Uint8Array(A),T=0;for(x=0,k=S.length;k>x;x++){E=S[x];var M=E.data.subarray(E.start,E.end);R.set(M,T),T+=M.length}var L=new s(R,0,A);for(w.setDecoder(L),x=0;I>x;x++){switch(y){case 0:w.runSignificancePropogationPass();break;case 1:w.runMagnitudeRefinementPass();break;case 2:w.runCleanupPass(),c&&w.checkSegmentationSymbol()}y=(y+1)%3}var C,O,D,U=v.tbx0_-u+(v.tby0_-f)*l,z=w.coefficentsSign,B=w.coefficentsMagnitude,F=w.bitsDecoded,N=o?0:.5;T=0;var j="LL"!==n.type;for(x=0;b>x;x++){var Z=U/l|0,q=2*Z*(t-l)+d+p;for(C=0;_>C;C++){if(O=B[T],0!==O){O=(O+N)*i,0!==z[T]&&(O=-O),D=F[T];var G=j?q+(U<<1):U;o&&D>=a?e[G]=O:e[G]=O*(1<<a-D)}U++,T++}U+=l-_}}}}function k(e,t,r){for(var n=t.components[r],i=n.codingStyleParameters,a=n.quantizationParameters,o=i.decompositionLevelsCount,s=a.SPqcds,c=a.scalarExpounded,u=a.guardBits,f=i.segmentationSymbolUsed,l=e.components[r].precision,h=i.reversibleTransformation,d=h?new L:new M,p=[],g=0,m=0;o>=m;m++){for(var v=n.resolutions[m],_=v.trx1-v.trx0,b=v.try1-v.try0,w=new Float32Array(_*b),y=0,k=v.subbands.length;k>y;y++){var E,S;c?(E=s[g].mu,S=s[g].epsilon,g++):(E=s[0].mu,S=s[0].epsilon+(m>0?1-m:0));var I=v.subbands[y],R=A[I.type],P=h?1:Math.pow(2,l+R-S)*(1+E/2048),T=u+S-1;x(w,_,b,I,P,T,h,f)}p.push({width:_,height:b,items:w})}var C=d.calculate(p,n.tcx0,n.tcy0);return{left:n.tcx0,top:n.tcy0,width:C.width,height:C.height,items:C.items}}function E(e){for(var t=e.SIZ,r=e.components,n=t.Csiz,i=[],a=0,o=e.tiles.length;o>a;a++){var s,c=e.tiles[a],u=[];for(s=0;n>s;s++)u[s]=k(e,c,s);var f,l,h,d,p,g,m,v,_,b,w,y,x,E,S,A=u[0],I=new Uint8Array(A.items.length*n),R={left:A.left,top:A.top,width:A.width,height:A.height,items:I},P=0;if(c.codingStyleDefaultParameters.multipleComponentTransform){var T=4===n,M=u[0].items,L=u[1].items,C=u[2].items,O=T?u[3].items:null;f=r[0].precision-8,l=(128<<f)+.5,h=255*(1<<f),p=.5*h,d=-p;var D=c.components[0],U=n-3;if(m=M.length,D.codingStyleParameters.reversibleTransformation)for(g=0;m>g;g++,P+=U)v=M[g]+l,_=L[g],b=C[g],y=v-(b+_>>2),w=y+b,x=y+_,I[P++]=0>=w?0:w>=h?255:w>>f,I[P++]=0>=y?0:y>=h?255:y>>f,I[P++]=0>=x?0:x>=h?255:x>>f;else for(g=0;m>g;g++,P+=U)v=M[g]+l,_=L[g],b=C[g],w=v+1.402*b,y=v-.34413*_-.71414*b,x=v+1.772*_,I[P++]=0>=w?0:w>=h?255:w>>f,I[P++]=0>=y?0:y>=h?255:y>>f,I[P++]=0>=x?0:x>=h?255:x>>f;if(T)for(g=0,P=3;m>g;g++,P+=4)E=O[g],I[P]=d>=E?0:E>=p?255:E+l>>f}else for(s=0;n>s;s++){var z=u[s].items;for(f=r[s].precision-8,l=(128<<f)+.5,h=127.5*(1<<f),d=-h,P=s,g=0,m=z.length;m>g;g++)S=z[g],I[P]=d>=S?0:S>=h?255:S+l>>f,P+=n}i.push(R)}return i}function S(e,t){for(var r=e.SIZ,n=r.Csiz,i=e.tiles[t],a=0;n>a;a++){var o=i.components[a],s=void 0!==e.currentTile.QCC[a]?e.currentTile.QCC[a]:e.currentTile.QCD;o.quantizationParameters=s;var c=void 0!==e.currentTile.COC[a]?e.currentTile.COC[a]:e.currentTile.COD;o.codingStyleParameters=c}i.codingStyleDefaultParameters=e.currentTile.COD}var A={LL:0,LH:1,HL:1,HH:2};e.prototype={parse:function(e){var t=n(e,0);if(65359===t)return void this.parseCodestream(e,0,e.length);for(var r=0,a=e.length;a>r;){var o=8,s=i(e,r),c=i(e,r+4);if(r+=o,1===s&&(s=4294967296*i(e,r)+i(e,r+4),r+=8,o+=8),0===s&&(s=a-r+o),o>s)throw new Error("JPX Error: Invalid box field size");var u=s-o,f=!0;switch(c){case 1785737832:f=!1;break;case 1668246642:var d=e[r];e[r+1],e[r+2];if(1===d){var p=i(e,r+3);switch(p){case 16:case 17:case 18:break;default:l("Unknown colorspace "+p)}}else 2===d&&h("ICC profile not supported");break;case 1785737827:this.parseCodestream(e,r,r+u);break;case 1783636e3:218793738!==i(e,r)&&l("Invalid JP2 signature");break;case 1783634458:case 1718909296:case 1920099697:case 1919251232:case 1768449138:break;default:var g=String.fromCharCode(c>>24&255,c>>16&255,c>>8&255,255&c);l("Unsupported header type "+c+" ("+g+")")}f&&(r+=u)}},parseImageProperties:function(e){for(var t=e.getByte();t>=0;){var r=t;t=e.getByte();var n=r<<8|t;if(65361===n){e.skip(4);var i=e.getInt32()>>>0,a=e.getInt32()>>>0,o=e.getInt32()>>>0,s=e.getInt32()>>>0;e.skip(16);var c=e.getUint16();return this.width=i-o,this.height=a-s,this.componentsCount=c,void(this.bitsPerComponent=8)}}throw new Error("JPX Error: No size marker found in JPX stream")},parseCodestream:function(e,t,o){var s={};try{for(var c=!1,u=t;o>u+1;){var f=n(e,u);u+=2;var h,d,p,g,m,v,_=0;switch(f){case 65359:s.mainHeader=!0;break;case 65497:break;case 65361:_=n(e,u);var b={};b.Xsiz=i(e,u+4),b.Ysiz=i(e,u+8),b.XOsiz=i(e,u+12),b.YOsiz=i(e,u+16),b.XTsiz=i(e,u+20),b.YTsiz=i(e,u+24),b.XTOsiz=i(e,u+28),b.YTOsiz=i(e,u+32);var x=n(e,u+36);b.Csiz=x;var k=[];h=u+38;for(var A=0;x>A;A++){var I={precision:(127&e[h])+1,isSigned:!!(128&e[h]),XRsiz:e[h+1],YRsiz:e[h+1]};r(I,b),k.push(I)}s.SIZ=b,s.components=k,a(s,k),s.QCC=[],s.COC=[];break;case 65372:_=n(e,u);var R={};switch(h=u+2,d=e[h++],31&d){case 0:g=8,m=!0;break;case 1:g=16,m=!1;break;case 2:g=16,m=!0;break;default:throw new Error("JPX Error: Invalid SQcd value "+d)}for(R.noQuantization=8===g,R.scalarExpounded=m,R.guardBits=d>>5,p=[];_+u>h;){var P={};8===g?(P.epsilon=e[h++]>>3,P.mu=0):(P.epsilon=e[h]>>3,P.mu=(7&e[h])<<8|e[h+1],h+=2),p.push(P)}R.SPqcds=p,s.mainHeader?s.QCD=R:(s.currentTile.QCD=R,s.currentTile.QCC=[]);break;case 65373:_=n(e,u);var T={};h=u+2;var M;switch(s.SIZ.Csiz<257?M=e[h++]:(M=n(e,h),h+=2),d=e[h++],31&d){case 0:g=8,m=!0;break;case 1:g=16,m=!1;break;case 2:g=16,m=!0;break;default:throw new Error("JPX Error: Invalid SQcd value "+d)}for(T.noQuantization=8===g,T.scalarExpounded=m,T.guardBits=d>>5,p=[];_+u>h;)P={},8===g?(P.epsilon=e[h++]>>3,P.mu=0):(P.epsilon=e[h]>>3,P.mu=(7&e[h])<<8|e[h+1],h+=2),p.push(P);T.SPqcds=p,s.mainHeader?s.QCC[M]=T:s.currentTile.QCC[M]=T;break;case 65362:_=n(e,u);var L={};h=u+2;var C=e[h++];L.entropyCoderWithCustomPrecincts=!!(1&C),L.sopMarkerUsed=!!(2&C),L.ephMarkerUsed=!!(4&C),L.progressionOrder=e[h++],L.layersCount=n(e,h),h+=2,L.multipleComponentTransform=e[h++],L.decompositionLevelsCount=e[h++],L.xcb=(15&e[h++])+2,L.ycb=(15&e[h++])+2;var O=e[h++];if(L.selectiveArithmeticCodingBypass=!!(1&O),L.resetContextProbabilities=!!(2&O),L.terminationOnEachCodingPass=!!(4&O),L.verticalyStripe=!!(8&O),L.predictableTermination=!!(16&O),L.segmentationSymbolUsed=!!(32&O),L.reversibleTransformation=e[h++],L.entropyCoderWithCustomPrecincts){for(var D=[];_+u>h;){var U=e[h++];D.push({PPx:15&U,PPy:U>>4})}L.precinctsSizes=D}var z=[];if(L.selectiveArithmeticCodingBypass&&z.push("selectiveArithmeticCodingBypass"),L.resetContextProbabilities&&z.push("resetContextProbabilities"),L.terminationOnEachCodingPass&&z.push("terminationOnEachCodingPass"),L.verticalyStripe&&z.push("verticalyStripe"),L.predictableTermination&&z.push("predictableTermination"),z.length>0)throw c=!0,new Error("JPX Error: Unsupported COD options ("+z.join(", ")+")");s.mainHeader?s.COD=L:(s.currentTile.COD=L,s.currentTile.COC=[]);break;case 65424:_=n(e,u),v={},v.index=n(e,u+2),v.length=i(e,u+4),v.dataEnd=v.length+u-2,v.partIndex=e[u+8],v.partsCount=e[u+9],s.mainHeader=!1,0===v.partIndex&&(v.COD=s.COD,v.COC=s.COC.slice(0),v.QCD=s.QCD,v.QCC=s.QCC.slice(0)),s.currentTile=v;break;case 65427:v=s.currentTile,0===v.partIndex&&(S(s,v.index),w(s)),_=v.dataEnd-u,y(s,e,u,_);break;case 65365:case 65367:case 65368:case 65380:_=n(e,u);break;case 65363:throw new Error("JPX Error: Codestream code 0xFF53 (COC) is not implemented");default:throw new Error("JPX Error: Unknown codestream code: "+f.toString(16))}u+=_}}catch(B){if(c||this.failOnCorruptedImage)throw B;l("Trying to recover from "+B.message)}this.tiles=E(s),this.width=s.SIZ.Xsiz-s.SIZ.XOsiz,this.height=s.SIZ.Ysiz-s.SIZ.YOsiz,this.componentsCount=s.SIZ.Csiz}};var I=function(){function e(e,r){var n=t(Math.max(e,r))+1;this.levels=[];for(var i=0;n>i;i++){var a={width:e,height:r,items:[]};this.levels.push(a),e=Math.ceil(e/2),r=Math.ceil(r/2)}}return e.prototype={reset:function(e,t){for(var r,n=0,i=0;n<this.levels.length;){r=this.levels[n];var a=e+t*r.width;if(void 0!==r.items[a]){i=r.items[a];break}r.index=a,e>>=1,t>>=1,n++}n--,r=this.levels[n],r.items[r.index]=i,this.currentLevel=n,delete this.value},incrementValue:function(){var e=this.levels[this.currentLevel];e.items[e.index]++},nextLevel:function(){var e=this.currentLevel,t=this.levels[e],r=t.items[t.index];return e--,0>e?(this.value=r,!1):(this.currentLevel=e,t=this.levels[e],t.items[t.index]=r,!0)}},e}(),R=function(){function e(e,r,n){var i=t(Math.max(e,r))+1;this.levels=[];for(var a=0;i>a;a++){for(var o=new Uint8Array(e*r),s=0,c=o.length;c>s;s++)o[s]=n;var u={width:e,height:r,items:o};this.levels.push(u),e=Math.ceil(e/2),r=Math.ceil(r/2)}}return e.prototype={reset:function(e,t,r){for(var n=0;n<this.levels.length;){var i=this.levels[n],a=e+t*i.width;i.index=a;var o=i.items[a];if(255===o)break;if(o>r)return this.currentLevel=n,this.propagateValues(),!1;e>>=1,t>>=1,n++}return this.currentLevel=n-1,!0},incrementValue:function(e){var t=this.levels[this.currentLevel];t.items[t.index]=e+1,this.propagateValues()},propagateValues:function(){for(var e=this.currentLevel,t=this.levels[e],r=t.items[t.index];--e>=0;)t=this.levels[e],t.items[t.index]=r},nextLevel:function(){var e=this.currentLevel,t=this.levels[e],r=t.items[t.index];return t.items[t.index]=255,e--,0>e?!1:(this.currentLevel=e,t=this.levels[e],t.items[t.index]=r,!0)}},e}(),P=function(){function e(e,t,r,o,s){this.width=e,this.height=t,this.contextLabelTable="HH"===r?a:"HL"===r?i:n;var c=e*t;this.neighborsSignificance=new Uint8Array(c),this.coefficentsSign=new Uint8Array(c),this.coefficentsMagnitude=s>14?new Uint32Array(c):s>6?new Uint16Array(c):new Uint8Array(c),this.processingFlags=new Uint8Array(c);var u=new Uint8Array(c);if(0!==o)for(var f=0;c>f;f++)u[f]=o;this.bitsDecoded=u,this.reset()}var t=17,r=18,n=new Uint8Array([0,5,8,0,3,7,8,0,4,7,8,0,0,0,0,0,1,6,8,0,3,7,8,0,4,7,8,0,0,0,0,0,2,6,8,0,3,7,8,0,4,7,8,0,0,0,0,0,2,6,8,0,3,7,8,0,4,7,8,0,0,0,0,0,2,6,8,0,3,7,8,0,4,7,8]),i=new Uint8Array([0,3,4,0,5,7,7,0,8,8,8,0,0,0,0,0,1,3,4,0,6,7,7,0,8,8,8,0,0,0,0,0,2,3,4,0,6,7,7,0,8,8,8,0,0,0,0,0,2,3,4,0,6,7,7,0,8,8,8,0,0,0,0,0,2,3,4,0,6,7,7,0,8,8,8]),a=new Uint8Array([0,1,2,0,1,2,2,0,2,2,2,0,0,0,0,0,3,4,5,0,4,5,5,0,5,5,5,0,0,0,0,0,6,7,7,0,7,7,7,0,7,7,7,0,0,0,0,0,8,8,8,0,8,8,8,0,8,8,8,0,0,0,0,0,8,8,8,0,8,8,8,0,8,8,8]);
return e.prototype={setDecoder:function(e){this.decoder=e},reset:function(){this.contexts=new Int8Array(19),this.contexts[0]=8,this.contexts[t]=92,this.contexts[r]=6},setNeighborsSignificance:function(e,t,r){var n,i=this.neighborsSignificance,a=this.width,o=this.height,s=t>0,c=a>t+1;e>0&&(n=r-a,s&&(i[n-1]+=16),c&&(i[n+1]+=16),i[n]+=4),o>e+1&&(n=r+a,s&&(i[n-1]+=16),c&&(i[n+1]+=16),i[n]+=4),s&&(i[r-1]+=1),c&&(i[r+1]+=1),i[r]|=128},runSignificancePropogationPass:function(){for(var e=this.decoder,t=this.width,r=this.height,n=this.coefficentsMagnitude,i=this.coefficentsSign,a=this.neighborsSignificance,o=this.processingFlags,s=this.contexts,c=this.contextLabelTable,u=this.bitsDecoded,f=-2,l=1,h=2,d=0;r>d;d+=4)for(var p=0;t>p;p++)for(var g=d*t+p,m=0;4>m;m++,g+=t){var v=d+m;if(v>=r)break;if(o[g]&=f,!n[g]&&a[g]){var _=c[a[g]],b=e.readBit(s,_);if(b){var w=this.decodeSignBit(v,p,g);i[g]=w,n[g]=1,this.setNeighborsSignificance(v,p,g),o[g]|=h}u[g]++,o[g]|=l}}},decodeSignBit:function(e,t,r){var n,i,a,o,s,c,u=this.width,f=this.height,l=this.coefficentsMagnitude,h=this.coefficentsSign;o=t>0&&0!==l[r-1],u>t+1&&0!==l[r+1]?(a=h[r+1],o?(i=h[r-1],n=1-a-i):n=1-a-a):o?(i=h[r-1],n=1-i-i):n=0;var d=3*n;return o=e>0&&0!==l[r-u],f>e+1&&0!==l[r+u]?(a=h[r+u],o?(i=h[r-u],n=1-a-i+d):n=1-a-a+d):o?(i=h[r-u],n=1-i-i+d):n=d,n>=0?(s=9+n,c=this.decoder.readBit(this.contexts,s)):(s=9-n,c=1^this.decoder.readBit(this.contexts,s)),c},runMagnitudeRefinementPass:function(){for(var e,t=this.decoder,r=this.width,n=this.height,i=this.coefficentsMagnitude,a=this.neighborsSignificance,o=this.contexts,s=this.bitsDecoded,c=this.processingFlags,u=1,f=2,l=r*n,h=4*r,d=0;l>d;d=e){e=Math.min(l,d+h);for(var p=0;r>p;p++)for(var g=d+p;e>g;g+=r)if(i[g]&&0===(c[g]&u)){var m=16;if(0!==(c[g]&f)){c[g]^=f;var v=127&a[g];m=0===v?15:14}var _=t.readBit(o,m);i[g]=i[g]<<1|_,s[g]++,c[g]|=u}}},runCleanupPass:function(){for(var e,n=this.decoder,i=this.width,a=this.height,o=this.neighborsSignificance,s=this.coefficentsMagnitude,c=this.coefficentsSign,u=this.contexts,f=this.contextLabelTable,l=this.bitsDecoded,h=this.processingFlags,d=1,p=2,g=i,m=2*i,v=3*i,_=0;a>_;_=e){e=Math.min(_+4,a);for(var b=_*i,w=a>_+3,y=0;i>y;y++){var x,k=b+y,E=w&&0===h[k]&&0===h[k+g]&&0===h[k+m]&&0===h[k+v]&&0===o[k]&&0===o[k+g]&&0===o[k+m]&&0===o[k+v],S=0,A=k,I=_;if(E){var R=n.readBit(u,r);if(!R){l[k]++,l[k+g]++,l[k+m]++,l[k+v]++;continue}S=n.readBit(u,t)<<1|n.readBit(u,t),0!==S&&(I=_+S,A+=S*i),x=this.decodeSignBit(I,y,A),c[A]=x,s[A]=1,this.setNeighborsSignificance(I,y,A),h[A]|=p,A=k;for(var P=_;I>=P;P++,A+=i)l[A]++;S++}for(I=_+S;e>I;I++,A+=i)if(!s[A]&&0===(h[A]&d)){var T=f[o[A]],M=n.readBit(u,T);1===M&&(x=this.decodeSignBit(I,y,A),c[A]=x,s[A]=1,this.setNeighborsSignificance(I,y,A),h[A]|=p),l[A]++}}}},checkSegmentationSymbol:function(){var e=this.decoder,r=this.contexts,n=e.readBit(r,t)<<3|e.readBit(r,t)<<2|e.readBit(r,t)<<1|e.readBit(r,t);if(10!==n)throw new Error("JPX Error: Invalid segmentation symbol")}},e}(),T=function(){function e(){}return e.prototype.calculate=function(e,t,r){for(var n=e[0],i=1,a=e.length;a>i;i++)n=this.iterate(n,e[i],t,r);return n},e.prototype.extend=function(e,t,r){var n=t-1,i=t+1,a=t+r-2,o=t+r;e[n--]=e[i++],e[o++]=e[a--],e[n--]=e[i++],e[o++]=e[a--],e[n--]=e[i++],e[o++]=e[a--],e[n]=e[i],e[o]=e[a]},e.prototype.iterate=function(e,t,r,n){var i,a,o,s,c,u,f=e.width,l=e.height,h=e.items,d=t.width,p=t.height,g=t.items;for(o=0,i=0;l>i;i++)for(s=2*i*d,a=0;f>a;a++,o++,s+=2)g[s]=h[o];h=e.items=null;var m=4,v=new Float32Array(d+2*m);if(1===d){if(0!==(1&r))for(u=0,o=0;p>u;u++,o+=d)g[o]*=.5}else for(u=0,o=0;p>u;u++,o+=d)v.set(g.subarray(o,o+d),m),this.extend(v,m,d),this.filter(v,m,d),g.set(v.subarray(m,m+d),o);var _=16,b=[];for(i=0;_>i;i++)b.push(new Float32Array(p+2*m));var w,y=0;if(e=m+p,1===p){if(0!==(1&n))for(c=0;d>c;c++)g[c]*=.5}else for(c=0;d>c;c++){if(0===y){for(_=Math.min(d-c,_),o=c,s=m;e>s;o+=d,s++)for(w=0;_>w;w++)b[w][s]=g[o+w];y=_}y--;var x=b[y];if(this.extend(x,m,p),this.filter(x,m,p),0===y)for(o=c-_+1,s=m;e>s;o+=d,s++)for(w=0;_>w;w++)g[o+w]=b[w][s]}return{width:d,height:p,items:g}},e}(),M=function(){function e(){T.call(this)}return e.prototype=Object.create(T.prototype),e.prototype.filter=function(e,t,r){var n=r>>1;t=0|t;var i,a,o,s,c=-1.586134342059924,u=-.052980118572961,f=.882911075530934,l=.443506852043971,h=1.230174104914001,d=1/h;for(i=t-3,a=n+4;a--;i+=2)e[i]*=d;for(i=t-2,o=l*e[i-1],a=n+3;a--&&(s=l*e[i+1],e[i]=h*e[i]-o-s,a--);i+=2)i+=2,o=l*e[i+1],e[i]=h*e[i]-o-s;for(i=t-1,o=f*e[i-1],a=n+2;a--&&(s=f*e[i+1],e[i]-=o+s,a--);i+=2)i+=2,o=f*e[i+1],e[i]-=o+s;for(i=t,o=u*e[i-1],a=n+1;a--&&(s=u*e[i+1],e[i]-=o+s,a--);i+=2)i+=2,o=u*e[i+1],e[i]-=o+s;if(0!==n)for(i=t+1,o=c*e[i-1],a=n;a--&&(s=c*e[i+1],e[i]-=o+s,a--);i+=2)i+=2,o=c*e[i+1],e[i]-=o+s},e}(),L=function(){function e(){T.call(this)}return e.prototype=Object.create(T.prototype),e.prototype.filter=function(e,t,r){var n=r>>1;t=0|t;var i,a;for(i=t,a=n+1;a--;i+=2)e[i]-=e[i-1]+e[i+1]+2>>2;for(i=t+1,a=n;a--;i+=2)e[i]+=e[i-1]+e[i+1]>>1},e}();return e}(),u=function(){function e(){}function o(e,t,r){this.data=e,this.start=t,this.end=r}function c(e,t,r){function n(e){for(var t=0,n=0;e>n;n++){var o=r.readBit(i,a);a=256>a?a<<1|o:511&(a<<1|o)|256,t=t<<1|o}return t>>>0}var i=e.getContexts(t),a=1,o=n(1),s=n(1)?n(1)?n(1)?n(1)?n(1)?n(32)+4436:n(12)+340:n(8)+84:n(6)+20:n(4)+4:n(2);return 0===o?s:s>0?-s:null}function u(e,t,r){for(var n=e.getContexts("IAID"),i=1,a=0;r>a;a++){var o=t.readBit(n,i);i=i<<1|o}return 31>r?i&(1<<r)-1:2147483647&i}function l(e,t,r){var n,i,a,o,s,c,u,f=r.decoder,l=r.contextCache.getContexts("GB"),h=[],d=31735;for(i=0;t>i;i++)for(s=h[i]=new Uint8Array(e),c=1>i?s:h[i-1],u=2>i?s:h[i-2],n=u[0]<<13|u[1]<<12|u[2]<<11|c[0]<<7|c[1]<<6|c[2]<<5|c[3]<<4,a=0;e>a;a++)s[a]=o=f.readBit(l,n),n=(n&d)<<1|(e>a+3?u[a+3]<<11:0)|(e>a+4?c[a+4]<<4:0)|o;return h}function h(e,t,r,n,i,a,o,s){if(e&&f("JBIG2 error: MMR encoding is not supported"),0===n&&!a&&!i&&4===o.length&&3===o[0].x&&-1===o[0].y&&-3===o[1].x&&-1===o[1].y&&2===o[2].x&&-2===o[2].y&&-2===o[3].x&&-2===o[3].y)return l(t,r,s);var c=!!a,u=S[n].concat(o);u.sort(function(e,t){return e.y-t.y||e.x-t.x});var h,d,p=u.length,g=new Int8Array(p),m=new Int8Array(p),v=[],_=0,b=0,w=0,y=0;for(d=0;p>d;d++)g[d]=u[d].x,m[d]=u[d].y,b=Math.min(b,u[d].x),w=Math.max(w,u[d].x),y=Math.min(y,u[d].y),p-1>d&&u[d].y===u[d+1].y&&u[d].x===u[d+1].x-1?_|=1<<p-1-d:v.push(d);var x=v.length,k=new Int8Array(x),E=new Int8Array(x),A=new Uint16Array(x);for(h=0;x>h;h++)d=v[h],k[h]=u[d].x,E[h]=u[d].y,A[h]=1<<p-1-d;for(var R,P,T,M,L,C=-b,O=-y,D=t-w,U=I[n],z=new Uint8Array(t),B=[],F=s.decoder,N=s.contextCache.getContexts("GB"),j=0,Z=0,q=0;r>q;q++){if(i){var G=F.readBit(N,U);if(j^=G){B.push(z);continue}}for(z=new Uint8Array(z),B.push(z),R=0;t>R;R++)if(c&&a[q][R])z[R]=0;else{if(R>=C&&D>R&&q>=O)for(Z=Z<<1&_,d=0;x>d;d++)P=q+E[d],T=R+k[d],M=B[P][T],M&&(M=A[d],Z|=M);else for(Z=0,L=p-1,d=0;p>d;d++,L--)T=R+g[d],T>=0&&t>T&&(P=q+m[d],P>=0&&(M=B[P][T],M&&(Z|=M<<L)));var H=F.readBit(N,Z);z[R]=H}}return B}function d(e,t,r,n,i,a,o,s,c){var u=A[r].coding;0===r&&(u=u.concat([s[0]]));var l,h=u.length,d=new Int32Array(h),p=new Int32Array(h);for(l=0;h>l;l++)d[l]=u[l].x,p[l]=u[l].y;var g=A[r].reference;0===r&&(g=g.concat([s[1]]));var m=g.length,v=new Int32Array(m),_=new Int32Array(m);for(l=0;m>l;l++)v[l]=g[l].x,_[l]=g[l].y;for(var b=n[0].length,w=n.length,y=R[r],x=[],k=c.decoder,E=c.contextCache.getContexts("GR"),S=0,I=0;t>I;I++){if(o){var P=k.readBit(E,y);S^=P,S&&f("JBIG2 error: prediction is not supported")}var T=new Uint8Array(e);x.push(T);for(var M=0;e>M;M++){var L,C,O=0;for(l=0;h>l;l++)L=I+p[l],C=M+d[l],0>L||0>C||C>=e?O<<=1:O=O<<1|x[L][C];for(l=0;m>l;l++)L=I+_[l]+a,C=M+v[l]+i,0>L||L>=w||0>C||C>=b?O<<=1:O=O<<1|n[L][C];var D=k.readBit(E,O);T[M]=D}}return x}function p(e,r,n,i,a,o,s,l,p,m,v){e&&f("JBIG2 error: huffman is not supported");for(var _=[],b=0,w=t(n.length+i),y=v.decoder,x=v.contextCache;_.length<i;){var k=c(x,"IADH",y);b+=k;for(var E=0,S=0;;){var A=c(x,"IADW",y);if(null===A)break;E+=A,S+=E;var I;if(r){var R=c(x,"IAAI",y);if(R>1)I=g(e,r,E,b,0,R,1,n.concat(_),w,0,0,1,0,o,p,m,v);else{var P=u(x,y,w),T=c(x,"IARDX",y),M=c(x,"IARDY",y),L=P<n.length?n[P]:_[P-n.length];I=d(E,b,p,L,T,M,!1,m,v)}}else I=h(!1,E,b,s,!1,null,l,v);_.push(I)}}for(var C=[],O=[],D=!1,U=n.length+i;O.length<U;){for(var z=c(x,"IAEX",y);z--;)O.push(D);D=!D}for(var B=0,F=n.length;F>B;B++)O[B]&&C.push(n[B]);for(var N=0;i>N;B++,N++)O[B]&&C.push(_[N]);return C}function g(e,t,r,n,i,a,o,s,l,h,p,g,m,v,_,b,w){e&&f("JBIG2 error: huffman is not supported");var y,x,k=[];for(y=0;n>y;y++){if(x=new Uint8Array(r),i)for(var E=0;r>E;E++)x[E]=i;k.push(x)}var S=w.decoder,A=w.contextCache,I=-c(A,"IADT",S),R=0;for(y=0;a>y;){var P=c(A,"IADT",S);I+=P;var T=c(A,"IAFS",S);R+=T;for(var M=R;;){var L=1===o?0:c(A,"IAIT",S),C=o*I+L,O=u(A,S,l),D=t&&c(A,"IARI",S),U=s[O],z=U[0].length,B=U.length;if(D){var F=c(A,"IARDW",S),N=c(A,"IARDH",S),j=c(A,"IARDX",S),Z=c(A,"IARDY",S);z+=F,B+=N,U=d(z,B,_,U,(F>>1)+j,(N>>1)+Z,!1,b,w)}var q,G,H,Y=C-(1&g?0:B),W=M-(2&g?z:0);if(h){for(q=0;B>q;q++)if(x=k[W+q]){H=U[q];var X=Math.min(r-Y,z);switch(m){case 0:for(G=0;X>G;G++)x[Y+G]|=H[G];break;case 2:for(G=0;X>G;G++)x[Y+G]^=H[G];break;default:f("JBIG2 error: operator "+m+" is not supported")}}M+=B-1}else{for(G=0;B>G;G++)if(x=k[Y+G])switch(H=U[G],m){case 0:for(q=0;z>q;q++)x[W+q]|=H[q];break;case 2:for(q=0;z>q;q++)x[W+q]^=H[q];break;default:f("JBIG2 error: operator "+m+" is not supported")}M+=z-1}y++;var J=c(A,"IADS",S);if(null===J)break;M+=J+p}}return k}function m(e,t){var r={};r.number=i(e,t);var a=e[t+4],o=63&a;E[o]||f("JBIG2 error: invalid segment type: "+o),r.type=o,r.typeName=E[o],r.deferredNonRetain=!!(128&a);var s=!!(64&a),c=e[t+5],u=c>>5&7,l=[31&c],h=t+6;if(7===c){u=536870911&i(e,h-1),h+=3;var d=u+7>>3;for(l[0]=e[h++];--d>0;)l.push(e[h++])}else 5!==c&&6!==c||f("JBIG2 error: invalid referred-to flags");r.retainBits=l;var p,g,m=r.number<=256?1:r.number<=65536?2:4,v=[];for(p=0;u>p;p++){var b=1===m?e[h]:2===m?n(e,h):i(e,h);v.push(b),h+=m}if(r.referredTo=v,s?(r.pageAssociation=i(e,h),h+=4):r.pageAssociation=e[h++],r.length=i(e,h),h+=4,4294967295===r.length)if(38===o){var w=_(e,h),y=e[h+P],x=!!(1&y),k=6,S=new Uint8Array(k);for(x||(S[0]=255,S[1]=172),S[2]=w.height>>>24&255,S[3]=w.height>>16&255,S[4]=w.height>>8&255,S[5]=255&w.height,p=h,g=e.length;g>p;p++){for(var A=0;k>A&&S[A]===e[p+A];)A++;if(A===k){r.length=p+k;break}}4294967295===r.length&&f("JBIG2 error: segment end was not found")}else f("JBIG2 error: invalid unknown segment length");return r.headerEnd=h,r}function v(e,t,r,n){for(var i=[],a=r;n>a;){var o=m(t,a);a=o.headerEnd;var s={header:o,data:t};if(e.randomAccess||(s.start=a,a+=o.length,s.end=a),i.push(s),51===o.type)break}if(e.randomAccess)for(var c=0,u=i.length;u>c;c++)i[c].start=a,a+=i[c].header.length,i[c].end=a;return i}function _(e,t){return{width:i(e,t),height:i(e,t+4),x:i(e,t+8),y:i(e,t+12),combinationOperator:7&e[t+16]}}function b(e,t){var a,o,s,c,u=e.header,l=e.data,h=e.start,d=e.end;switch(u.type){case 0:var p={},g=n(l,h);if(p.huffman=!!(1&g),p.refinement=!!(2&g),p.huffmanDHSelector=g>>2&3,p.huffmanDWSelector=g>>4&3,p.bitmapSizeSelector=g>>6&1,p.aggregationInstancesSelector=g>>7&1,p.bitmapCodingContextUsed=!!(256&g),p.bitmapCodingContextRetained=!!(512&g),p.template=g>>10&3,p.refinementTemplate=g>>12&1,h+=2,!p.huffman){for(c=0===p.template?4:1,o=[],s=0;c>s;s++)o.push({x:r(l,h),y:r(l,h+1)}),h+=2;p.at=o}if(p.refinement&&!p.refinementTemplate){for(o=[],s=0;2>s;s++)o.push({x:r(l,h),y:r(l,h+1)}),h+=2;p.refinementAt=o}p.numberOfExportedSymbols=i(l,h),h+=4,p.numberOfNewSymbols=i(l,h),h+=4,a=[p,u.number,u.referredTo,l,h,d];break;case 6:case 7:var m={};m.info=_(l,h),h+=P;var v=n(l,h);if(h+=2,m.huffman=!!(1&v),m.refinement=!!(2&v),m.stripSize=1<<(v>>2&3),m.referenceCorner=v>>4&3,m.transposed=!!(64&v),m.combinationOperator=v>>7&3,m.defaultPixelValue=v>>9&1,m.dsOffset=v<<17>>27,m.refinementTemplate=v>>15&1,m.huffman){var b=n(l,h);h+=2,m.huffmanFS=3&b,m.huffmanDS=b>>2&3,m.huffmanDT=b>>4&3,m.huffmanRefinementDW=b>>6&3,m.huffmanRefinementDH=b>>8&3,m.huffmanRefinementDX=b>>10&3,m.huffmanRefinementDY=b>>12&3,m.huffmanRefinementSizeSelector=!!(14&b)}if(m.refinement&&!m.refinementTemplate){for(o=[],s=0;2>s;s++)o.push({x:r(l,h),y:r(l,h+1)}),h+=2;m.refinementAt=o}m.numberOfSymbolInstances=i(l,h),h+=4,m.huffman&&f("JBIG2 error: huffman is not supported"),a=[m,u.referredTo,l,h,d];break;case 38:case 39:var w={};w.info=_(l,h),h+=P;var y=l[h++];if(w.mmr=!!(1&y),w.template=y>>1&3,w.prediction=!!(8&y),!w.mmr){for(c=0===w.template?4:1,o=[],s=0;c>s;s++)o.push({x:r(l,h),y:r(l,h+1)}),h+=2;w.at=o}a=[w,l,h,d];break;case 48:var x={width:i(l,h),height:i(l,h+4),resolutionX:i(l,h+8),resolutionY:i(l,h+12)};4294967295===x.height&&delete x.height;var k=l[h+16];n(l,h+17);x.lossless=!!(1&k),x.refinement=!!(2&k),x.defaultPixelValue=k>>2&1,x.combinationOperator=k>>3&3,x.requiresBuffer=!!(32&k),x.combinationOperatorOverride=!!(64&k),a=[x];break;case 49:break;case 50:break;case 51:break;case 62:break;default:f("JBIG2 error: segment type "+u.typeName+"("+u.type+") is not implemented")}var E="on"+u.typeName;E in t&&t[E].apply(t,a)}function w(e,t){for(var r=0,n=e.length;n>r;r++)b(e[r],t)}function y(e){for(var t=new x,r=0,n=e.length;n>r;r++){var i=e[r],a=v({},i.data,i.start,i.end);w(a,t)}return t}function x(){}function k(){}e.prototype={getContexts:function(e){return e in this?this[e]:this[e]=new Int8Array(65536)}},o.prototype={get decoder(){var e=new s(this.data,this.start,this.end);return a(this,"decoder",e)},get contextCache(){var t=new e;return a(this,"contextCache",t)}};var E=["SymbolDictionary",null,null,null,"IntermediateTextRegion",null,"ImmediateTextRegion","ImmediateLosslessTextRegion",null,null,null,null,null,null,null,null,"patternDictionary",null,null,null,"IntermediateHalftoneRegion",null,"ImmediateHalftoneRegion","ImmediateLosslessHalftoneRegion",null,null,null,null,null,null,null,null,null,null,null,null,"IntermediateGenericRegion",null,"ImmediateGenericRegion","ImmediateLosslessGenericRegion","IntermediateGenericRefinementRegion",null,"ImmediateGenericRefinementRegion","ImmediateLosslessGenericRefinementRegion",null,null,null,null,"PageInformation","EndOfPage","EndOfStripe","EndOfFile","Profiles","Tables",null,null,null,null,null,null,null,null,"Extension"],S=[[{x:-1,y:-2},{x:0,y:-2},{x:1,y:-2},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:2,y:-1},{x:-4,y:0},{x:-3,y:0},{x:-2,y:0},{x:-1,y:0}],[{x:-1,y:-2},{x:0,y:-2},{x:1,y:-2},{x:2,y:-2},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:2,y:-1},{x:-3,y:0},{x:-2,y:0},{x:-1,y:0}],[{x:-1,y:-2},{x:0,y:-2},{x:1,y:-2},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:-2,y:0},{x:-1,y:0}],[{x:-3,y:-1},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:-4,y:0},{x:-3,y:0},{x:-2,y:0},{x:-1,y:0}]],A=[{coding:[{x:0,y:-1},{x:1,y:-1},{x:-1,y:0}],reference:[{x:0,y:-1},{x:1,y:-1},{x:-1,y:0},{x:0,y:0},{x:1,y:0},{x:-1,y:1},{x:0,y:1},{x:1,y:1}]},{coding:[{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:-1,y:0}],reference:[{x:0,y:-1},{x:-1,y:0},{x:0,y:0},{x:1,y:0},{x:0,y:1},{x:1,y:1}]}],I=[39717,1941,229,405],R=[32,8],P=17;return x.prototype={onPageInformation:function(e){this.currentPageInfo=e;var t=e.width+7>>3,r=new Uint8Array(t*e.height);if(e.defaultPixelValue)for(var n=0,i=r.length;i>n;n++)r[n]=255;this.buffer=r},drawBitmap:function(e,t){var r,n,i,a,o=this.currentPageInfo,s=e.width,c=e.height,u=o.width+7>>3,l=o.combinationOperatorOverride?e.combinationOperator:o.combinationOperator,h=this.buffer,d=128>>(7&e.x),p=e.y*u+(e.x>>3);switch(l){case 0:for(r=0;c>r;r++){for(i=d,a=p,n=0;s>n;n++)t[r][n]&&(h[a]|=i),i>>=1,i||(i=128,a++);p+=u}break;case 2:for(r=0;c>r;r++){for(i=d,a=p,n=0;s>n;n++)t[r][n]&&(h[a]^=i),i>>=1,i||(i=128,a++);p+=u}break;default:f("JBIG2 error: operator "+l+" is not supported")}},onImmediateGenericRegion:function(e,t,r,n){var i=e.info,a=new o(t,r,n),s=h(e.mmr,i.width,i.height,e.template,e.prediction,null,e.at,a);this.drawBitmap(i,s)},onImmediateLosslessGenericRegion:function(){this.onImmediateGenericRegion.apply(this,arguments)},onSymbolDictionary:function(e,t,r,n,i,a){var s;e.huffman&&f("JBIG2 error: huffman is not supported");var c=this.symbols;c||(this.symbols=c={});for(var u=[],l=0,h=r.length;h>l;l++)u=u.concat(c[r[l]]);var d=new o(n,i,a);c[t]=p(e.huffman,e.refinement,u,e.numberOfNewSymbols,e.numberOfExportedSymbols,s,e.template,e.at,e.refinementTemplate,e.refinementAt,d)},onImmediateTextRegion:function(e,r,n,i,a){for(var s,c=e.info,u=this.symbols,f=[],l=0,h=r.length;h>l;l++)f=f.concat(u[r[l]]);var d=t(f.length),p=new o(n,i,a),m=g(e.huffman,e.refinement,c.width,c.height,e.defaultPixelValue,e.numberOfSymbolInstances,e.stripSize,f,d,e.transposed,e.dsOffset,e.referenceCorner,e.combinationOperator,s,e.refinementTemplate,e.refinementAt,p);this.drawBitmap(c,m)},onImmediateLosslessTextRegion:function(){this.onImmediateTextRegion.apply(this,arguments)}},k.prototype={parseChunks:function(e){return y(e)}},k}(),f=function(){throw console.error.apply(console,arguments),new Error("PDFJS error: "+arguments[0])},l=function(){console.warn.apply(console,arguments)},h=function(){console.info.apply(console,arguments)};u.prototype.parse=function(e){var t=0,r=e.length;151===e[t]&&74===e[t+1]&&66===e[t+2]&&50===e[t+3]&&13===e[t+4]&&10===e[t+5]&&26===e[t+6]&&10===e[t+7]||f("JBIG2 error: invalid header");var n={};t+=8;var a=e[t++];n.randomAccess=!(1&a),2&a||(n.numberOfPages=i(e,t),t+=4);for(var o=this.parseChunks([{data:e,start:t,end:r}]),s=o.currentPageInfo.width,c=o.currentPageInfo.height,u=o.buffer,e=new Uint8Array(s*c),l=0,h=0,d=0;c>d;d++)for(var p,g=0,m=0;s>m;m++)g||(g=128,p=u[h++]),e[l++]=p&g?0:255,g>>=1;this.width=s,this.height=c,this.data=e},e.JpegImage=o,e.JpxImage=c,e.Jbig2Image=u}(a||(a={}));var o=a.JpegImage,s=a.JpxImage,c=a.Jbig2Image},{}],5:[function(e,t,r){(function(e){"use strict";function r(t){return t instanceof ArrayBuffer?s(t):e.isBuffer(t)?t:t instanceof Uint8Array?new e(t):t}function n(t){return t instanceof ArrayBuffer?t:e.isBuffer(t)?o(t):t instanceof Uint8Array?o(t):t}function i(t){return t instanceof Uint8Array?t:t instanceof ArrayBuffer?new Uint8Array(t):e.isBuffer(t)?new Uint8Array(t):t}function a(t){return t instanceof Uint8Array?t:t instanceof ArrayBuffer?new Uint8Array(t):e.isBuffer(t)?t:t}function o(e){for(var t=new ArrayBuffer(e.length),r=new Uint8Array(t),n=0;n<e.length;++n)r[n]=e[n];return t}function s(t){return new e(new Uint8Array(t))}t.exports.toBuffer=r,t.exports.toArrayBuffer=n,t.exports.toUint8Array=i,t.exports.toArrayLike=a,t.exports.bufferToArrayBuffer=o,t.exports.arrayBufferToBuffer=s}).call(this,e("buffer").Buffer)},{buffer:21}],6:[function(e,t,r){"use strict";t.exports=function(t){var r=e("./decode");t.onmessage=function(e){var n=e.data;r(n.buf,n.options,function(e,r){if(e){var n=e instanceof Error?e.message:e;t.postMessage({err:n})}else t.postMessage({result:r})})}}},{"./decode":7}],7:[function(e,t,r){"use strict";function n(e,t,r){function n(e,t,r){var n={width:t,height:r,data:new Uint8Array(t*r*4)};return e.copyToImageData(n),n.data}try{var a=new i;a.parse(e);var o=t.width||a.width,s=t.height||a.height,c=n(a,o,s),u={width:o,height:s,data:c};r(null,u)}catch(f){"string"==typeof f&&(f=new Error(f)),r(f)}}var i=e("./backend/jpg").JpegImage;t.exports=n},{"./backend/jpg":4}],8:[function(e,t,r){"use strict";t.exports=function(t){var r=e("./encode");t.onmessage=function(e){var n=e.data;r(n.buf,n.options,function(e,r){if(e){var n=e instanceof Error?e.message:e;t.postMessage({err:n})}else t.postMessage({result:r})})}}},{"./encode":9}],9:[function(e,t,r){"use strict";function n(e,t,r){try{var n={data:e,width:t.width,height:t.height},a=i(n,t.quality);r(null,a)}catch(o){r(o)}}var i=e("./backend/encoder");t.exports=n},{"./backend/encoder":3}],10:[function(e,t,r){"use strict";t.exports=function(t){var r=e("./exif");t.onmessage=function(e){var n=e.data;r(n.buf,{},function(e,r){if(e){var n=e instanceof Error?e.message:e;t.postMessage({err:n})}else t.postMessage({result:r})})}}},{"./exif":11}],11:[function(e,t,r){"use strict";function n(e,t,r){try{var n=new i;n.load(e),t.hasOwnProperty("hasMakerNote")&&t.hasMakerNote||n.deleteTag("MakerNote");var a=n.getAllTags();r(null,a)}catch(o){"No Exif data"===o.message?r(null,{}):r(o)}}var i=e("./backend/ExifReader").ExifReader;t.exports=n},{"./backend/ExifReader":2}],12:[function(e,t,r){"use strict";var n="undefined"!=typeof window&&"Worker"in window;if(n)try{var i=e("webworkify")(function(){});i.terminate()}catch(a){n=!1}t.exports.HAS_WORKER=n},{webworkify:59}],13:[function(e,t,r){"use strict";function n(e,t){setTimeout(function(){var r=i(e);r?t(null,{type:r.type,mimeType:r.mimeType,extension:r.format.toLowerCase(),width:r.width,height:r.height}):t(new Error("Cannot get image info"))},0)}var i=e("imageinfo");t.exports.collect=n},{imageinfo:27}],14:[function(e,t,r){t.exports={474946383961:{mimeType:"image/gif",extension:"gif"},474946383761:{mimeType:"image/gif",extension:"gif"},"89504e470d0a1a0a":{mimeType:"image/png",extension:"png"},ffd8ff:{mimeType:"image/jpeg",extension:"jpg"},57454250:{mimeType:"image/webp",extension:"webp"},"49492a00":{mimeType:"image/tiff",extension:"tiff"},"4d4d002a":{mimeType:"image/tiff",extension:"tiff"},"424d":{mimeType:"image/bmp",extension:"bmp"},"000000146674797069736f6d":{mimeType:"video/mp4",extension:"mp4"},"000000186674797033677035":{mimeType:"video/mp4",extension:"mp4"},"000000146674797071742020":{mimeType:"video/quicktime",extension:"mov"},"1a45dfa3":{mimeType:"video/webm",extension:"webm"},25504446:{mimeType:"application/pdf",extension:"pdf"}}},{}],15:[function(e,t,r){"use strict";function n(e,t){setTimeout(function(){var r=24,n=e.slice(0,r).toString("hex"),s=Object.keys(a),c=i(s,function(e){return o("%s <---- %s",n,e),-1!=n.indexOf(e)});c?t(null,a[c]):t(new Error("Magic number not found"))},0)}var i=e("lodash.find"),a=e("./magic-db"),o=e("debug")("inkjet:magic");t.exports.lookup=n},{"./magic-db":14,debug:23,"lodash.find":35}],16:[function(e,t,r){function n(e,t){return d.isUndefined(t)?""+t:d.isNumber(t)&&!isFinite(t)?t.toString():d.isFunction(t)||d.isRegExp(t)?t.toString():t}function i(e,t){return d.isString(e)?e.length<t?e:e.slice(0,t):e}function a(e){return i(JSON.stringify(e.actual,n),128)+" "+e.operator+" "+i(JSON.stringify(e.expected,n),128)}function o(e,t,r,n,i){throw new m.AssertionError({message:r,actual:e,expected:t,operator:n,stackStartFunction:i})}function s(e,t){e||o(e,!0,t,"==",m.ok)}function c(e,t){if(e===t)return!0;if(d.isBuffer(e)&&d.isBuffer(t)){if(e.length!=t.length)return!1;for(var r=0;r<e.length;r++)if(e[r]!==t[r])return!1;return!0}return d.isDate(e)&&d.isDate(t)?e.getTime()===t.getTime():d.isRegExp(e)&&d.isRegExp(t)?e.source===t.source&&e.global===t.global&&e.multiline===t.multiline&&e.lastIndex===t.lastIndex&&e.ignoreCase===t.ignoreCase:d.isObject(e)||d.isObject(t)?f(e,t):e==t}function u(e){return"[object Arguments]"==Object.prototype.toString.call(e)}function f(e,t){if(d.isNullOrUndefined(e)||d.isNullOrUndefined(t))return!1;if(e.prototype!==t.prototype)return!1;if(d.isPrimitive(e)||d.isPrimitive(t))return e===t;var r=u(e),n=u(t);if(r&&!n||!r&&n)return!1;if(r)return e=p.call(e),t=p.call(t),c(e,t);var i,a,o=v(e),s=v(t);if(o.length!=s.length)return!1;for(o.sort(),s.sort(),a=o.length-1;a>=0;a--)if(o[a]!=s[a])return!1;for(a=o.length-1;a>=0;a--)if(i=o[a],!c(e[i],t[i]))return!1;return!0}function l(e,t){return e&&t?"[object RegExp]"==Object.prototype.toString.call(t)?t.test(e):e instanceof t?!0:t.call({},e)===!0:!1}function h(e,t,r,n){var i;d.isString(r)&&(n=r,r=null);try{t()}catch(a){i=a}if(n=(r&&r.name?" ("+r.name+").":".")+(n?" "+n:"."),e&&!i&&o(i,r,"Missing expected exception"+n),!e&&l(i,r)&&o(i,r,"Got unwanted exception"+n),e&&i&&r&&!l(i,r)||!e&&i)throw i}var d=e("util/"),p=Array.prototype.slice,g=Object.prototype.hasOwnProperty,m=t.exports=s;m.AssertionError=function(e){this.name="AssertionError",this.actual=e.actual,this.expected=e.expected,this.operator=e.operator,e.message?(this.message=e.message,this.generatedMessage=!1):(this.message=a(this),this.generatedMessage=!0);var t=e.stackStartFunction||o;if(Error.captureStackTrace)Error.captureStackTrace(this,t);else{var r=new Error;if(r.stack){var n=r.stack,i=t.name,s=n.indexOf("\n"+i);if(s>=0){var c=n.indexOf("\n",s+1);n=n.substring(c+1)}this.stack=n}}},d.inherits(m.AssertionError,Error),m.fail=o,m.ok=s,m.equal=function(e,t,r){e!=t&&o(e,t,r,"==",m.equal)},m.notEqual=function(e,t,r){e==t&&o(e,t,r,"!=",m.notEqual)},m.deepEqual=function(e,t,r){c(e,t)||o(e,t,r,"deepEqual",m.deepEqual)},m.notDeepEqual=function(e,t,r){c(e,t)&&o(e,t,r,"notDeepEqual",m.notDeepEqual)},m.strictEqual=function(e,t,r){e!==t&&o(e,t,r,"===",m.strictEqual)},m.notStrictEqual=function(e,t,r){e===t&&o(e,t,r,"!==",m.notStrictEqual)},m["throws"]=function(e,t,r){h.apply(this,[!0].concat(p.call(arguments)))},m.doesNotThrow=function(e,t){h.apply(this,[!1].concat(p.call(arguments)))},m.ifError=function(e){if(e)throw e};var v=Object.keys||function(e){var t=[];for(var r in e)g.call(e,r)&&t.push(r);return t}},{"util/":58}],17:[function(e,t,r){"use strict";function n(){for(var e="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",t=0,r=e.length;r>t;++t)c[t]=e[t],u[e.charCodeAt(t)]=t;u["-".charCodeAt(0)]=62,u["_".charCodeAt(0)]=63}function i(e){var t,r,n,i,a,o,s=e.length;if(s%4>0)throw new Error("Invalid string. Length must be a multiple of 4");a="="===e[s-2]?2:"="===e[s-1]?1:0,o=new f(3*s/4-a),n=a>0?s-4:s;var c=0;for(t=0,r=0;n>t;t+=4,r+=3)i=u[e.charCodeAt(t)]<<18|u[e.charCodeAt(t+1)]<<12|u[e.charCodeAt(t+2)]<<6|u[e.charCodeAt(t+3)],o[c++]=i>>16&255,o[c++]=i>>8&255,o[c++]=255&i;return 2===a?(i=u[e.charCodeAt(t)]<<2|u[e.charCodeAt(t+1)]>>4,o[c++]=255&i):1===a&&(i=u[e.charCodeAt(t)]<<10|u[e.charCodeAt(t+1)]<<4|u[e.charCodeAt(t+2)]>>2,o[c++]=i>>8&255,o[c++]=255&i),o}function a(e){return c[e>>18&63]+c[e>>12&63]+c[e>>6&63]+c[63&e]}function o(e,t,r){for(var n,i=[],o=t;r>o;o+=3)n=(e[o]<<16)+(e[o+1]<<8)+e[o+2],i.push(a(n));return i.join("")}function s(e){for(var t,r=e.length,n=r%3,i="",a=[],s=16383,u=0,f=r-n;f>u;u+=s)a.push(o(e,u,u+s>f?f:u+s));return 1===n?(t=e[r-1],i+=c[t>>2],i+=c[t<<4&63],i+="=="):2===n&&(t=(e[r-2]<<8)+e[r-1],i+=c[t>>10],i+=c[t>>4&63],i+=c[t<<2&63],i+="="),a.push(i),a.join("")}r.toByteArray=i,r.fromByteArray=s;var c=[],u=[],f="undefined"!=typeof Uint8Array?Uint8Array:Array;n()},{}],18:[function(e,t,r){},{}],19:[function(e,t,r){(function(t,n){function i(e){if(e<r.DEFLATE||e>r.UNZIP)throw new TypeError("Bad argument");this.mode=e,this.init_done=!1,this.write_in_progress=!1,this.pending_close=!1,this.windowBits=0,this.level=0,this.memLevel=0,this.strategy=0,this.dictionary=null}function a(e,t){for(var r=0;r<e.length;r++)this[t+r]=e[r]}var o=e("pako/lib/zlib/messages"),s=e("pako/lib/zlib/zstream"),c=e("pako/lib/zlib/deflate.js"),u=e("pako/lib/zlib/inflate.js"),f=e("pako/lib/zlib/constants");for(var l in f)r[l]=f[l];r.NONE=0,r.DEFLATE=1,r.INFLATE=2,r.GZIP=3,r.GUNZIP=4,r.DEFLATERAW=5,r.INFLATERAW=6,r.UNZIP=7,i.prototype.init=function(e,t,n,i,a){switch(this.windowBits=e,this.level=t,this.memLevel=n,this.strategy=i,this.mode!==r.GZIP&&this.mode!==r.GUNZIP||(this.windowBits+=16),this.mode===r.UNZIP&&(this.windowBits+=32),this.mode!==r.DEFLATERAW&&this.mode!==r.INFLATERAW||(this.windowBits=-this.windowBits),this.strm=new s,this.mode){case r.DEFLATE:case r.GZIP:case r.DEFLATERAW:var o=c.deflateInit2(this.strm,this.level,r.Z_DEFLATED,this.windowBits,this.memLevel,this.strategy);break;case r.INFLATE:case r.GUNZIP:case r.INFLATERAW:case r.UNZIP:var o=u.inflateInit2(this.strm,this.windowBits);break;default:throw new Error("Unknown mode "+this.mode)}return o!==r.Z_OK?void this._error(o):(this.write_in_progress=!1,void(this.init_done=!0))},i.prototype.params=function(){throw new Error("deflateParams Not supported")},i.prototype._writeCheck=function(){if(!this.init_done)throw new Error("write before init");if(this.mode===r.NONE)throw new Error("already finalized");if(this.write_in_progress)throw new Error("write already in progress");if(this.pending_close)throw new Error("close is pending")},i.prototype.write=function(e,r,n,i,a,o,s){this._writeCheck(),this.write_in_progress=!0;var c=this;return t.nextTick(function(){c.write_in_progress=!1;var t=c._write(e,r,n,i,a,o,s);c.callback(t[0],t[1]),c.pending_close&&c.close()}),this},i.prototype.writeSync=function(e,t,r,n,i,a,o){return this._writeCheck(),this._write(e,t,r,n,i,a,o)},i.prototype._write=function(e,t,i,o,s,f,l){if(this.write_in_progress=!0,e!==r.Z_NO_FLUSH&&e!==r.Z_PARTIAL_FLUSH&&e!==r.Z_SYNC_FLUSH&&e!==r.Z_FULL_FLUSH&&e!==r.Z_FINISH&&e!==r.Z_BLOCK)throw new Error("Invalid flush value");null==t&&(t=new n(0),o=0,i=0),s._set?s.set=s._set:s.set=a;var h=this.strm;switch(h.avail_in=o,h.input=t,h.next_in=i,h.avail_out=l,h.output=s,h.next_out=f,this.mode){case r.DEFLATE:case r.GZIP:case r.DEFLATERAW:var d=c.deflate(h,e);break;case r.UNZIP:case r.INFLATE:case r.GUNZIP:case r.INFLATERAW:var d=u.inflate(h,e);break;default:throw new Error("Unknown mode "+this.mode)}return d!==r.Z_STREAM_END&&d!==r.Z_OK&&this._error(d),this.write_in_progress=!1,[h.avail_in,h.avail_out]},i.prototype.close=function(){return this.write_in_progress?void(this.pending_close=!0):(this.pending_close=!1,this.mode===r.DEFLATE||this.mode===r.GZIP||this.mode===r.DEFLATERAW?c.deflateEnd(this.strm):u.inflateEnd(this.strm),void(this.mode=r.NONE))},i.prototype.reset=function(){switch(this.mode){case r.DEFLATE:case r.DEFLATERAW:var e=c.deflateReset(this.strm);break;case r.INFLATE:case r.INFLATERAW:var e=u.inflateReset(this.strm)}e!==r.Z_OK&&this._error(e)},i.prototype._error=function(e){this.onerror(o[e]+": "+this.strm.msg,e),this.write_in_progress=!1,this.pending_close&&this.close()},r.Zlib=i}).call(this,e("_process"),e("buffer").Buffer)},{_process:49,buffer:21,"pako/lib/zlib/constants":39,"pako/lib/zlib/deflate.js":41,"pako/lib/zlib/inflate.js":43,"pako/lib/zlib/messages":45,"pako/lib/zlib/zstream":47}],20:[function(e,t,r){(function(t,n){function i(e,t,r){function i(){for(var t;null!==(t=e.read());)s.push(t),c+=t.length;e.once("readable",i)}function a(t){e.removeListener("end",o),e.removeListener("readable",i),r(t)}function o(){var t=n.concat(s,c);s=[],r(null,t),e.close()}var s=[],c=0;e.on("error",a),e.on("end",o),e.end(t),i()}function a(e,t){if("string"==typeof t&&(t=new n(t)),!n.isBuffer(t))throw new TypeError("Not a string or buffer");var r=g.Z_FINISH;return e._processChunk(t,r)}function o(e){return this instanceof o?void d.call(this,e,g.DEFLATE):new o(e)}function s(e){return this instanceof s?void d.call(this,e,g.INFLATE):new s(e)}function c(e){return this instanceof c?void d.call(this,e,g.GZIP):new c(e)}function u(e){return this instanceof u?void d.call(this,e,g.GUNZIP):new u(e)}function f(e){return this instanceof f?void d.call(this,e,g.DEFLATERAW):new f(e)}function l(e){return this instanceof l?void d.call(this,e,g.INFLATERAW):new l(e)}function h(e){return this instanceof h?void d.call(this,e,g.UNZIP):new h(e)}function d(e,t){if(this._opts=e=e||{},this._chunkSize=e.chunkSize||r.Z_DEFAULT_CHUNK,p.call(this,e),e.flush&&e.flush!==g.Z_NO_FLUSH&&e.flush!==g.Z_PARTIAL_FLUSH&&e.flush!==g.Z_SYNC_FLUSH&&e.flush!==g.Z_FULL_FLUSH&&e.flush!==g.Z_FINISH&&e.flush!==g.Z_BLOCK)throw new Error("Invalid flush flag: "+e.flush);if(this._flushFlag=e.flush||g.Z_NO_FLUSH,e.chunkSize&&(e.chunkSize<r.Z_MIN_CHUNK||e.chunkSize>r.Z_MAX_CHUNK))throw new Error("Invalid chunk size: "+e.chunkSize);if(e.windowBits&&(e.windowBits<r.Z_MIN_WINDOWBITS||e.windowBits>r.Z_MAX_WINDOWBITS))throw new Error("Invalid windowBits: "+e.windowBits);if(e.level&&(e.level<r.Z_MIN_LEVEL||e.level>r.Z_MAX_LEVEL))throw new Error("Invalid compression level: "+e.level);if(e.memLevel&&(e.memLevel<r.Z_MIN_MEMLEVEL||e.memLevel>r.Z_MAX_MEMLEVEL))throw new Error("Invalid memLevel: "+e.memLevel);if(e.strategy&&e.strategy!=r.Z_FILTERED&&e.strategy!=r.Z_HUFFMAN_ONLY&&e.strategy!=r.Z_RLE&&e.strategy!=r.Z_FIXED&&e.strategy!=r.Z_DEFAULT_STRATEGY)throw new Error("Invalid strategy: "+e.strategy);if(e.dictionary&&!n.isBuffer(e.dictionary))throw new Error("Invalid dictionary: it should be a Buffer instance");
this._binding=new g.Zlib(t);var i=this;this._hadError=!1,this._binding.onerror=function(e,t){i._binding=null,i._hadError=!0;var n=new Error(e);n.errno=t,n.code=r.codes[t],i.emit("error",n)};var a=r.Z_DEFAULT_COMPRESSION;"number"==typeof e.level&&(a=e.level);var o=r.Z_DEFAULT_STRATEGY;"number"==typeof e.strategy&&(o=e.strategy),this._binding.init(e.windowBits||r.Z_DEFAULT_WINDOWBITS,a,e.memLevel||r.Z_DEFAULT_MEMLEVEL,o,e.dictionary),this._buffer=new n(this._chunkSize),this._offset=0,this._closed=!1,this._level=a,this._strategy=o,this.once("end",this.close)}var p=e("_stream_transform"),g=e("./binding"),m=e("util"),v=e("assert").ok;g.Z_MIN_WINDOWBITS=8,g.Z_MAX_WINDOWBITS=15,g.Z_DEFAULT_WINDOWBITS=15,g.Z_MIN_CHUNK=64,g.Z_MAX_CHUNK=1/0,g.Z_DEFAULT_CHUNK=16384,g.Z_MIN_MEMLEVEL=1,g.Z_MAX_MEMLEVEL=9,g.Z_DEFAULT_MEMLEVEL=8,g.Z_MIN_LEVEL=-1,g.Z_MAX_LEVEL=9,g.Z_DEFAULT_LEVEL=g.Z_DEFAULT_COMPRESSION,Object.keys(g).forEach(function(e){e.match(/^Z/)&&(r[e]=g[e])}),r.codes={Z_OK:g.Z_OK,Z_STREAM_END:g.Z_STREAM_END,Z_NEED_DICT:g.Z_NEED_DICT,Z_ERRNO:g.Z_ERRNO,Z_STREAM_ERROR:g.Z_STREAM_ERROR,Z_DATA_ERROR:g.Z_DATA_ERROR,Z_MEM_ERROR:g.Z_MEM_ERROR,Z_BUF_ERROR:g.Z_BUF_ERROR,Z_VERSION_ERROR:g.Z_VERSION_ERROR},Object.keys(r.codes).forEach(function(e){r.codes[r.codes[e]]=e}),r.Deflate=o,r.Inflate=s,r.Gzip=c,r.Gunzip=u,r.DeflateRaw=f,r.InflateRaw=l,r.Unzip=h,r.createDeflate=function(e){return new o(e)},r.createInflate=function(e){return new s(e)},r.createDeflateRaw=function(e){return new f(e)},r.createInflateRaw=function(e){return new l(e)},r.createGzip=function(e){return new c(e)},r.createGunzip=function(e){return new u(e)},r.createUnzip=function(e){return new h(e)},r.deflate=function(e,t,r){return"function"==typeof t&&(r=t,t={}),i(new o(t),e,r)},r.deflateSync=function(e,t){return a(new o(t),e)},r.gzip=function(e,t,r){return"function"==typeof t&&(r=t,t={}),i(new c(t),e,r)},r.gzipSync=function(e,t){return a(new c(t),e)},r.deflateRaw=function(e,t,r){return"function"==typeof t&&(r=t,t={}),i(new f(t),e,r)},r.deflateRawSync=function(e,t){return a(new f(t),e)},r.unzip=function(e,t,r){return"function"==typeof t&&(r=t,t={}),i(new h(t),e,r)},r.unzipSync=function(e,t){return a(new h(t),e)},r.inflate=function(e,t,r){return"function"==typeof t&&(r=t,t={}),i(new s(t),e,r)},r.inflateSync=function(e,t){return a(new s(t),e)},r.gunzip=function(e,t,r){return"function"==typeof t&&(r=t,t={}),i(new u(t),e,r)},r.gunzipSync=function(e,t){return a(new u(t),e)},r.inflateRaw=function(e,t,r){return"function"==typeof t&&(r=t,t={}),i(new l(t),e,r)},r.inflateRawSync=function(e,t){return a(new l(t),e)},m.inherits(d,p),d.prototype.params=function(e,n,i){if(e<r.Z_MIN_LEVEL||e>r.Z_MAX_LEVEL)throw new RangeError("Invalid compression level: "+e);if(n!=r.Z_FILTERED&&n!=r.Z_HUFFMAN_ONLY&&n!=r.Z_RLE&&n!=r.Z_FIXED&&n!=r.Z_DEFAULT_STRATEGY)throw new TypeError("Invalid strategy: "+n);if(this._level!==e||this._strategy!==n){var a=this;this.flush(g.Z_SYNC_FLUSH,function(){a._binding.params(e,n),a._hadError||(a._level=e,a._strategy=n,i&&i())})}else t.nextTick(i)},d.prototype.reset=function(){return this._binding.reset()},d.prototype._flush=function(e){this._transform(new n(0),"",e)},d.prototype.flush=function(e,r){var i=this._writableState;if(("function"==typeof e||void 0===e&&!r)&&(r=e,e=g.Z_FULL_FLUSH),i.ended)r&&t.nextTick(r);else if(i.ending)r&&this.once("end",r);else if(i.needDrain){var a=this;this.once("drain",function(){a.flush(r)})}else this._flushFlag=e,this.write(new n(0),"",r)},d.prototype.close=function(e){if(e&&t.nextTick(e),!this._closed){this._closed=!0,this._binding.close();var r=this;t.nextTick(function(){r.emit("close")})}},d.prototype._transform=function(e,t,r){var i,a=this._writableState,o=a.ending||a.ended,s=o&&(!e||a.length===e.length);if(null===!e&&!n.isBuffer(e))return r(new Error("invalid input"));s?i=g.Z_FINISH:(i=this._flushFlag,e.length>=a.length&&(this._flushFlag=this._opts.flush||g.Z_NO_FLUSH));this._processChunk(e,i,r)},d.prototype._processChunk=function(e,t,r){function i(f,d){if(!c._hadError){var p=o-d;if(v(p>=0,"have should not go down"),p>0){var g=c._buffer.slice(c._offset,c._offset+p);c._offset+=p,u?c.push(g):(l.push(g),h+=g.length)}if((0===d||c._offset>=c._chunkSize)&&(o=c._chunkSize,c._offset=0,c._buffer=new n(c._chunkSize)),0===d){if(s+=a-f,a=f,!u)return!0;var m=c._binding.write(t,e,s,a,c._buffer,c._offset,c._chunkSize);return m.callback=i,void(m.buffer=e)}return u?void r():!1}}var a=e&&e.length,o=this._chunkSize-this._offset,s=0,c=this,u="function"==typeof r;if(!u){var f,l=[],h=0;this.on("error",function(e){f=e});do var d=this._binding.writeSync(t,e,s,a,this._buffer,this._offset,o);while(!this._hadError&&i(d[0],d[1]));if(this._hadError)throw f;var p=n.concat(l,h);return this.close(),p}var g=this._binding.write(t,e,s,a,this._buffer,this._offset,o);g.buffer=e,g.callback=i},m.inherits(o,d),m.inherits(s,d),m.inherits(c,d),m.inherits(u,d),m.inherits(f,d),m.inherits(l,d),m.inherits(h,d)}).call(this,e("_process"),e("buffer").Buffer)},{"./binding":19,_process:49,_stream_transform:54,assert:16,buffer:21,util:58}],21:[function(e,t,r){(function(t){"use strict";function n(){try{var e=new Uint8Array(1);return e.foo=function(){return 42},42===e.foo()&&"function"==typeof e.subarray&&0===e.subarray(1,1).byteLength}catch(t){return!1}}function i(){return a.TYPED_ARRAY_SUPPORT?2147483647:1073741823}function a(e){return this instanceof a?(a.TYPED_ARRAY_SUPPORT||(this.length=0,this.parent=void 0),"number"==typeof e?o(this,e):"string"==typeof e?s(this,e,arguments.length>1?arguments[1]:"utf8"):c(this,e)):arguments.length>1?new a(e,arguments[1]):new a(e)}function o(e,t){if(e=g(e,0>t?0:0|m(t)),!a.TYPED_ARRAY_SUPPORT)for(var r=0;t>r;r++)e[r]=0;return e}function s(e,t,r){"string"==typeof r&&""!==r||(r="utf8");var n=0|_(t,r);return e=g(e,n),e.write(t,r),e}function c(e,t){if(a.isBuffer(t))return u(e,t);if(V(t))return f(e,t);if(null==t)throw new TypeError("must start with number, buffer, array or string");if("undefined"!=typeof ArrayBuffer){if(t.buffer instanceof ArrayBuffer)return l(e,t);if(t instanceof ArrayBuffer)return h(e,t)}return t.length?d(e,t):p(e,t)}function u(e,t){var r=0|m(t.length);return e=g(e,r),t.copy(e,0,0,r),e}function f(e,t){var r=0|m(t.length);e=g(e,r);for(var n=0;r>n;n+=1)e[n]=255&t[n];return e}function l(e,t){var r=0|m(t.length);e=g(e,r);for(var n=0;r>n;n+=1)e[n]=255&t[n];return e}function h(e,t){return t.byteLength,a.TYPED_ARRAY_SUPPORT?(e=new Uint8Array(t),e.__proto__=a.prototype):e=l(e,new Uint8Array(t)),e}function d(e,t){var r=0|m(t.length);e=g(e,r);for(var n=0;r>n;n+=1)e[n]=255&t[n];return e}function p(e,t){var r,n=0;"Buffer"===t.type&&V(t.data)&&(r=t.data,n=0|m(r.length)),e=g(e,n);for(var i=0;n>i;i+=1)e[i]=255&r[i];return e}function g(e,t){a.TYPED_ARRAY_SUPPORT?(e=new Uint8Array(t),e.__proto__=a.prototype):e.length=t;var r=0!==t&&t<=a.poolSize>>>1;return r&&(e.parent=K),e}function m(e){if(e>=i())throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+i().toString(16)+" bytes");return 0|e}function v(e,t){if(!(this instanceof v))return new v(e,t);var r=new a(e,t);return delete r.parent,r}function _(e,t){"string"!=typeof e&&(e=""+e);var r=e.length;if(0===r)return 0;for(var n=!1;;)switch(t){case"ascii":case"binary":case"raw":case"raws":return r;case"utf8":case"utf-8":return q(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*r;case"hex":return r>>>1;case"base64":return Y(e).length;default:if(n)return q(e).length;t=(""+t).toLowerCase(),n=!0}}function b(e,t,r){var n=!1;if(t=0|t,r=void 0===r||r===1/0?this.length:0|r,e||(e="utf8"),0>t&&(t=0),r>this.length&&(r=this.length),t>=r)return"";for(;;)switch(e){case"hex":return M(this,t,r);case"utf8":case"utf-8":return I(this,t,r);case"ascii":return P(this,t,r);case"binary":return T(this,t,r);case"base64":return A(this,t,r);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return L(this,t,r);default:if(n)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),n=!0}}function w(e,t,r,n){r=Number(r)||0;var i=e.length-r;n?(n=Number(n),n>i&&(n=i)):n=i;var a=t.length;if(a%2!==0)throw new Error("Invalid hex string");n>a/2&&(n=a/2);for(var o=0;n>o;o++){var s=parseInt(t.substr(2*o,2),16);if(isNaN(s))throw new Error("Invalid hex string");e[r+o]=s}return o}function y(e,t,r,n){return W(q(t,e.length-r),e,r,n)}function x(e,t,r,n){return W(G(t),e,r,n)}function k(e,t,r,n){return x(e,t,r,n)}function E(e,t,r,n){return W(Y(t),e,r,n)}function S(e,t,r,n){return W(H(t,e.length-r),e,r,n)}function A(e,t,r){return 0===t&&r===e.length?X.fromByteArray(e):X.fromByteArray(e.slice(t,r))}function I(e,t,r){r=Math.min(e.length,r);for(var n=[],i=t;r>i;){var a=e[i],o=null,s=a>239?4:a>223?3:a>191?2:1;if(r>=i+s){var c,u,f,l;switch(s){case 1:128>a&&(o=a);break;case 2:c=e[i+1],128===(192&c)&&(l=(31&a)<<6|63&c,l>127&&(o=l));break;case 3:c=e[i+1],u=e[i+2],128===(192&c)&&128===(192&u)&&(l=(15&a)<<12|(63&c)<<6|63&u,l>2047&&(55296>l||l>57343)&&(o=l));break;case 4:c=e[i+1],u=e[i+2],f=e[i+3],128===(192&c)&&128===(192&u)&&128===(192&f)&&(l=(15&a)<<18|(63&c)<<12|(63&u)<<6|63&f,l>65535&&1114112>l&&(o=l))}}null===o?(o=65533,s=1):o>65535&&(o-=65536,n.push(o>>>10&1023|55296),o=56320|1023&o),n.push(o),i+=s}return R(n)}function R(e){var t=e.length;if(Q>=t)return String.fromCharCode.apply(String,e);for(var r="",n=0;t>n;)r+=String.fromCharCode.apply(String,e.slice(n,n+=Q));return r}function P(e,t,r){var n="";r=Math.min(e.length,r);for(var i=t;r>i;i++)n+=String.fromCharCode(127&e[i]);return n}function T(e,t,r){var n="";r=Math.min(e.length,r);for(var i=t;r>i;i++)n+=String.fromCharCode(e[i]);return n}function M(e,t,r){var n=e.length;(!t||0>t)&&(t=0),(!r||0>r||r>n)&&(r=n);for(var i="",a=t;r>a;a++)i+=Z(e[a]);return i}function L(e,t,r){for(var n=e.slice(t,r),i="",a=0;a<n.length;a+=2)i+=String.fromCharCode(n[a]+256*n[a+1]);return i}function C(e,t,r){if(e%1!==0||0>e)throw new RangeError("offset is not uint");if(e+t>r)throw new RangeError("Trying to access beyond buffer length")}function O(e,t,r,n,i,o){if(!a.isBuffer(e))throw new TypeError("buffer must be a Buffer instance");if(t>i||o>t)throw new RangeError("value is out of bounds");if(r+n>e.length)throw new RangeError("index out of range")}function D(e,t,r,n){0>t&&(t=65535+t+1);for(var i=0,a=Math.min(e.length-r,2);a>i;i++)e[r+i]=(t&255<<8*(n?i:1-i))>>>8*(n?i:1-i)}function U(e,t,r,n){0>t&&(t=4294967295+t+1);for(var i=0,a=Math.min(e.length-r,4);a>i;i++)e[r+i]=t>>>8*(n?i:3-i)&255}function z(e,t,r,n,i,a){if(r+n>e.length)throw new RangeError("index out of range");if(0>r)throw new RangeError("index out of range")}function B(e,t,r,n,i){return i||z(e,t,r,4,3.4028234663852886e38,-3.4028234663852886e38),J.write(e,t,r,n,23,4),r+4}function F(e,t,r,n,i){return i||z(e,t,r,8,1.7976931348623157e308,-1.7976931348623157e308),J.write(e,t,r,n,52,8),r+8}function N(e){if(e=j(e).replace($,""),e.length<2)return"";for(;e.length%4!==0;)e+="=";return e}function j(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}function Z(e){return 16>e?"0"+e.toString(16):e.toString(16)}function q(e,t){t=t||1/0;for(var r,n=e.length,i=null,a=[],o=0;n>o;o++){if(r=e.charCodeAt(o),r>55295&&57344>r){if(!i){if(r>56319){(t-=3)>-1&&a.push(239,191,189);continue}if(o+1===n){(t-=3)>-1&&a.push(239,191,189);continue}i=r;continue}if(56320>r){(t-=3)>-1&&a.push(239,191,189),i=r;continue}r=(i-55296<<10|r-56320)+65536}else i&&(t-=3)>-1&&a.push(239,191,189);if(i=null,128>r){if((t-=1)<0)break;a.push(r)}else if(2048>r){if((t-=2)<0)break;a.push(r>>6|192,63&r|128)}else if(65536>r){if((t-=3)<0)break;a.push(r>>12|224,r>>6&63|128,63&r|128)}else{if(!(1114112>r))throw new Error("Invalid code point");if((t-=4)<0)break;a.push(r>>18|240,r>>12&63|128,r>>6&63|128,63&r|128)}}return a}function G(e){for(var t=[],r=0;r<e.length;r++)t.push(255&e.charCodeAt(r));return t}function H(e,t){for(var r,n,i,a=[],o=0;o<e.length&&!((t-=2)<0);o++)r=e.charCodeAt(o),n=r>>8,i=r%256,a.push(i),a.push(n);return a}function Y(e){return X.toByteArray(N(e))}function W(e,t,r,n){for(var i=0;n>i&&!(i+r>=t.length||i>=e.length);i++)t[i+r]=e[i];return i}var X=e("base64-js"),J=e("ieee754"),V=e("isarray");r.Buffer=a,r.SlowBuffer=v,r.INSPECT_MAX_BYTES=50,a.poolSize=8192;var K={};a.TYPED_ARRAY_SUPPORT=void 0!==t.TYPED_ARRAY_SUPPORT?t.TYPED_ARRAY_SUPPORT:n(),a._augment=function(e){return e.__proto__=a.prototype,e},a.TYPED_ARRAY_SUPPORT?(a.prototype.__proto__=Uint8Array.prototype,a.__proto__=Uint8Array,"undefined"!=typeof Symbol&&Symbol.species&&a[Symbol.species]===a&&Object.defineProperty(a,Symbol.species,{value:null,configurable:!0})):(a.prototype.length=void 0,a.prototype.parent=void 0),a.isBuffer=function(e){return!(null==e||!e._isBuffer)},a.compare=function(e,t){if(!a.isBuffer(e)||!a.isBuffer(t))throw new TypeError("Arguments must be Buffers");if(e===t)return 0;for(var r=e.length,n=t.length,i=0,o=Math.min(r,n);o>i;++i)if(e[i]!==t[i]){r=e[i],n=t[i];break}return n>r?-1:r>n?1:0},a.isEncoding=function(e){switch(String(e).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"raw":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},a.concat=function(e,t){if(!V(e))throw new TypeError("list argument must be an Array of Buffers.");if(0===e.length)return new a(0);var r;if(void 0===t)for(t=0,r=0;r<e.length;r++)t+=e[r].length;var n=new a(t),i=0;for(r=0;r<e.length;r++){var o=e[r];o.copy(n,i),i+=o.length}return n},a.byteLength=_,a.prototype._isBuffer=!0,a.prototype.toString=function(){var e=0|this.length;return 0===e?"":0===arguments.length?I(this,0,e):b.apply(this,arguments)},a.prototype.equals=function(e){if(!a.isBuffer(e))throw new TypeError("Argument must be a Buffer");return this===e?!0:0===a.compare(this,e)},a.prototype.inspect=function(){var e="",t=r.INSPECT_MAX_BYTES;return this.length>0&&(e=this.toString("hex",0,t).match(/.{2}/g).join(" "),this.length>t&&(e+=" ... ")),"<Buffer "+e+">"},a.prototype.compare=function(e){if(!a.isBuffer(e))throw new TypeError("Argument must be a Buffer");return a.compare(this,e)},a.prototype.indexOf=function(e,t){function r(e,t,r){for(var n=-1,i=0;r+i<e.length;i++)if(e[r+i]===t[-1===n?0:i-n]){if(-1===n&&(n=i),i-n+1===t.length)return r+n}else n=-1;return-1}if(t>2147483647?t=2147483647:-2147483648>t&&(t=-2147483648),t>>=0,0===this.length)return-1;if(t>=this.length)return-1;if(0>t&&(t=Math.max(this.length+t,0)),"string"==typeof e)return 0===e.length?-1:String.prototype.indexOf.call(this,e,t);if(a.isBuffer(e))return r(this,e,t);if("number"==typeof e)return a.TYPED_ARRAY_SUPPORT&&"function"===Uint8Array.prototype.indexOf?Uint8Array.prototype.indexOf.call(this,e,t):r(this,[e],t);throw new TypeError("val must be string, number or Buffer")},a.prototype.write=function(e,t,r,n){if(void 0===t)n="utf8",r=this.length,t=0;else if(void 0===r&&"string"==typeof t)n=t,r=this.length,t=0;else if(isFinite(t))t=0|t,isFinite(r)?(r=0|r,void 0===n&&(n="utf8")):(n=r,r=void 0);else{var i=n;n=t,t=0|r,r=i}var a=this.length-t;if((void 0===r||r>a)&&(r=a),e.length>0&&(0>r||0>t)||t>this.length)throw new RangeError("attempt to write outside buffer bounds");n||(n="utf8");for(var o=!1;;)switch(n){case"hex":return w(this,e,t,r);case"utf8":case"utf-8":return y(this,e,t,r);case"ascii":return x(this,e,t,r);case"binary":return k(this,e,t,r);case"base64":return E(this,e,t,r);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return S(this,e,t,r);default:if(o)throw new TypeError("Unknown encoding: "+n);n=(""+n).toLowerCase(),o=!0}},a.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};var Q=4096;a.prototype.slice=function(e,t){var r=this.length;e=~~e,t=void 0===t?r:~~t,0>e?(e+=r,0>e&&(e=0)):e>r&&(e=r),0>t?(t+=r,0>t&&(t=0)):t>r&&(t=r),e>t&&(t=e);var n;if(a.TYPED_ARRAY_SUPPORT)n=this.subarray(e,t),n.__proto__=a.prototype;else{var i=t-e;n=new a(i,void 0);for(var o=0;i>o;o++)n[o]=this[o+e]}return n.length&&(n.parent=this.parent||this),n},a.prototype.readUIntLE=function(e,t,r){e=0|e,t=0|t,r||C(e,t,this.length);for(var n=this[e],i=1,a=0;++a<t&&(i*=256);)n+=this[e+a]*i;return n},a.prototype.readUIntBE=function(e,t,r){e=0|e,t=0|t,r||C(e,t,this.length);for(var n=this[e+--t],i=1;t>0&&(i*=256);)n+=this[e+--t]*i;return n},a.prototype.readUInt8=function(e,t){return t||C(e,1,this.length),this[e]},a.prototype.readUInt16LE=function(e,t){return t||C(e,2,this.length),this[e]|this[e+1]<<8},a.prototype.readUInt16BE=function(e,t){return t||C(e,2,this.length),this[e]<<8|this[e+1]},a.prototype.readUInt32LE=function(e,t){return t||C(e,4,this.length),(this[e]|this[e+1]<<8|this[e+2]<<16)+16777216*this[e+3]},a.prototype.readUInt32BE=function(e,t){return t||C(e,4,this.length),16777216*this[e]+(this[e+1]<<16|this[e+2]<<8|this[e+3])},a.prototype.readIntLE=function(e,t,r){e=0|e,t=0|t,r||C(e,t,this.length);for(var n=this[e],i=1,a=0;++a<t&&(i*=256);)n+=this[e+a]*i;return i*=128,n>=i&&(n-=Math.pow(2,8*t)),n},a.prototype.readIntBE=function(e,t,r){e=0|e,t=0|t,r||C(e,t,this.length);for(var n=t,i=1,a=this[e+--n];n>0&&(i*=256);)a+=this[e+--n]*i;return i*=128,a>=i&&(a-=Math.pow(2,8*t)),a},a.prototype.readInt8=function(e,t){return t||C(e,1,this.length),128&this[e]?-1*(255-this[e]+1):this[e]},a.prototype.readInt16LE=function(e,t){t||C(e,2,this.length);var r=this[e]|this[e+1]<<8;return 32768&r?4294901760|r:r},a.prototype.readInt16BE=function(e,t){t||C(e,2,this.length);var r=this[e+1]|this[e]<<8;return 32768&r?4294901760|r:r},a.prototype.readInt32LE=function(e,t){return t||C(e,4,this.length),this[e]|this[e+1]<<8|this[e+2]<<16|this[e+3]<<24},a.prototype.readInt32BE=function(e,t){return t||C(e,4,this.length),this[e]<<24|this[e+1]<<16|this[e+2]<<8|this[e+3]},a.prototype.readFloatLE=function(e,t){return t||C(e,4,this.length),J.read(this,e,!0,23,4)},a.prototype.readFloatBE=function(e,t){return t||C(e,4,this.length),J.read(this,e,!1,23,4)},a.prototype.readDoubleLE=function(e,t){return t||C(e,8,this.length),J.read(this,e,!0,52,8)},a.prototype.readDoubleBE=function(e,t){return t||C(e,8,this.length),J.read(this,e,!1,52,8)},a.prototype.writeUIntLE=function(e,t,r,n){e=+e,t=0|t,r=0|r,n||O(this,e,t,r,Math.pow(2,8*r),0);var i=1,a=0;for(this[t]=255&e;++a<r&&(i*=256);)this[t+a]=e/i&255;return t+r},a.prototype.writeUIntBE=function(e,t,r,n){e=+e,t=0|t,r=0|r,n||O(this,e,t,r,Math.pow(2,8*r),0);var i=r-1,a=1;for(this[t+i]=255&e;--i>=0&&(a*=256);)this[t+i]=e/a&255;return t+r},a.prototype.writeUInt8=function(e,t,r){return e=+e,t=0|t,r||O(this,e,t,1,255,0),a.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),this[t]=255&e,t+1},a.prototype.writeUInt16LE=function(e,t,r){return e=+e,t=0|t,r||O(this,e,t,2,65535,0),a.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):D(this,e,t,!0),t+2},a.prototype.writeUInt16BE=function(e,t,r){return e=+e,t=0|t,r||O(this,e,t,2,65535,0),a.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):D(this,e,t,!1),t+2},a.prototype.writeUInt32LE=function(e,t,r){return e=+e,t=0|t,r||O(this,e,t,4,4294967295,0),a.TYPED_ARRAY_SUPPORT?(this[t+3]=e>>>24,this[t+2]=e>>>16,this[t+1]=e>>>8,this[t]=255&e):U(this,e,t,!0),t+4},a.prototype.writeUInt32BE=function(e,t,r){return e=+e,t=0|t,r||O(this,e,t,4,4294967295,0),a.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):U(this,e,t,!1),t+4},a.prototype.writeIntLE=function(e,t,r,n){if(e=+e,t=0|t,!n){var i=Math.pow(2,8*r-1);O(this,e,t,r,i-1,-i)}var a=0,o=1,s=0>e?1:0;for(this[t]=255&e;++a<r&&(o*=256);)this[t+a]=(e/o>>0)-s&255;return t+r},a.prototype.writeIntBE=function(e,t,r,n){if(e=+e,t=0|t,!n){var i=Math.pow(2,8*r-1);O(this,e,t,r,i-1,-i)}var a=r-1,o=1,s=0>e?1:0;for(this[t+a]=255&e;--a>=0&&(o*=256);)this[t+a]=(e/o>>0)-s&255;return t+r},a.prototype.writeInt8=function(e,t,r){return e=+e,t=0|t,r||O(this,e,t,1,127,-128),a.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),0>e&&(e=255+e+1),this[t]=255&e,t+1},a.prototype.writeInt16LE=function(e,t,r){return e=+e,t=0|t,r||O(this,e,t,2,32767,-32768),a.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):D(this,e,t,!0),t+2},a.prototype.writeInt16BE=function(e,t,r){return e=+e,t=0|t,r||O(this,e,t,2,32767,-32768),a.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):D(this,e,t,!1),t+2},a.prototype.writeInt32LE=function(e,t,r){return e=+e,t=0|t,r||O(this,e,t,4,2147483647,-2147483648),a.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8,this[t+2]=e>>>16,this[t+3]=e>>>24):U(this,e,t,!0),t+4},a.prototype.writeInt32BE=function(e,t,r){return e=+e,t=0|t,r||O(this,e,t,4,2147483647,-2147483648),0>e&&(e=4294967295+e+1),a.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):U(this,e,t,!1),t+4},a.prototype.writeFloatLE=function(e,t,r){return B(this,e,t,!0,r)},a.prototype.writeFloatBE=function(e,t,r){return B(this,e,t,!1,r)},a.prototype.writeDoubleLE=function(e,t,r){return F(this,e,t,!0,r)},a.prototype.writeDoubleBE=function(e,t,r){return F(this,e,t,!1,r)},a.prototype.copy=function(e,t,r,n){if(r||(r=0),n||0===n||(n=this.length),t>=e.length&&(t=e.length),t||(t=0),n>0&&r>n&&(n=r),n===r)return 0;if(0===e.length||0===this.length)return 0;if(0>t)throw new RangeError("targetStart out of bounds");if(0>r||r>=this.length)throw new RangeError("sourceStart out of bounds");if(0>n)throw new RangeError("sourceEnd out of bounds");n>this.length&&(n=this.length),e.length-t<n-r&&(n=e.length-t+r);var i,o=n-r;if(this===e&&t>r&&n>t)for(i=o-1;i>=0;i--)e[i+t]=this[i+r];else if(1e3>o||!a.TYPED_ARRAY_SUPPORT)for(i=0;o>i;i++)e[i+t]=this[i+r];else Uint8Array.prototype.set.call(e,this.subarray(r,r+o),t);return o},a.prototype.fill=function(e,t,r){if(e||(e=0),t||(t=0),r||(r=this.length),t>r)throw new RangeError("end < start");if(r!==t&&0!==this.length){if(0>t||t>=this.length)throw new RangeError("start out of bounds");if(0>r||r>this.length)throw new RangeError("end out of bounds");var n;if("number"==typeof e)for(n=t;r>n;n++)this[n]=e;else{var i=q(e.toString()),a=i.length;for(n=t;r>n;n++)this[n]=i[n%a]}return this}};var $=/[^+\/0-9A-Za-z-_]/g}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"base64-js":17,ieee754:26,isarray:30}],22:[function(e,t,r){(function(e){function t(e){return Array.isArray?Array.isArray(e):"[object Array]"===m(e)}function n(e){return"boolean"==typeof e}function i(e){return null===e}function a(e){return null==e}function o(e){return"number"==typeof e}function s(e){return"string"==typeof e}function c(e){return"symbol"==typeof e}function u(e){return void 0===e}function f(e){return"[object RegExp]"===m(e)}function l(e){return"object"==typeof e&&null!==e}function h(e){return"[object Date]"===m(e)}function d(e){return"[object Error]"===m(e)||e instanceof Error}function p(e){return"function"==typeof e}function g(e){return null===e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||"symbol"==typeof e||"undefined"==typeof e}function m(e){return Object.prototype.toString.call(e)}r.isArray=t,r.isBoolean=n,r.isNull=i,r.isNullOrUndefined=a,r.isNumber=o,r.isString=s,r.isSymbol=c,r.isUndefined=u,r.isRegExp=f,r.isObject=l,r.isDate=h,r.isError=d,r.isFunction=p,r.isPrimitive=g,r.isBuffer=e.isBuffer}).call(this,{isBuffer:e("../../is-buffer/index.js")})},{"../../is-buffer/index.js":29}],23:[function(e,t,r){function n(){return"WebkitAppearance"in document.documentElement.style||window.console&&(console.firebug||console.exception&&console.table)||navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)&&parseInt(RegExp.$1,10)>=31}function i(){var e=arguments,t=this.useColors;if(e[0]=(t?"%c":"")+this.namespace+(t?" %c":" ")+e[0]+(t?"%c ":" ")+"+"+r.humanize(this.diff),!t)return e;var n="color: "+this.color;e=[e[0],n,"color: inherit"].concat(Array.prototype.slice.call(e,1));var i=0,a=0;return e[0].replace(/%[a-z%]/g,function(e){"%%"!==e&&(i++,"%c"===e&&(a=i))}),e.splice(a,0,n),e}function a(){return"object"==typeof console&&console.log&&Function.prototype.apply.call(console.log,console,arguments)}function o(e){try{null==e?r.storage.removeItem("debug"):r.storage.debug=e}catch(t){}}function s(){var e;try{e=r.storage.debug}catch(t){}return e}function c(){try{return window.localStorage}catch(e){}}r=t.exports=e("./debug"),r.log=a,r.formatArgs=i,r.save=o,r.load=s,r.useColors=n,r.storage="undefined"!=typeof chrome&&"undefined"!=typeof chrome.storage?chrome.storage.local:c(),r.colors=["lightseagreen","forestgreen","goldenrod","dodgerblue","darkorchid","crimson"],r.formatters.j=function(e){return JSON.stringify(e)},r.enable(s())},{"./debug":24}],24:[function(e,t,r){function n(){return r.colors[f++%r.colors.length]}function i(e){function t(){}function i(){var e=i,t=+new Date,a=t-(u||t);e.diff=a,e.prev=u,e.curr=t,u=t,null==e.useColors&&(e.useColors=r.useColors()),null==e.color&&e.useColors&&(e.color=n());var o=Array.prototype.slice.call(arguments);o[0]=r.coerce(o[0]),"string"!=typeof o[0]&&(o=["%o"].concat(o));var s=0;o[0]=o[0].replace(/%([a-z%])/g,function(t,n){if("%%"===t)return t;s++;var i=r.formatters[n];if("function"==typeof i){var a=o[s];t=i.call(e,a),o.splice(s,1),s--}return t}),"function"==typeof r.formatArgs&&(o=r.formatArgs.apply(e,o));var c=i.log||r.log||console.log.bind(console);c.apply(e,o)}t.enabled=!1,i.enabled=!0;var a=r.enabled(e)?i:t;return a.namespace=e,a}function a(e){r.save(e);for(var t=(e||"").split(/[\s,]+/),n=t.length,i=0;n>i;i++)t[i]&&(e=t[i].replace(/\*/g,".*?"),"-"===e[0]?r.skips.push(new RegExp("^"+e.substr(1)+"$")):r.names.push(new RegExp("^"+e+"$")))}function o(){r.enable("")}function s(e){var t,n;for(t=0,n=r.skips.length;n>t;t++)if(r.skips[t].test(e))return!1;for(t=0,n=r.names.length;n>t;t++)if(r.names[t].test(e))return!0;return!1}function c(e){return e instanceof Error?e.stack||e.message:e}r=t.exports=i,r.coerce=c,r.disable=o,r.enable=a,r.enabled=s,r.humanize=e("ms"),r.names=[],r.skips=[],r.formatters={};var u,f=0},{ms:36}],25:[function(e,t,r){function n(){this._events=this._events||{},this._maxListeners=this._maxListeners||void 0}function i(e){return"function"==typeof e}function a(e){return"number"==typeof e}function o(e){return"object"==typeof e&&null!==e}function s(e){return void 0===e}t.exports=n,n.EventEmitter=n,n.prototype._events=void 0,n.prototype._maxListeners=void 0,n.defaultMaxListeners=10,n.prototype.setMaxListeners=function(e){if(!a(e)||0>e||isNaN(e))throw TypeError("n must be a positive number");return this._maxListeners=e,this},n.prototype.emit=function(e){var t,r,n,a,c,u;if(this._events||(this._events={}),"error"===e&&(!this._events.error||o(this._events.error)&&!this._events.error.length)){if(t=arguments[1],t instanceof Error)throw t;throw TypeError('Uncaught, unspecified "error" event.')}if(r=this._events[e],s(r))return!1;if(i(r))switch(arguments.length){case 1:r.call(this);break;case 2:r.call(this,arguments[1]);break;case 3:r.call(this,arguments[1],arguments[2]);break;default:a=Array.prototype.slice.call(arguments,1),r.apply(this,a)}else if(o(r))for(a=Array.prototype.slice.call(arguments,1),u=r.slice(),n=u.length,c=0;n>c;c++)u[c].apply(this,a);return!0},n.prototype.addListener=function(e,t){var r;if(!i(t))throw TypeError("listener must be a function");return this._events||(this._events={}),this._events.newListener&&this.emit("newListener",e,i(t.listener)?t.listener:t),this._events[e]?o(this._events[e])?this._events[e].push(t):this._events[e]=[this._events[e],t]:this._events[e]=t,o(this._events[e])&&!this._events[e].warned&&(r=s(this._maxListeners)?n.defaultMaxListeners:this._maxListeners,r&&r>0&&this._events[e].length>r&&(this._events[e].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[e].length),"function"==typeof console.trace&&console.trace())),this},n.prototype.on=n.prototype.addListener,n.prototype.once=function(e,t){function r(){this.removeListener(e,r),n||(n=!0,t.apply(this,arguments))}if(!i(t))throw TypeError("listener must be a function");var n=!1;return r.listener=t,this.on(e,r),this},n.prototype.removeListener=function(e,t){var r,n,a,s;if(!i(t))throw TypeError("listener must be a function");if(!this._events||!this._events[e])return this;if(r=this._events[e],a=r.length,n=-1,r===t||i(r.listener)&&r.listener===t)delete this._events[e],this._events.removeListener&&this.emit("removeListener",e,t);else if(o(r)){for(s=a;s-- >0;)if(r[s]===t||r[s].listener&&r[s].listener===t){n=s;break}if(0>n)return this;1===r.length?(r.length=0,delete this._events[e]):r.splice(n,1),this._events.removeListener&&this.emit("removeListener",e,t)}return this},n.prototype.removeAllListeners=function(e){var t,r;if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events={}:this._events[e]&&delete this._events[e],this;if(0===arguments.length){for(t in this._events)"removeListener"!==t&&this.removeAllListeners(t);return this.removeAllListeners("removeListener"),this._events={},this}if(r=this._events[e],i(r))this.removeListener(e,r);else if(r)for(;r.length;)this.removeListener(e,r[r.length-1]);return delete this._events[e],this},n.prototype.listeners=function(e){var t;return t=this._events&&this._events[e]?i(this._events[e])?[this._events[e]]:this._events[e].slice():[]},n.prototype.listenerCount=function(e){if(this._events){var t=this._events[e];if(i(t))return 1;if(t)return t.length}return 0},n.listenerCount=function(e,t){return e.listenerCount(t)}},{}],26:[function(e,t,r){r.read=function(e,t,r,n,i){var a,o,s=8*i-n-1,c=(1<<s)-1,u=c>>1,f=-7,l=r?i-1:0,h=r?-1:1,d=e[t+l];for(l+=h,a=d&(1<<-f)-1,d>>=-f,f+=s;f>0;a=256*a+e[t+l],l+=h,f-=8);for(o=a&(1<<-f)-1,a>>=-f,f+=n;f>0;o=256*o+e[t+l],l+=h,f-=8);if(0===a)a=1-u;else{if(a===c)return o?NaN:(d?-1:1)*(1/0);o+=Math.pow(2,n),a-=u}return(d?-1:1)*o*Math.pow(2,a-n)},r.write=function(e,t,r,n,i,a){var o,s,c,u=8*a-i-1,f=(1<<u)-1,l=f>>1,h=23===i?Math.pow(2,-24)-Math.pow(2,-77):0,d=n?0:a-1,p=n?1:-1,g=0>t||0===t&&0>1/t?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(s=isNaN(t)?1:0,o=f):(o=Math.floor(Math.log(t)/Math.LN2),t*(c=Math.pow(2,-o))<1&&(o--,c*=2),t+=o+l>=1?h/c:h*Math.pow(2,1-l),t*c>=2&&(o++,c/=2),o+l>=f?(s=0,o=f):o+l>=1?(s=(t*c-1)*Math.pow(2,i),o+=l):(s=t*Math.pow(2,l-1)*Math.pow(2,i),o=0));i>=8;e[r+d]=255&s,d+=p,s/=256,i-=8);for(o=o<<i|s,u+=i;u>0;e[r+d]=255&o,d+=p,o/=256,u-=8);e[r+d-p]|=128*g}},{}],27:[function(e,t,r){(function(r){function n(e,t,r){if(e.readUInt32)return e.readUInt32(t,r);var n;if(r){if(e.readUInt32BE)return e.readUInt32BE(t);n=(e[t]<<24)+(e[t+1]<<16)+(e[t+2]<<8)+e[t+3]}else{if(e.readUInt32LE)return e.readUInt32LE(t);n=e[t]+(e[t+1]<<8)+(e[t+2]<<16)+(e[t+3]<<24)}return n}function i(e,t,r){if(e.readUInt16)return e.readUInt16(t,r);var n;if(r){if(e.readUInt16BE)return e.readUInt16BE(t);n=(e[t]<<8)+e[t+1]}else{if(e.readUInt16LE)return e.readUInt16LE(t);n=e[t]+(e[t+1]<<8)}return n}function a(e,t,r){r>7&&(t+=Math.floor(r/8),r%=8);var n=e[t];7>r&&(n>>>=7-r);var i=1&n;return i}function o(e,t,n,i,o){var s=0,c=!1;o&&(a(e,t,n)>0&&(c=!0),i--,n++);for(var u=[],f=0;i>f;f++){var l=a(e,t,n+f);f>0&&(i-f)%8==0&&(u.push(s),s=0),s<<=1,s|=l}return u.push(s),s=new r(u),s.negative=!!c,s}function s(e){var t=[73,72,68,82],r=12;return l(e,r,t)?(r+=4,{type:"image",format:"PNG",mimeType:"image/png",width:n(e,r,!0),height:n(e,r+4,!0)}):!1}function c(e){for(var t=2,r=e.length,n=[255,[192,194]];r>t;){if(l(e,t,n))return t+=5,{type:"image",format:"JPG",mimeType:"image/jpeg",width:i(e,t+2,!0),height:i(e,t,!0)};t+=2;var a=i(e,t,!0);t+=a}}function u(e){var t=6;return{type:"image",format:"GIF",mimeType:"image/gif",width:i(e,t,!1),height:i(e,t+2,!1)}}function f(t){var r,n=8,a=0;if(67===t[0])try{t=e("zlib").inflate(t.slice(8,100)),n=0}catch(s){return{type:"flash",format:"SWF",mimeType:"application/x-shockwave-flash",width:null,height:null}}var c=o(t,n,a,5)[0];a+=5,r=o(t,n,a,c,!0);var u=(c>9?i(r,0,!0):r[0])*(r.negative?-1:1);a+=c,r=o(t,n,a,c,!0);var f=(c>9?i(r,0,!0):r[0])*(r.negative?-1:1);a+=c,r=o(t,n,a,c,!0);var l=(c>9?i(r,0,!0):r[0])*(r.negative?-1:1);a+=c,r=o(t,n,a,c,!0);var h=(c>9?i(r,0,!0):r[0])*(r.negative?-1:1);return{type:"flash",format:"SWF",mimeType:"application/x-shockwave-flash",width:Math.ceil((f-u)/20),height:Math.ceil((h-l)/20)}}function l(e,t,r){for(var n=r.length,i=0;n>i;i++){
var a=e[i+t],o=r[i],s=!1;if("number"==typeof o)s=o===a;else for(var c in o){var u=o[c];u===a&&(s=!0)}if(!s)return!1}return!0}t.exports=function(e,t){var r=[137,80,78,71,13,10,26,10],n=[255,216,255],i=[71,73,70,56,[55,57],97],a=[[70,67],87,83];return l(e,0,r)?s(e):l(e,0,n)?c(e):l(e,0,i)?u(e):l(e,0,a)?f(e):!1}}).call(this,e("buffer").Buffer)},{buffer:21,zlib:20}],28:[function(e,t,r){"function"==typeof Object.create?t.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:t.exports=function(e,t){e.super_=t;var r=function(){};r.prototype=t.prototype,e.prototype=new r,e.prototype.constructor=e}},{}],29:[function(e,t,r){t.exports=function(e){return!(null==e||!(e._isBuffer||e.constructor&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)))}},{}],30:[function(e,t,r){var n={}.toString;t.exports=Array.isArray||function(e){return"[object Array]"==n.call(e)}},{}],31:[function(e,t,r){function n(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}function i(e,t){return e="number"==typeof e||I.test(e)?+e:-1,t=null==t?x:t,e>-1&&e%1==0&&t>e}function a(e,t){return e&&D(e,t,y)}function o(e,t){return P.call(e,t)||"object"==typeof e&&t in e&&null===M(e)}function s(e){return C(Object(e))}function c(e){return function(t){return null==t?void 0:t[e]}}function u(e,t){return function(r,n){if(null==r)return r;if(!p(r))return e(r,n);for(var i=r.length,a=t?i:-1,o=Object(r);(t?a--:++a<i)&&n(o[a],a,o)!==!1;);return r}}function f(e){return function(t,r,n){for(var i=-1,a=Object(t),o=n(t),s=o.length;s--;){var c=o[e?s:++i];if(r(a[c],c,a)===!1)break}return t}}function l(e){var t=e?e.length:void 0;return v(t)&&(z(e)||w(e)||d(e))?n(t,String):null}function h(e){var t=e&&e.constructor,r="function"==typeof t&&t.prototype||R;return e===r}function d(e){return g(e)&&P.call(e,"callee")&&(!L.call(e,"callee")||T.call(e)==k)}function p(e){return null!=e&&v(U(e))&&!m(e)}function g(e){return b(e)&&p(e)}function m(e){var t=_(e)?T.call(e):"";return t==E||t==S}function v(e){return"number"==typeof e&&e>-1&&e%1==0&&x>=e}function _(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function b(e){return!!e&&"object"==typeof e}function w(e){return"string"==typeof e||!z(e)&&b(e)&&T.call(e)==A}function y(e){var t=h(e);if(!t&&!p(e))return s(e);var r=l(e),n=!!r,a=r||[],c=a.length;for(var u in e)!o(e,u)||n&&("length"==u||i(u,c))||t&&"constructor"==u||a.push(u);return a}var x=9007199254740991,k="[object Arguments]",E="[object Function]",S="[object GeneratorFunction]",A="[object String]",I=/^(?:0|[1-9]\d*)$/,R=Object.prototype,P=R.hasOwnProperty,T=R.toString,M=Object.getPrototypeOf,L=R.propertyIsEnumerable,C=Object.keys,O=u(a),D=f(),U=c("length"),z=Array.isArray;t.exports=O},{}],32:[function(e,t,r){function n(e,t,r,n){var i;return r(e,function(e,r,a){return t(e,r,a)?(i=n?r:e,!1):void 0}),i}t.exports=n},{}],33:[function(e,t,r){function n(e,t,r){for(var n=e.length,i=r?n:-1;r?i--:++i<n;)if(t(e[i],i,e))return i;return-1}t.exports=n},{}],34:[function(e,t,r){(function(e){function n(e,t){for(var r=-1,n=e.length,i=Array(n);++r<n;)i[r]=t(e[r],r,e);return i}function i(e,t){for(var r=-1,n=e.length;++r<n;)if(t(e[r],r,e))return!0;return!1}function a(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}function o(e,t){return n(t,function(t){return[t,e[t]]})}function s(e){return e&&e.Object===Object?e:null}function c(e){var t=!1;if(null!=e&&"function"!=typeof e.toString)try{t=!!(e+"")}catch(r){}return t}function u(e,t){return e="number"==typeof e||lt.test(e)?+e:-1,t=null==t?Ce:t,e>-1&&e%1==0&&t>e}function f(e){var t=-1,r=Array(e.size);return e.forEach(function(e,n){r[++t]=[n,e]}),r}function l(e){var t=-1,r=Array(e.size);return e.forEach(function(e){r[++t]=e}),r}function h(){}function d(e,t){return g(e,t)&&delete e[t]}function p(e,t){if(Ut){var r=e[t];return r===Pe?void 0:r}return Et.call(e,t)?e[t]:void 0}function g(e,t){return Ut?void 0!==e[t]:Et.call(e,t)}function m(e,t,r){e[t]=Ut&&void 0===r?Pe:r}function v(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function _(){this.__data__={hash:new h,map:Ct?new Ct:[],string:new h}}function b(e){var t=this.__data__;return ne(e)?d("string"==typeof e?t.string:t.hash,e):Ct?t.map["delete"](e):P(t.map,e)}function w(e){var t=this.__data__;return ne(e)?p("string"==typeof e?t.string:t.hash,e):Ct?t.map.get(e):T(t.map,e)}function y(e){var t=this.__data__;return ne(e)?g("string"==typeof e?t.string:t.hash,e):Ct?t.map.has(e):M(t.map,e)}function x(e,t){var r=this.__data__;return ne(e)?m("string"==typeof e?r.string:r.hash,e,t):Ct?r.map.set(e,t):C(r.map,e,t),this}function k(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function E(){this.__data__={array:[],map:null}}function S(e){var t=this.__data__,r=t.array;return r?P(r,e):t.map["delete"](e)}function A(e){var t=this.__data__,r=t.array;return r?T(r,e):t.map.get(e)}function I(e){var t=this.__data__,r=t.array;return r?M(r,e):t.map.has(e)}function R(e,t){var r=this.__data__,n=r.array;n&&(n.length<Re-1?C(n,e,t):(r.array=null,r.map=new v(n)));var i=r.map;return i&&i.set(e,t),this}function P(e,t){var r=L(e,t);if(0>r)return!1;var n=e.length-1;return r==n?e.pop():Mt.call(e,r,1),!0}function T(e,t){var r=L(e,t);return 0>r?void 0:e[r][1]}function M(e,t){return L(e,t)>-1}function L(e,t){for(var r=e.length;r--;)if(ue(e[r][0],t))return r;return-1}function C(e,t,r){var n=L(e,t);0>n?e.push([t,r]):e[n][1]=r}function O(e){return Gt(e)?e:se(e)}function D(e,t){t=re(t,e)?[t+""]:O(t);for(var r=0,n=t.length;null!=e&&n>r;)e=e[t[r++]];return r&&r==n?e:void 0}function U(e,t){return Et.call(e,t)||"object"==typeof e&&t in e&&null===Pt(e)}function z(e,t){return t in Object(e)}function B(e,t,r,n,i){return e===t?!0:null==e||null==t||!ge(e)&&!me(t)?e!==e&&t!==t:F(e,t,B,r,n,i)}function F(e,t,r,n,i,a){var o=Gt(e),s=Gt(t),u=De,f=De;o||(u=$(e),u=u==Oe?qe:u),s||(f=$(t),f=f==Oe?qe:f);var l=u==qe&&!c(e),h=f==qe&&!c(t),d=u==f;if(d&&!l)return a||(a=new k),o||we(e)?X(e,t,r,n,i,a):J(e,t,u,r,n,i,a);if(!(i&Me)){var p=l&&Et.call(e,"__wrapped__"),g=h&&Et.call(t,"__wrapped__");if(p||g)return a||(a=new k),r(p?e.value():e,g?t.value():t,n,i,a)}return d?(a||(a=new k),V(e,t,r,n,i,a)):!1}function N(e,t,r,n){var i=r.length,a=i,o=!n;if(null==e)return!a;for(e=Object(e);i--;){var s=r[i];if(o&&s[2]?s[1]!==e[s[0]]:!(s[0]in e))return!1}for(;++i<a;){s=r[i];var c=s[0],u=e[c],f=s[1];if(o&&s[2]){if(void 0===u&&!(c in e))return!1}else{var l=new k,h=n?n(u,f,c,e,t,l):void 0;if(!(void 0===h?B(f,u,n,Te|Me,l):h))return!1}}return!0}function j(e){var t=typeof e;return"function"==t?e:null==e?Ae:"object"==t?Gt(e)?G(e[0],e[1]):q(e):Ie(e)}function Z(e){return Lt(Object(e))}function q(e){var t=K(e);if(1==t.length&&t[0][2]){var r=t[0][0],n=t[0][1];return function(e){return null==e?!1:e[r]===n&&(void 0!==n||r in Object(e))}}return function(r){return r===e||N(r,e,t)}}function G(e,t){return function(r){var n=xe(r,e);return void 0===n&&n===t?ke(r,e):B(t,n,void 0,Te|Me)}}function H(e){return function(t){return null==t?void 0:t[e]}}function Y(e){return function(t){return D(t,e)}}function W(e,t,r){var n=-1,i=e.length;0>t&&(t=-t>i?0:i+t),r=r>i?i:r,0>r&&(r+=i),i=t>r?0:r-t>>>0,t>>>=0;for(var a=Array(i);++n<i;)a[n]=e[n+t];return a}function X(e,t,r,n,a,o){var s=-1,c=a&Me,u=a&Te,f=e.length,l=t.length;if(f!=l&&!(c&&l>f))return!1;var h=o.get(e);if(h)return h==t;var d=!0;for(o.set(e,t);++s<f;){var p=e[s],g=t[s];if(n)var m=c?n(g,p,s,t,e,o):n(p,g,s,e,t,o);if(void 0!==m){if(m)continue;d=!1;break}if(u){if(!i(t,function(e){return p===e||r(p,e,n,a,o)})){d=!1;break}}else if(p!==g&&!r(p,g,n,a,o)){d=!1;break}}return o["delete"](e),d}function J(e,t,r,n,i,a,o){switch(r){case Je:return!(e.byteLength!=t.byteLength||!n(new Rt(e),new Rt(t)));case Ue:case ze:return+e==+t;case Be:return e.name==t.name&&e.message==t.message;case Ze:return e!=+e?t!=+t:e==+t;case Ge:case Ye:return e==t+"";case je:var s=f;case He:var c=a&Me;if(s||(s=l),e.size!=t.size&&!c)return!1;var u=o.get(e);return u?u==t:X(s(e),s(t),n,i,a|Te,o.set(e,t));case We:if(jt)return jt.call(e)==jt.call(t)}return!1}function V(e,t,r,n,i,a){var o=i&Me,s=Ee(e),c=s.length,u=Ee(t),f=u.length;if(c!=f&&!o)return!1;for(var l=c;l--;){var h=s[l];if(!(o?h in t:U(t,h)))return!1}var d=a.get(e);if(d)return d==t;var p=!0;a.set(e,t);for(var g=o;++l<c;){h=s[l];var m=e[h],v=t[h];if(n)var _=o?n(v,m,h,t,e,a):n(m,v,h,e,t,a);if(!(void 0===_?m===v||r(m,v,n,i,a):_)){p=!1;break}g||(g="constructor"==h)}if(p&&!g){var b=e.constructor,w=t.constructor;b!=w&&"constructor"in e&&"constructor"in t&&!("function"==typeof b&&b instanceof b&&"function"==typeof w&&w instanceof w)&&(p=!1)}return a["delete"](e),p}function K(e){for(var t=Se(e),r=t.length;r--;)t[r][2]=ae(t[r][1]);return t}function Q(e,t){var r=e[t];return ve(r)?r:void 0}function $(e){return St.call(e)}function ee(e,t,r){if(null==e)return!1;var n=r(e,t);n||re(t)||(t=O(t),e=oe(e,t),null!=e&&(t=ce(t),n=r(e,t)));var i=e?e.length:void 0;return n||!!i&&pe(i)&&u(t,i)&&(Gt(e)||_e(e)||fe(e))}function te(e){var t=e?e.length:void 0;return pe(t)&&(Gt(e)||_e(e)||fe(e))?a(t,String):null}function re(e,t){return"number"==typeof e?!0:!Gt(e)&&(ot.test(e)||!at.test(e)||null!=t&&e in Object(t))}function ne(e){var t=typeof e;return"number"==t||"boolean"==t||"string"==t&&"__proto__"!=e||null==e}function ie(e){var t=e&&e.constructor,r="function"==typeof t&&t.prototype||xt;return e===r}function ae(e){return e===e&&!ge(e)}function oe(e,t){return 1==t.length?e:xe(e,W(t,0,-1))}function se(e){var t=[];return ye(e).replace(st,function(e,r,n,i){t.push(n?i.replace(ut,"$1"):r||e)}),t}function ce(e){var t=e?e.length:0;return t?e[t-1]:void 0}function ue(e,t){return e===t||e!==e&&t!==t}function fe(e){return he(e)&&Et.call(e,"callee")&&(!Tt.call(e,"callee")||St.call(e)==Oe)}function le(e){return null!=e&&pe(qt(e))&&!de(e)}function he(e){return me(e)&&le(e)}function de(e){var t=ge(e)?St.call(e):"";return t==Fe||t==Ne}function pe(e){return"number"==typeof e&&e>-1&&e%1==0&&Ce>=e}function ge(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function me(e){return!!e&&"object"==typeof e}function ve(e){return null==e?!1:de(e)?At.test(kt.call(e)):me(e)&&(c(e)?At:ft).test(e)}function _e(e){return"string"==typeof e||!Gt(e)&&me(e)&&St.call(e)==Ye}function be(e){return"symbol"==typeof e||me(e)&&St.call(e)==We}function we(e){return me(e)&&pe(e.length)&&!!ht[St.call(e)]}function ye(e){if("string"==typeof e)return e;if(null==e)return"";if(be(e))return Zt?Zt.call(e):"";var t=e+"";return"0"==t&&1/e==-Le?"-0":t}function xe(e,t,r){var n=null==e?void 0:D(e,t);return void 0===n?r:n}function ke(e,t){return ee(e,t,z)}function Ee(e){var t=ie(e);if(!t&&!le(e))return Z(e);var r=te(e),n=!!r,i=r||[],a=i.length;for(var o in e)!U(e,o)||n&&("length"==o||u(o,a))||t&&"constructor"==o||i.push(o);return i}function Se(e){return o(e,Ee(e))}function Ae(e){return e}function Ie(e){return re(e)?H(e):Y(e)}var Re=200,Pe="__lodash_hash_undefined__",Te=1,Me=2,Le=1/0,Ce=9007199254740991,Oe="[object Arguments]",De="[object Array]",Ue="[object Boolean]",ze="[object Date]",Be="[object Error]",Fe="[object Function]",Ne="[object GeneratorFunction]",je="[object Map]",Ze="[object Number]",qe="[object Object]",Ge="[object RegExp]",He="[object Set]",Ye="[object String]",We="[object Symbol]",Xe="[object WeakMap]",Je="[object ArrayBuffer]",Ve="[object Float32Array]",Ke="[object Float64Array]",Qe="[object Int8Array]",$e="[object Int16Array]",et="[object Int32Array]",tt="[object Uint8Array]",rt="[object Uint8ClampedArray]",nt="[object Uint16Array]",it="[object Uint32Array]",at=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,ot=/^\w*$/,st=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]/g,ct=/[\\^$.*+?()[\]{}|]/g,ut=/\\(\\)?/g,ft=/^\[object .+?Constructor\]$/,lt=/^(?:0|[1-9]\d*)$/,ht={};ht[Ve]=ht[Ke]=ht[Qe]=ht[$e]=ht[et]=ht[tt]=ht[rt]=ht[nt]=ht[it]=!0,ht[Oe]=ht[De]=ht[Je]=ht[Ue]=ht[ze]=ht[Be]=ht[Fe]=ht[je]=ht[Ze]=ht[qe]=ht[Ge]=ht[He]=ht[Ye]=ht[Xe]=!1;var dt={"function":!0,object:!0},pt=dt[typeof r]&&r&&!r.nodeType?r:void 0,gt=dt[typeof t]&&t&&!t.nodeType?t:void 0,mt=s(pt&&gt&&"object"==typeof e&&e),vt=s(dt[typeof self]&&self),_t=s(dt[typeof window]&&window),bt=s(dt[typeof this]&&this),wt=mt||_t!==(bt&&bt.window)&&_t||vt||bt||Function("return this")(),yt=Array.prototype,xt=Object.prototype,kt=Function.prototype.toString,Et=xt.hasOwnProperty,St=xt.toString,At=RegExp("^"+kt.call(Et).replace(ct,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),It=wt.Symbol,Rt=wt.Uint8Array,Pt=Object.getPrototypeOf,Tt=xt.propertyIsEnumerable,Mt=yt.splice,Lt=Object.keys,Ct=Q(wt,"Map"),Ot=Q(wt,"Set"),Dt=Q(wt,"WeakMap"),Ut=Q(Object,"create"),zt=Ct?kt.call(Ct):"",Bt=Ot?kt.call(Ot):"",Ft=Dt?kt.call(Dt):"",Nt=It?It.prototype:void 0,jt=Nt?Nt.valueOf:void 0,Zt=Nt?Nt.toString:void 0,qt=H("length");(Ct&&$(new Ct)!=je||Ot&&$(new Ot)!=He||Dt&&$(new Dt)!=Xe)&&($=function(e){var t=St.call(e),r=t==qe?e.constructor:null,n="function"==typeof r?kt.call(r):"";if(n)switch(n){case zt:return je;case Bt:return He;case Ft:return Xe}return t});var Gt=Array.isArray;h.prototype=Ut?Ut(null):xt,v.prototype.clear=_,v.prototype["delete"]=b,v.prototype.get=w,v.prototype.has=y,v.prototype.set=x,k.prototype.clear=E,k.prototype["delete"]=S,k.prototype.get=A,k.prototype.has=I,k.prototype.set=R,t.exports=j}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{}],35:[function(e,t,r){function n(e,t){if(t=s(t,3),c(e)){var r=o(e,t);return r>-1?e[r]:void 0}return a(e,t,i)}var i=e("lodash._baseeach"),a=e("lodash._basefind"),o=e("lodash._basefindindex"),s=e("lodash._baseiteratee"),c=Array.isArray;t.exports=n},{"lodash._baseeach":31,"lodash._basefind":32,"lodash._basefindindex":33,"lodash._baseiteratee":34}],36:[function(e,t,r){function n(e){if(e=""+e,!(e.length>1e4)){var t=/^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(e);if(t){var r=parseFloat(t[1]),n=(t[2]||"ms").toLowerCase();switch(n){case"years":case"year":case"yrs":case"yr":case"y":return r*l;case"days":case"day":case"d":return r*f;case"hours":case"hour":case"hrs":case"hr":case"h":return r*u;case"minutes":case"minute":case"mins":case"min":case"m":return r*c;case"seconds":case"second":case"secs":case"sec":case"s":return r*s;case"milliseconds":case"millisecond":case"msecs":case"msec":case"ms":return r}}}}function i(e){return e>=f?Math.round(e/f)+"d":e>=u?Math.round(e/u)+"h":e>=c?Math.round(e/c)+"m":e>=s?Math.round(e/s)+"s":e+"ms"}function a(e){return o(e,f,"day")||o(e,u,"hour")||o(e,c,"minute")||o(e,s,"second")||e+" ms"}function o(e,t,r){return t>e?void 0:1.5*t>e?Math.floor(e/t)+" "+r:Math.ceil(e/t)+" "+r+"s"}var s=1e3,c=60*s,u=60*c,f=24*u,l=365.25*f;t.exports=function(e,t){return t=t||{},"string"==typeof e?n(e):t["long"]?a(e):i(e)}},{}],37:[function(e,t,r){"use strict";var n="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Int32Array;r.assign=function(e){for(var t=Array.prototype.slice.call(arguments,1);t.length;){var r=t.shift();if(r){if("object"!=typeof r)throw new TypeError(r+"must be non-object");for(var n in r)r.hasOwnProperty(n)&&(e[n]=r[n])}}return e},r.shrinkBuf=function(e,t){return e.length===t?e:e.subarray?e.subarray(0,t):(e.length=t,e)};var i={arraySet:function(e,t,r,n,i){if(t.subarray&&e.subarray)return void e.set(t.subarray(r,r+n),i);for(var a=0;n>a;a++)e[i+a]=t[r+a]},flattenChunks:function(e){var t,r,n,i,a,o;for(n=0,t=0,r=e.length;r>t;t++)n+=e[t].length;for(o=new Uint8Array(n),i=0,t=0,r=e.length;r>t;t++)a=e[t],o.set(a,i),i+=a.length;return o}},a={arraySet:function(e,t,r,n,i){for(var a=0;n>a;a++)e[i+a]=t[r+a]},flattenChunks:function(e){return[].concat.apply([],e)}};r.setTyped=function(e){e?(r.Buf8=Uint8Array,r.Buf16=Uint16Array,r.Buf32=Int32Array,r.assign(r,i)):(r.Buf8=Array,r.Buf16=Array,r.Buf32=Array,r.assign(r,a))},r.setTyped(n)},{}],38:[function(e,t,r){"use strict";function n(e,t,r,n){for(var i=65535&e|0,a=e>>>16&65535|0,o=0;0!==r;){o=r>2e3?2e3:r,r-=o;do i=i+t[n++]|0,a=a+i|0;while(--o);i%=65521,a%=65521}return i|a<<16|0}t.exports=n},{}],39:[function(e,t,r){t.exports={Z_NO_FLUSH:0,Z_PARTIAL_FLUSH:1,Z_SYNC_FLUSH:2,Z_FULL_FLUSH:3,Z_FINISH:4,Z_BLOCK:5,Z_TREES:6,Z_OK:0,Z_STREAM_END:1,Z_NEED_DICT:2,Z_ERRNO:-1,Z_STREAM_ERROR:-2,Z_DATA_ERROR:-3,Z_BUF_ERROR:-5,Z_NO_COMPRESSION:0,Z_BEST_SPEED:1,Z_BEST_COMPRESSION:9,Z_DEFAULT_COMPRESSION:-1,Z_FILTERED:1,Z_HUFFMAN_ONLY:2,Z_RLE:3,Z_FIXED:4,Z_DEFAULT_STRATEGY:0,Z_BINARY:0,Z_TEXT:1,Z_UNKNOWN:2,Z_DEFLATED:8}},{}],40:[function(e,t,r){"use strict";function n(){for(var e,t=[],r=0;256>r;r++){e=r;for(var n=0;8>n;n++)e=1&e?3988292384^e>>>1:e>>>1;t[r]=e}return t}function i(e,t,r,n){var i=a,o=n+r;e=-1^e;for(var s=n;o>s;s++)e=e>>>8^i[255&(e^t[s])];return-1^e}var a=n();t.exports=i},{}],41:[function(e,t,r){"use strict";function n(e,t){return e.msg=L[t],t}function i(e){return(e<<1)-(e>4?9:0)}function a(e){for(var t=e.length;--t>=0;)e[t]=0}function o(e){var t=e.state,r=t.pending;r>e.avail_out&&(r=e.avail_out),0!==r&&(R.arraySet(e.output,t.pending_buf,t.pending_out,r,e.next_out),e.next_out+=r,t.pending_out+=r,e.total_out+=r,e.avail_out-=r,t.pending-=r,0===t.pending&&(t.pending_out=0))}function s(e,t){P._tr_flush_block(e,e.block_start>=0?e.block_start:-1,e.strstart-e.block_start,t),e.block_start=e.strstart,o(e.strm)}function c(e,t){e.pending_buf[e.pending++]=t}function u(e,t){e.pending_buf[e.pending++]=t>>>8&255,e.pending_buf[e.pending++]=255&t}function f(e,t,r,n){var i=e.avail_in;return i>n&&(i=n),0===i?0:(e.avail_in-=i,R.arraySet(t,e.input,e.next_in,i,r),1===e.state.wrap?e.adler=T(e.adler,t,i,r):2===e.state.wrap&&(e.adler=M(e.adler,t,i,r)),e.next_in+=i,e.total_in+=i,i)}function l(e,t){var r,n,i=e.max_chain_length,a=e.strstart,o=e.prev_length,s=e.nice_match,c=e.strstart>e.w_size-ue?e.strstart-(e.w_size-ue):0,u=e.window,f=e.w_mask,l=e.prev,h=e.strstart+ce,d=u[a+o-1],p=u[a+o];e.prev_length>=e.good_match&&(i>>=2),s>e.lookahead&&(s=e.lookahead);do if(r=t,u[r+o]===p&&u[r+o-1]===d&&u[r]===u[a]&&u[++r]===u[a+1]){a+=2,r++;do;while(u[++a]===u[++r]&&u[++a]===u[++r]&&u[++a]===u[++r]&&u[++a]===u[++r]&&u[++a]===u[++r]&&u[++a]===u[++r]&&u[++a]===u[++r]&&u[++a]===u[++r]&&h>a);if(n=ce-(h-a),a=h-ce,n>o){if(e.match_start=t,o=n,n>=s)break;d=u[a+o-1],p=u[a+o]}}while((t=l[t&f])>c&&0!==--i);return o<=e.lookahead?o:e.lookahead}function h(e){var t,r,n,i,a,o=e.w_size;do{if(i=e.window_size-e.lookahead-e.strstart,e.strstart>=o+(o-ue)){R.arraySet(e.window,e.window,o,o,0),e.match_start-=o,e.strstart-=o,e.block_start-=o,r=e.hash_size,t=r;do n=e.head[--t],e.head[t]=n>=o?n-o:0;while(--r);r=o,t=r;do n=e.prev[--t],e.prev[t]=n>=o?n-o:0;while(--r);i+=o}if(0===e.strm.avail_in)break;if(r=f(e.strm,e.window,e.strstart+e.lookahead,i),e.lookahead+=r,e.lookahead+e.insert>=se)for(a=e.strstart-e.insert,e.ins_h=e.window[a],e.ins_h=(e.ins_h<<e.hash_shift^e.window[a+1])&e.hash_mask;e.insert&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[a+se-1])&e.hash_mask,e.prev[a&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=a,a++,e.insert--,!(e.lookahead+e.insert<se)););}while(e.lookahead<ue&&0!==e.strm.avail_in)}function d(e,t){var r=65535;for(r>e.pending_buf_size-5&&(r=e.pending_buf_size-5);;){if(e.lookahead<=1){if(h(e),0===e.lookahead&&t===C)return _e;if(0===e.lookahead)break}e.strstart+=e.lookahead,e.lookahead=0;var n=e.block_start+r;if((0===e.strstart||e.strstart>=n)&&(e.lookahead=e.strstart-n,e.strstart=n,s(e,!1),0===e.strm.avail_out))return _e;if(e.strstart-e.block_start>=e.w_size-ue&&(s(e,!1),0===e.strm.avail_out))return _e}return e.insert=0,t===U?(s(e,!0),0===e.strm.avail_out?we:ye):e.strstart>e.block_start&&(s(e,!1),0===e.strm.avail_out)?_e:_e}function p(e,t){for(var r,n;;){if(e.lookahead<ue){if(h(e),e.lookahead<ue&&t===C)return _e;if(0===e.lookahead)break}if(r=0,e.lookahead>=se&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+se-1])&e.hash_mask,r=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),0!==r&&e.strstart-r<=e.w_size-ue&&(e.match_length=l(e,r)),e.match_length>=se)if(n=P._tr_tally(e,e.strstart-e.match_start,e.match_length-se),e.lookahead-=e.match_length,e.match_length<=e.max_lazy_match&&e.lookahead>=se){e.match_length--;do e.strstart++,e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+se-1])&e.hash_mask,r=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart;while(0!==--e.match_length);e.strstart++}else e.strstart+=e.match_length,e.match_length=0,e.ins_h=e.window[e.strstart],e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+1])&e.hash_mask;else n=P._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++;if(n&&(s(e,!1),0===e.strm.avail_out))return _e}return e.insert=e.strstart<se-1?e.strstart:se-1,t===U?(s(e,!0),0===e.strm.avail_out?we:ye):e.last_lit&&(s(e,!1),0===e.strm.avail_out)?_e:be}function g(e,t){for(var r,n,i;;){if(e.lookahead<ue){if(h(e),e.lookahead<ue&&t===C)return _e;if(0===e.lookahead)break}if(r=0,e.lookahead>=se&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+se-1])&e.hash_mask,r=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),e.prev_length=e.match_length,e.prev_match=e.match_start,e.match_length=se-1,0!==r&&e.prev_length<e.max_lazy_match&&e.strstart-r<=e.w_size-ue&&(e.match_length=l(e,r),e.match_length<=5&&(e.strategy===G||e.match_length===se&&e.strstart-e.match_start>4096)&&(e.match_length=se-1)),e.prev_length>=se&&e.match_length<=e.prev_length){i=e.strstart+e.lookahead-se,n=P._tr_tally(e,e.strstart-1-e.prev_match,e.prev_length-se),e.lookahead-=e.prev_length-1,e.prev_length-=2;do++e.strstart<=i&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+se-1])&e.hash_mask,r=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart);while(0!==--e.prev_length);if(e.match_available=0,e.match_length=se-1,e.strstart++,n&&(s(e,!1),0===e.strm.avail_out))return _e}else if(e.match_available){if(n=P._tr_tally(e,0,e.window[e.strstart-1]),n&&s(e,!1),e.strstart++,e.lookahead--,0===e.strm.avail_out)return _e}else e.match_available=1,e.strstart++,e.lookahead--}return e.match_available&&(n=P._tr_tally(e,0,e.window[e.strstart-1]),e.match_available=0),e.insert=e.strstart<se-1?e.strstart:se-1,t===U?(s(e,!0),0===e.strm.avail_out?we:ye):e.last_lit&&(s(e,!1),0===e.strm.avail_out)?_e:be}function m(e,t){for(var r,n,i,a,o=e.window;;){if(e.lookahead<=ce){if(h(e),e.lookahead<=ce&&t===C)return _e;if(0===e.lookahead)break}if(e.match_length=0,e.lookahead>=se&&e.strstart>0&&(i=e.strstart-1,n=o[i],n===o[++i]&&n===o[++i]&&n===o[++i])){a=e.strstart+ce;do;while(n===o[++i]&&n===o[++i]&&n===o[++i]&&n===o[++i]&&n===o[++i]&&n===o[++i]&&n===o[++i]&&n===o[++i]&&a>i);e.match_length=ce-(a-i),e.match_length>e.lookahead&&(e.match_length=e.lookahead)}if(e.match_length>=se?(r=P._tr_tally(e,1,e.match_length-se),e.lookahead-=e.match_length,e.strstart+=e.match_length,e.match_length=0):(r=P._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++),r&&(s(e,!1),0===e.strm.avail_out))return _e}return e.insert=0,t===U?(s(e,!0),0===e.strm.avail_out?we:ye):e.last_lit&&(s(e,!1),0===e.strm.avail_out)?_e:be}function v(e,t){for(var r;;){if(0===e.lookahead&&(h(e),0===e.lookahead)){if(t===C)return _e;break}if(e.match_length=0,r=P._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++,r&&(s(e,!1),0===e.strm.avail_out))return _e}return e.insert=0,t===U?(s(e,!0),0===e.strm.avail_out?we:ye):e.last_lit&&(s(e,!1),0===e.strm.avail_out)?_e:be}function _(e){e.window_size=2*e.w_size,a(e.head),e.max_lazy_match=I[e.level].max_lazy,e.good_match=I[e.level].good_length,e.nice_match=I[e.level].nice_length,e.max_chain_length=I[e.level].max_chain,e.strstart=0,e.block_start=0,e.lookahead=0,e.insert=0,e.match_length=e.prev_length=se-1,e.match_available=0,e.ins_h=0}function b(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=V,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new R.Buf16(2*ae),this.dyn_dtree=new R.Buf16(2*(2*ne+1)),this.bl_tree=new R.Buf16(2*(2*ie+1)),a(this.dyn_ltree),a(this.dyn_dtree),a(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new R.Buf16(oe+1),this.heap=new R.Buf16(2*re+1),a(this.heap),this.heap_len=0,this.heap_max=0,this.depth=new R.Buf16(2*re+1),a(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0}function w(e){var t;return e&&e.state?(e.total_in=e.total_out=0,e.data_type=J,t=e.state,t.pending=0,t.pending_out=0,t.wrap<0&&(t.wrap=-t.wrap),t.status=t.wrap?le:me,e.adler=2===t.wrap?0:1,t.last_flush=C,P._tr_init(t),B):n(e,N)}function y(e){var t=w(e);return t===B&&_(e.state),t}function x(e,t){return e&&e.state?2!==e.state.wrap?N:(e.state.gzhead=t,B):N}function k(e,t,r,i,a,o){if(!e)return N;var s=1;if(t===q&&(t=6),0>i?(s=0,i=-i):i>15&&(s=2,i-=16),1>a||a>K||r!==V||8>i||i>15||0>t||t>9||0>o||o>W)return n(e,N);8===i&&(i=9);var c=new b;return e.state=c,c.strm=e,c.wrap=s,c.gzhead=null,c.w_bits=i,c.w_size=1<<c.w_bits,c.w_mask=c.w_size-1,c.hash_bits=a+7,c.hash_size=1<<c.hash_bits,c.hash_mask=c.hash_size-1,c.hash_shift=~~((c.hash_bits+se-1)/se),c.window=new R.Buf8(2*c.w_size),c.head=new R.Buf16(c.hash_size),c.prev=new R.Buf16(c.w_size),c.lit_bufsize=1<<a+6,c.pending_buf_size=4*c.lit_bufsize,c.pending_buf=new R.Buf8(c.pending_buf_size),c.d_buf=c.lit_bufsize>>1,c.l_buf=3*c.lit_bufsize,c.level=t,c.strategy=o,c.method=r,y(e)}function E(e,t){return k(e,t,V,Q,$,X)}function S(e,t){var r,s,f,l;if(!e||!e.state||t>z||0>t)return e?n(e,N):N;if(s=e.state,!e.output||!e.input&&0!==e.avail_in||s.status===ve&&t!==U)return n(e,0===e.avail_out?Z:N);if(s.strm=e,r=s.last_flush,s.last_flush=t,s.status===le)if(2===s.wrap)e.adler=0,c(s,31),c(s,139),c(s,8),s.gzhead?(c(s,(s.gzhead.text?1:0)+(s.gzhead.hcrc?2:0)+(s.gzhead.extra?4:0)+(s.gzhead.name?8:0)+(s.gzhead.comment?16:0)),c(s,255&s.gzhead.time),c(s,s.gzhead.time>>8&255),c(s,s.gzhead.time>>16&255),c(s,s.gzhead.time>>24&255),c(s,9===s.level?2:s.strategy>=H||s.level<2?4:0),c(s,255&s.gzhead.os),s.gzhead.extra&&s.gzhead.extra.length&&(c(s,255&s.gzhead.extra.length),c(s,s.gzhead.extra.length>>8&255)),s.gzhead.hcrc&&(e.adler=M(e.adler,s.pending_buf,s.pending,0)),s.gzindex=0,s.status=he):(c(s,0),c(s,0),c(s,0),c(s,0),c(s,0),c(s,9===s.level?2:s.strategy>=H||s.level<2?4:0),c(s,xe),s.status=me);else{var h=V+(s.w_bits-8<<4)<<8,d=-1;d=s.strategy>=H||s.level<2?0:s.level<6?1:6===s.level?2:3,h|=d<<6,0!==s.strstart&&(h|=fe),h+=31-h%31,s.status=me,u(s,h),0!==s.strstart&&(u(s,e.adler>>>16),u(s,65535&e.adler)),e.adler=1}if(s.status===he)if(s.gzhead.extra){for(f=s.pending;s.gzindex<(65535&s.gzhead.extra.length)&&(s.pending!==s.pending_buf_size||(s.gzhead.hcrc&&s.pending>f&&(e.adler=M(e.adler,s.pending_buf,s.pending-f,f)),o(e),f=s.pending,s.pending!==s.pending_buf_size));)c(s,255&s.gzhead.extra[s.gzindex]),s.gzindex++;s.gzhead.hcrc&&s.pending>f&&(e.adler=M(e.adler,s.pending_buf,s.pending-f,f)),s.gzindex===s.gzhead.extra.length&&(s.gzindex=0,s.status=de)}else s.status=de;if(s.status===de)if(s.gzhead.name){f=s.pending;do{if(s.pending===s.pending_buf_size&&(s.gzhead.hcrc&&s.pending>f&&(e.adler=M(e.adler,s.pending_buf,s.pending-f,f)),o(e),f=s.pending,s.pending===s.pending_buf_size)){l=1;break}l=s.gzindex<s.gzhead.name.length?255&s.gzhead.name.charCodeAt(s.gzindex++):0,c(s,l)}while(0!==l);s.gzhead.hcrc&&s.pending>f&&(e.adler=M(e.adler,s.pending_buf,s.pending-f,f)),0===l&&(s.gzindex=0,s.status=pe)}else s.status=pe;if(s.status===pe)if(s.gzhead.comment){f=s.pending;do{if(s.pending===s.pending_buf_size&&(s.gzhead.hcrc&&s.pending>f&&(e.adler=M(e.adler,s.pending_buf,s.pending-f,f)),o(e),f=s.pending,s.pending===s.pending_buf_size)){l=1;break}l=s.gzindex<s.gzhead.comment.length?255&s.gzhead.comment.charCodeAt(s.gzindex++):0,c(s,l)}while(0!==l);s.gzhead.hcrc&&s.pending>f&&(e.adler=M(e.adler,s.pending_buf,s.pending-f,f)),0===l&&(s.status=ge)}else s.status=ge;if(s.status===ge&&(s.gzhead.hcrc?(s.pending+2>s.pending_buf_size&&o(e),s.pending+2<=s.pending_buf_size&&(c(s,255&e.adler),c(s,e.adler>>8&255),e.adler=0,s.status=me)):s.status=me),0!==s.pending){if(o(e),0===e.avail_out)return s.last_flush=-1,B}else if(0===e.avail_in&&i(t)<=i(r)&&t!==U)return n(e,Z);if(s.status===ve&&0!==e.avail_in)return n(e,Z);if(0!==e.avail_in||0!==s.lookahead||t!==C&&s.status!==ve){var p=s.strategy===H?v(s,t):s.strategy===Y?m(s,t):I[s.level].func(s,t);if(p!==we&&p!==ye||(s.status=ve),p===_e||p===we)return 0===e.avail_out&&(s.last_flush=-1),B;if(p===be&&(t===O?P._tr_align(s):t!==z&&(P._tr_stored_block(s,0,0,!1),t===D&&(a(s.head),0===s.lookahead&&(s.strstart=0,s.block_start=0,s.insert=0))),o(e),0===e.avail_out))return s.last_flush=-1,B}return t!==U?B:s.wrap<=0?F:(2===s.wrap?(c(s,255&e.adler),c(s,e.adler>>8&255),c(s,e.adler>>16&255),c(s,e.adler>>24&255),c(s,255&e.total_in),c(s,e.total_in>>8&255),c(s,e.total_in>>16&255),c(s,e.total_in>>24&255)):(u(s,e.adler>>>16),u(s,65535&e.adler)),o(e),s.wrap>0&&(s.wrap=-s.wrap),0!==s.pending?B:F)}function A(e){var t;return e&&e.state?(t=e.state.status,t!==le&&t!==he&&t!==de&&t!==pe&&t!==ge&&t!==me&&t!==ve?n(e,N):(e.state=null,t===me?n(e,j):B)):N}var I,R=e("../utils/common"),P=e("./trees"),T=e("./adler32"),M=e("./crc32"),L=e("./messages"),C=0,O=1,D=3,U=4,z=5,B=0,F=1,N=-2,j=-3,Z=-5,q=-1,G=1,H=2,Y=3,W=4,X=0,J=2,V=8,K=9,Q=15,$=8,ee=29,te=256,re=te+1+ee,ne=30,ie=19,ae=2*re+1,oe=15,se=3,ce=258,ue=ce+se+1,fe=32,le=42,he=69,de=73,pe=91,ge=103,me=113,ve=666,_e=1,be=2,we=3,ye=4,xe=3,ke=function(e,t,r,n,i){this.good_length=e,this.max_lazy=t,this.nice_length=r,this.max_chain=n,this.func=i};I=[new ke(0,0,0,0,d),new ke(4,4,8,4,p),new ke(4,5,16,8,p),new ke(4,6,32,32,p),new ke(4,4,16,16,g),new ke(8,16,32,32,g),new ke(8,16,128,128,g),new ke(8,32,128,256,g),new ke(32,128,258,1024,g),new ke(32,258,258,4096,g)],r.deflateInit=E,r.deflateInit2=k,r.deflateReset=y,r.deflateResetKeep=w,r.deflateSetHeader=x,r.deflate=S,r.deflateEnd=A,r.deflateInfo="pako deflate (from Nodeca project)"},{"../utils/common":37,"./adler32":38,"./crc32":40,"./messages":45,"./trees":46}],42:[function(e,t,r){"use strict";var n=30,i=12;t.exports=function(e,t){var r,a,o,s,c,u,f,l,h,d,p,g,m,v,_,b,w,y,x,k,E,S,A,I,R;r=e.state,a=e.next_in,I=e.input,o=a+(e.avail_in-5),s=e.next_out,R=e.output,c=s-(t-e.avail_out),u=s+(e.avail_out-257),f=r.dmax,l=r.wsize,h=r.whave,d=r.wnext,p=r.window,g=r.hold,m=r.bits,v=r.lencode,_=r.distcode,b=(1<<r.lenbits)-1,w=(1<<r.distbits)-1;e:do{15>m&&(g+=I[a++]<<m,m+=8,g+=I[a++]<<m,m+=8),y=v[g&b];t:for(;;){if(x=y>>>24,g>>>=x,m-=x,x=y>>>16&255,0===x)R[s++]=65535&y;else{if(!(16&x)){if(0===(64&x)){y=v[(65535&y)+(g&(1<<x)-1)];continue t}if(32&x){r.mode=i;break e}e.msg="invalid literal/length code",r.mode=n;break e}k=65535&y,x&=15,x&&(x>m&&(g+=I[a++]<<m,m+=8),k+=g&(1<<x)-1,g>>>=x,m-=x),15>m&&(g+=I[a++]<<m,m+=8,g+=I[a++]<<m,m+=8),y=_[g&w];r:for(;;){if(x=y>>>24,g>>>=x,m-=x,x=y>>>16&255,!(16&x)){if(0===(64&x)){y=_[(65535&y)+(g&(1<<x)-1)];continue r}e.msg="invalid distance code",r.mode=n;break e}if(E=65535&y,x&=15,x>m&&(g+=I[a++]<<m,m+=8,x>m&&(g+=I[a++]<<m,m+=8)),E+=g&(1<<x)-1,E>f){e.msg="invalid distance too far back",r.mode=n;break e}if(g>>>=x,m-=x,x=s-c,E>x){if(x=E-x,x>h&&r.sane){e.msg="invalid distance too far back",r.mode=n;break e}if(S=0,A=p,0===d){if(S+=l-x,k>x){k-=x;do R[s++]=p[S++];while(--x);S=s-E,A=R}}else if(x>d){if(S+=l+d-x,x-=d,k>x){k-=x;do R[s++]=p[S++];while(--x);if(S=0,k>d){x=d,k-=x;do R[s++]=p[S++];while(--x);S=s-E,A=R}}}else if(S+=d-x,k>x){k-=x;do R[s++]=p[S++];while(--x);S=s-E,A=R}for(;k>2;)R[s++]=A[S++],
R[s++]=A[S++],R[s++]=A[S++],k-=3;k&&(R[s++]=A[S++],k>1&&(R[s++]=A[S++]))}else{S=s-E;do R[s++]=R[S++],R[s++]=R[S++],R[s++]=R[S++],k-=3;while(k>2);k&&(R[s++]=R[S++],k>1&&(R[s++]=R[S++]))}break}}break}}while(o>a&&u>s);k=m>>3,a-=k,m-=k<<3,g&=(1<<m)-1,e.next_in=a,e.next_out=s,e.avail_in=o>a?5+(o-a):5-(a-o),e.avail_out=u>s?257+(u-s):257-(s-u),r.hold=g,r.bits=m}},{}],43:[function(e,t,r){"use strict";function n(e){return(e>>>24&255)+(e>>>8&65280)+((65280&e)<<8)+((255&e)<<24)}function i(){this.mode=0,this.last=!1,this.wrap=0,this.havedict=!1,this.flags=0,this.dmax=0,this.check=0,this.total=0,this.head=null,this.wbits=0,this.wsize=0,this.whave=0,this.wnext=0,this.window=null,this.hold=0,this.bits=0,this.length=0,this.offset=0,this.extra=0,this.lencode=null,this.distcode=null,this.lenbits=0,this.distbits=0,this.ncode=0,this.nlen=0,this.ndist=0,this.have=0,this.next=null,this.lens=new v.Buf16(320),this.work=new v.Buf16(288),this.lendyn=null,this.distdyn=null,this.sane=0,this.back=0,this.was=0}function a(e){var t;return e&&e.state?(t=e.state,e.total_in=e.total_out=t.total=0,e.msg="",t.wrap&&(e.adler=1&t.wrap),t.mode=U,t.last=0,t.havedict=0,t.dmax=32768,t.head=null,t.hold=0,t.bits=0,t.lencode=t.lendyn=new v.Buf32(pe),t.distcode=t.distdyn=new v.Buf32(ge),t.sane=1,t.back=-1,R):M}function o(e){var t;return e&&e.state?(t=e.state,t.wsize=0,t.whave=0,t.wnext=0,a(e)):M}function s(e,t){var r,n;return e&&e.state?(n=e.state,0>t?(r=0,t=-t):(r=(t>>4)+1,48>t&&(t&=15)),t&&(8>t||t>15)?M:(null!==n.window&&n.wbits!==t&&(n.window=null),n.wrap=r,n.wbits=t,o(e))):M}function c(e,t){var r,n;return e?(n=new i,e.state=n,n.window=null,r=s(e,t),r!==R&&(e.state=null),r):M}function u(e){return c(e,ve)}function f(e){if(_e){var t;for(g=new v.Buf32(512),m=new v.Buf32(32),t=0;144>t;)e.lens[t++]=8;for(;256>t;)e.lens[t++]=9;for(;280>t;)e.lens[t++]=7;for(;288>t;)e.lens[t++]=8;for(y(k,e.lens,0,288,g,0,e.work,{bits:9}),t=0;32>t;)e.lens[t++]=5;y(E,e.lens,0,32,m,0,e.work,{bits:5}),_e=!1}e.lencode=g,e.lenbits=9,e.distcode=m,e.distbits=5}function l(e,t,r,n){var i,a=e.state;return null===a.window&&(a.wsize=1<<a.wbits,a.wnext=0,a.whave=0,a.window=new v.Buf8(a.wsize)),n>=a.wsize?(v.arraySet(a.window,t,r-a.wsize,a.wsize,0),a.wnext=0,a.whave=a.wsize):(i=a.wsize-a.wnext,i>n&&(i=n),v.arraySet(a.window,t,r-n,i,a.wnext),n-=i,n?(v.arraySet(a.window,t,r-n,n,0),a.wnext=n,a.whave=a.wsize):(a.wnext+=i,a.wnext===a.wsize&&(a.wnext=0),a.whave<a.wsize&&(a.whave+=i))),0}function h(e,t){var r,i,a,o,s,c,u,h,d,p,g,m,pe,ge,me,ve,_e,be,we,ye,xe,ke,Ee,Se,Ae=0,Ie=new v.Buf8(4),Re=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];if(!e||!e.state||!e.output||!e.input&&0!==e.avail_in)return M;r=e.state,r.mode===W&&(r.mode=X),s=e.next_out,a=e.output,u=e.avail_out,o=e.next_in,i=e.input,c=e.avail_in,h=r.hold,d=r.bits,p=c,g=u,ke=R;e:for(;;)switch(r.mode){case U:if(0===r.wrap){r.mode=X;break}for(;16>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}if(2&r.wrap&&35615===h){r.check=0,Ie[0]=255&h,Ie[1]=h>>>8&255,r.check=b(r.check,Ie,2,0),h=0,d=0,r.mode=z;break}if(r.flags=0,r.head&&(r.head.done=!1),!(1&r.wrap)||(((255&h)<<8)+(h>>8))%31){e.msg="incorrect header check",r.mode=le;break}if((15&h)!==D){e.msg="unknown compression method",r.mode=le;break}if(h>>>=4,d-=4,xe=(15&h)+8,0===r.wbits)r.wbits=xe;else if(xe>r.wbits){e.msg="invalid window size",r.mode=le;break}r.dmax=1<<xe,e.adler=r.check=1,r.mode=512&h?H:W,h=0,d=0;break;case z:for(;16>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}if(r.flags=h,(255&r.flags)!==D){e.msg="unknown compression method",r.mode=le;break}if(57344&r.flags){e.msg="unknown header flags set",r.mode=le;break}r.head&&(r.head.text=h>>8&1),512&r.flags&&(Ie[0]=255&h,Ie[1]=h>>>8&255,r.check=b(r.check,Ie,2,0)),h=0,d=0,r.mode=B;case B:for(;32>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}r.head&&(r.head.time=h),512&r.flags&&(Ie[0]=255&h,Ie[1]=h>>>8&255,Ie[2]=h>>>16&255,Ie[3]=h>>>24&255,r.check=b(r.check,Ie,4,0)),h=0,d=0,r.mode=F;case F:for(;16>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}r.head&&(r.head.xflags=255&h,r.head.os=h>>8),512&r.flags&&(Ie[0]=255&h,Ie[1]=h>>>8&255,r.check=b(r.check,Ie,2,0)),h=0,d=0,r.mode=N;case N:if(1024&r.flags){for(;16>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}r.length=h,r.head&&(r.head.extra_len=h),512&r.flags&&(Ie[0]=255&h,Ie[1]=h>>>8&255,r.check=b(r.check,Ie,2,0)),h=0,d=0}else r.head&&(r.head.extra=null);r.mode=j;case j:if(1024&r.flags&&(m=r.length,m>c&&(m=c),m&&(r.head&&(xe=r.head.extra_len-r.length,r.head.extra||(r.head.extra=new Array(r.head.extra_len)),v.arraySet(r.head.extra,i,o,m,xe)),512&r.flags&&(r.check=b(r.check,i,m,o)),c-=m,o+=m,r.length-=m),r.length))break e;r.length=0,r.mode=Z;case Z:if(2048&r.flags){if(0===c)break e;m=0;do xe=i[o+m++],r.head&&xe&&r.length<65536&&(r.head.name+=String.fromCharCode(xe));while(xe&&c>m);if(512&r.flags&&(r.check=b(r.check,i,m,o)),c-=m,o+=m,xe)break e}else r.head&&(r.head.name=null);r.length=0,r.mode=q;case q:if(4096&r.flags){if(0===c)break e;m=0;do xe=i[o+m++],r.head&&xe&&r.length<65536&&(r.head.comment+=String.fromCharCode(xe));while(xe&&c>m);if(512&r.flags&&(r.check=b(r.check,i,m,o)),c-=m,o+=m,xe)break e}else r.head&&(r.head.comment=null);r.mode=G;case G:if(512&r.flags){for(;16>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}if(h!==(65535&r.check)){e.msg="header crc mismatch",r.mode=le;break}h=0,d=0}r.head&&(r.head.hcrc=r.flags>>9&1,r.head.done=!0),e.adler=r.check=0,r.mode=W;break;case H:for(;32>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}e.adler=r.check=n(h),h=0,d=0,r.mode=Y;case Y:if(0===r.havedict)return e.next_out=s,e.avail_out=u,e.next_in=o,e.avail_in=c,r.hold=h,r.bits=d,T;e.adler=r.check=1,r.mode=W;case W:if(t===A||t===I)break e;case X:if(r.last){h>>>=7&d,d-=7&d,r.mode=ce;break}for(;3>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}switch(r.last=1&h,h>>>=1,d-=1,3&h){case 0:r.mode=J;break;case 1:if(f(r),r.mode=te,t===I){h>>>=2,d-=2;break e}break;case 2:r.mode=Q;break;case 3:e.msg="invalid block type",r.mode=le}h>>>=2,d-=2;break;case J:for(h>>>=7&d,d-=7&d;32>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}if((65535&h)!==(h>>>16^65535)){e.msg="invalid stored block lengths",r.mode=le;break}if(r.length=65535&h,h=0,d=0,r.mode=V,t===I)break e;case V:r.mode=K;case K:if(m=r.length){if(m>c&&(m=c),m>u&&(m=u),0===m)break e;v.arraySet(a,i,o,m,s),c-=m,o+=m,u-=m,s+=m,r.length-=m;break}r.mode=W;break;case Q:for(;14>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}if(r.nlen=(31&h)+257,h>>>=5,d-=5,r.ndist=(31&h)+1,h>>>=5,d-=5,r.ncode=(15&h)+4,h>>>=4,d-=4,r.nlen>286||r.ndist>30){e.msg="too many length or distance symbols",r.mode=le;break}r.have=0,r.mode=$;case $:for(;r.have<r.ncode;){for(;3>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}r.lens[Re[r.have++]]=7&h,h>>>=3,d-=3}for(;r.have<19;)r.lens[Re[r.have++]]=0;if(r.lencode=r.lendyn,r.lenbits=7,Ee={bits:r.lenbits},ke=y(x,r.lens,0,19,r.lencode,0,r.work,Ee),r.lenbits=Ee.bits,ke){e.msg="invalid code lengths set",r.mode=le;break}r.have=0,r.mode=ee;case ee:for(;r.have<r.nlen+r.ndist;){for(;Ae=r.lencode[h&(1<<r.lenbits)-1],me=Ae>>>24,ve=Ae>>>16&255,_e=65535&Ae,!(d>=me);){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}if(16>_e)h>>>=me,d-=me,r.lens[r.have++]=_e;else{if(16===_e){for(Se=me+2;Se>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}if(h>>>=me,d-=me,0===r.have){e.msg="invalid bit length repeat",r.mode=le;break}xe=r.lens[r.have-1],m=3+(3&h),h>>>=2,d-=2}else if(17===_e){for(Se=me+3;Se>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}h>>>=me,d-=me,xe=0,m=3+(7&h),h>>>=3,d-=3}else{for(Se=me+7;Se>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}h>>>=me,d-=me,xe=0,m=11+(127&h),h>>>=7,d-=7}if(r.have+m>r.nlen+r.ndist){e.msg="invalid bit length repeat",r.mode=le;break}for(;m--;)r.lens[r.have++]=xe}}if(r.mode===le)break;if(0===r.lens[256]){e.msg="invalid code -- missing end-of-block",r.mode=le;break}if(r.lenbits=9,Ee={bits:r.lenbits},ke=y(k,r.lens,0,r.nlen,r.lencode,0,r.work,Ee),r.lenbits=Ee.bits,ke){e.msg="invalid literal/lengths set",r.mode=le;break}if(r.distbits=6,r.distcode=r.distdyn,Ee={bits:r.distbits},ke=y(E,r.lens,r.nlen,r.ndist,r.distcode,0,r.work,Ee),r.distbits=Ee.bits,ke){e.msg="invalid distances set",r.mode=le;break}if(r.mode=te,t===I)break e;case te:r.mode=re;case re:if(c>=6&&u>=258){e.next_out=s,e.avail_out=u,e.next_in=o,e.avail_in=c,r.hold=h,r.bits=d,w(e,g),s=e.next_out,a=e.output,u=e.avail_out,o=e.next_in,i=e.input,c=e.avail_in,h=r.hold,d=r.bits,r.mode===W&&(r.back=-1);break}for(r.back=0;Ae=r.lencode[h&(1<<r.lenbits)-1],me=Ae>>>24,ve=Ae>>>16&255,_e=65535&Ae,!(d>=me);){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}if(ve&&0===(240&ve)){for(be=me,we=ve,ye=_e;Ae=r.lencode[ye+((h&(1<<be+we)-1)>>be)],me=Ae>>>24,ve=Ae>>>16&255,_e=65535&Ae,!(d>=be+me);){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}h>>>=be,d-=be,r.back+=be}if(h>>>=me,d-=me,r.back+=me,r.length=_e,0===ve){r.mode=se;break}if(32&ve){r.back=-1,r.mode=W;break}if(64&ve){e.msg="invalid literal/length code",r.mode=le;break}r.extra=15&ve,r.mode=ne;case ne:if(r.extra){for(Se=r.extra;Se>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}r.length+=h&(1<<r.extra)-1,h>>>=r.extra,d-=r.extra,r.back+=r.extra}r.was=r.length,r.mode=ie;case ie:for(;Ae=r.distcode[h&(1<<r.distbits)-1],me=Ae>>>24,ve=Ae>>>16&255,_e=65535&Ae,!(d>=me);){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}if(0===(240&ve)){for(be=me,we=ve,ye=_e;Ae=r.distcode[ye+((h&(1<<be+we)-1)>>be)],me=Ae>>>24,ve=Ae>>>16&255,_e=65535&Ae,!(d>=be+me);){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}h>>>=be,d-=be,r.back+=be}if(h>>>=me,d-=me,r.back+=me,64&ve){e.msg="invalid distance code",r.mode=le;break}r.offset=_e,r.extra=15&ve,r.mode=ae;case ae:if(r.extra){for(Se=r.extra;Se>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}r.offset+=h&(1<<r.extra)-1,h>>>=r.extra,d-=r.extra,r.back+=r.extra}if(r.offset>r.dmax){e.msg="invalid distance too far back",r.mode=le;break}r.mode=oe;case oe:if(0===u)break e;if(m=g-u,r.offset>m){if(m=r.offset-m,m>r.whave&&r.sane){e.msg="invalid distance too far back",r.mode=le;break}m>r.wnext?(m-=r.wnext,pe=r.wsize-m):pe=r.wnext-m,m>r.length&&(m=r.length),ge=r.window}else ge=a,pe=s-r.offset,m=r.length;m>u&&(m=u),u-=m,r.length-=m;do a[s++]=ge[pe++];while(--m);0===r.length&&(r.mode=re);break;case se:if(0===u)break e;a[s++]=r.length,u--,r.mode=re;break;case ce:if(r.wrap){for(;32>d;){if(0===c)break e;c--,h|=i[o++]<<d,d+=8}if(g-=u,e.total_out+=g,r.total+=g,g&&(e.adler=r.check=r.flags?b(r.check,a,g,s-g):_(r.check,a,g,s-g)),g=u,(r.flags?h:n(h))!==r.check){e.msg="incorrect data check",r.mode=le;break}h=0,d=0}r.mode=ue;case ue:if(r.wrap&&r.flags){for(;32>d;){if(0===c)break e;c--,h+=i[o++]<<d,d+=8}if(h!==(4294967295&r.total)){e.msg="incorrect length check",r.mode=le;break}h=0,d=0}r.mode=fe;case fe:ke=P;break e;case le:ke=L;break e;case he:return C;case de:default:return M}return e.next_out=s,e.avail_out=u,e.next_in=o,e.avail_in=c,r.hold=h,r.bits=d,(r.wsize||g!==e.avail_out&&r.mode<le&&(r.mode<ce||t!==S))&&l(e,e.output,e.next_out,g-e.avail_out)?(r.mode=he,C):(p-=e.avail_in,g-=e.avail_out,e.total_in+=p,e.total_out+=g,r.total+=g,r.wrap&&g&&(e.adler=r.check=r.flags?b(r.check,a,g,e.next_out-g):_(r.check,a,g,e.next_out-g)),e.data_type=r.bits+(r.last?64:0)+(r.mode===W?128:0)+(r.mode===te||r.mode===V?256:0),(0===p&&0===g||t===S)&&ke===R&&(ke=O),ke)}function d(e){if(!e||!e.state)return M;var t=e.state;return t.window&&(t.window=null),e.state=null,R}function p(e,t){var r;return e&&e.state?(r=e.state,0===(2&r.wrap)?M:(r.head=t,t.done=!1,R)):M}var g,m,v=e("../utils/common"),_=e("./adler32"),b=e("./crc32"),w=e("./inffast"),y=e("./inftrees"),x=0,k=1,E=2,S=4,A=5,I=6,R=0,P=1,T=2,M=-2,L=-3,C=-4,O=-5,D=8,U=1,z=2,B=3,F=4,N=5,j=6,Z=7,q=8,G=9,H=10,Y=11,W=12,X=13,J=14,V=15,K=16,Q=17,$=18,ee=19,te=20,re=21,ne=22,ie=23,ae=24,oe=25,se=26,ce=27,ue=28,fe=29,le=30,he=31,de=32,pe=852,ge=592,me=15,ve=me,_e=!0;r.inflateReset=o,r.inflateReset2=s,r.inflateResetKeep=a,r.inflateInit=u,r.inflateInit2=c,r.inflate=h,r.inflateEnd=d,r.inflateGetHeader=p,r.inflateInfo="pako inflate (from Nodeca project)"},{"../utils/common":37,"./adler32":38,"./crc32":40,"./inffast":42,"./inftrees":44}],44:[function(e,t,r){"use strict";var n=e("../utils/common"),i=15,a=852,o=592,s=0,c=1,u=2,f=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0],l=[16,16,16,16,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,16,72,78],h=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577,0,0],d=[16,16,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,64,64];t.exports=function(e,t,r,p,g,m,v,_){var b,w,y,x,k,E,S,A,I,R=_.bits,P=0,T=0,M=0,L=0,C=0,O=0,D=0,U=0,z=0,B=0,F=null,N=0,j=new n.Buf16(i+1),Z=new n.Buf16(i+1),q=null,G=0;for(P=0;i>=P;P++)j[P]=0;for(T=0;p>T;T++)j[t[r+T]]++;for(C=R,L=i;L>=1&&0===j[L];L--);if(C>L&&(C=L),0===L)return g[m++]=20971520,g[m++]=20971520,_.bits=1,0;for(M=1;L>M&&0===j[M];M++);for(M>C&&(C=M),U=1,P=1;i>=P;P++)if(U<<=1,U-=j[P],0>U)return-1;if(U>0&&(e===s||1!==L))return-1;for(Z[1]=0,P=1;i>P;P++)Z[P+1]=Z[P]+j[P];for(T=0;p>T;T++)0!==t[r+T]&&(v[Z[t[r+T]]++]=T);if(e===s?(F=q=v,E=19):e===c?(F=f,N-=257,q=l,G-=257,E=256):(F=h,q=d,E=-1),B=0,T=0,P=M,k=m,O=C,D=0,y=-1,z=1<<C,x=z-1,e===c&&z>a||e===u&&z>o)return 1;for(var H=0;;){H++,S=P-D,v[T]<E?(A=0,I=v[T]):v[T]>E?(A=q[G+v[T]],I=F[N+v[T]]):(A=96,I=0),b=1<<P-D,w=1<<O,M=w;do w-=b,g[k+(B>>D)+w]=S<<24|A<<16|I|0;while(0!==w);for(b=1<<P-1;B&b;)b>>=1;if(0!==b?(B&=b-1,B+=b):B=0,T++,0===--j[P]){if(P===L)break;P=t[r+v[T]]}if(P>C&&(B&x)!==y){for(0===D&&(D=C),k+=M,O=P-D,U=1<<O;L>O+D&&(U-=j[O+D],!(0>=U));)O++,U<<=1;if(z+=1<<O,e===c&&z>a||e===u&&z>o)return 1;y=B&x,g[y]=C<<24|O<<16|k-m|0}}return 0!==B&&(g[k+B]=P-D<<24|64<<16|0),_.bits=C,0}},{"../utils/common":37}],45:[function(e,t,r){"use strict";t.exports={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"}},{}],46:[function(e,t,r){"use strict";function n(e){for(var t=e.length;--t>=0;)e[t]=0}function i(e){return 256>e?oe[e]:oe[256+(e>>>7)]}function a(e,t){e.pending_buf[e.pending++]=255&t,e.pending_buf[e.pending++]=t>>>8&255}function o(e,t,r){e.bi_valid>W-r?(e.bi_buf|=t<<e.bi_valid&65535,a(e,e.bi_buf),e.bi_buf=t>>W-e.bi_valid,e.bi_valid+=r-W):(e.bi_buf|=t<<e.bi_valid&65535,e.bi_valid+=r)}function s(e,t,r){o(e,r[2*t],r[2*t+1])}function c(e,t){var r=0;do r|=1&e,e>>>=1,r<<=1;while(--t>0);return r>>>1}function u(e){16===e.bi_valid?(a(e,e.bi_buf),e.bi_buf=0,e.bi_valid=0):e.bi_valid>=8&&(e.pending_buf[e.pending++]=255&e.bi_buf,e.bi_buf>>=8,e.bi_valid-=8)}function f(e,t){var r,n,i,a,o,s,c=t.dyn_tree,u=t.max_code,f=t.stat_desc.static_tree,l=t.stat_desc.has_stree,h=t.stat_desc.extra_bits,d=t.stat_desc.extra_base,p=t.stat_desc.max_length,g=0;for(a=0;Y>=a;a++)e.bl_count[a]=0;for(c[2*e.heap[e.heap_max]+1]=0,r=e.heap_max+1;H>r;r++)n=e.heap[r],a=c[2*c[2*n+1]+1]+1,a>p&&(a=p,g++),c[2*n+1]=a,n>u||(e.bl_count[a]++,o=0,n>=d&&(o=h[n-d]),s=c[2*n],e.opt_len+=s*(a+o),l&&(e.static_len+=s*(f[2*n+1]+o)));if(0!==g){do{for(a=p-1;0===e.bl_count[a];)a--;e.bl_count[a]--,e.bl_count[a+1]+=2,e.bl_count[p]--,g-=2}while(g>0);for(a=p;0!==a;a--)for(n=e.bl_count[a];0!==n;)i=e.heap[--r],i>u||(c[2*i+1]!==a&&(e.opt_len+=(a-c[2*i+1])*c[2*i],c[2*i+1]=a),n--)}}function l(e,t,r){var n,i,a=new Array(Y+1),o=0;for(n=1;Y>=n;n++)a[n]=o=o+r[n-1]<<1;for(i=0;t>=i;i++){var s=e[2*i+1];0!==s&&(e[2*i]=c(a[s]++,s))}}function h(){var e,t,r,n,i,a=new Array(Y+1);for(r=0,n=0;N-1>n;n++)for(ce[n]=r,e=0;e<1<<$[n];e++)se[r++]=n;for(se[r-1]=n,i=0,n=0;16>n;n++)for(ue[n]=i,e=0;e<1<<ee[n];e++)oe[i++]=n;for(i>>=7;q>n;n++)for(ue[n]=i<<7,e=0;e<1<<ee[n]-7;e++)oe[256+i++]=n;for(t=0;Y>=t;t++)a[t]=0;for(e=0;143>=e;)ie[2*e+1]=8,e++,a[8]++;for(;255>=e;)ie[2*e+1]=9,e++,a[9]++;for(;279>=e;)ie[2*e+1]=7,e++,a[7]++;for(;287>=e;)ie[2*e+1]=8,e++,a[8]++;for(l(ie,Z+1,a),e=0;q>e;e++)ae[2*e+1]=5,ae[2*e]=c(e,5);fe=new de(ie,$,j+1,Z,Y),le=new de(ae,ee,0,q,Y),he=new de(new Array(0),te,0,G,X)}function d(e){var t;for(t=0;Z>t;t++)e.dyn_ltree[2*t]=0;for(t=0;q>t;t++)e.dyn_dtree[2*t]=0;for(t=0;G>t;t++)e.bl_tree[2*t]=0;e.dyn_ltree[2*J]=1,e.opt_len=e.static_len=0,e.last_lit=e.matches=0}function p(e){e.bi_valid>8?a(e,e.bi_buf):e.bi_valid>0&&(e.pending_buf[e.pending++]=e.bi_buf),e.bi_buf=0,e.bi_valid=0}function g(e,t,r,n){p(e),n&&(a(e,r),a(e,~r)),T.arraySet(e.pending_buf,e.window,t,r,e.pending),e.pending+=r}function m(e,t,r,n){var i=2*t,a=2*r;return e[i]<e[a]||e[i]===e[a]&&n[t]<=n[r]}function v(e,t,r){for(var n=e.heap[r],i=r<<1;i<=e.heap_len&&(i<e.heap_len&&m(t,e.heap[i+1],e.heap[i],e.depth)&&i++,!m(t,n,e.heap[i],e.depth));)e.heap[r]=e.heap[i],r=i,i<<=1;e.heap[r]=n}function _(e,t,r){var n,a,c,u,f=0;if(0!==e.last_lit)do n=e.pending_buf[e.d_buf+2*f]<<8|e.pending_buf[e.d_buf+2*f+1],a=e.pending_buf[e.l_buf+f],f++,0===n?s(e,a,t):(c=se[a],s(e,c+j+1,t),u=$[c],0!==u&&(a-=ce[c],o(e,a,u)),n--,c=i(n),s(e,c,r),u=ee[c],0!==u&&(n-=ue[c],o(e,n,u)));while(f<e.last_lit);s(e,J,t)}function b(e,t){var r,n,i,a=t.dyn_tree,o=t.stat_desc.static_tree,s=t.stat_desc.has_stree,c=t.stat_desc.elems,u=-1;for(e.heap_len=0,e.heap_max=H,r=0;c>r;r++)0!==a[2*r]?(e.heap[++e.heap_len]=u=r,e.depth[r]=0):a[2*r+1]=0;for(;e.heap_len<2;)i=e.heap[++e.heap_len]=2>u?++u:0,a[2*i]=1,e.depth[i]=0,e.opt_len--,s&&(e.static_len-=o[2*i+1]);for(t.max_code=u,r=e.heap_len>>1;r>=1;r--)v(e,a,r);i=c;do r=e.heap[1],e.heap[1]=e.heap[e.heap_len--],v(e,a,1),n=e.heap[1],e.heap[--e.heap_max]=r,e.heap[--e.heap_max]=n,a[2*i]=a[2*r]+a[2*n],e.depth[i]=(e.depth[r]>=e.depth[n]?e.depth[r]:e.depth[n])+1,a[2*r+1]=a[2*n+1]=i,e.heap[1]=i++,v(e,a,1);while(e.heap_len>=2);e.heap[--e.heap_max]=e.heap[1],f(e,t),l(a,u,e.bl_count)}function w(e,t,r){var n,i,a=-1,o=t[1],s=0,c=7,u=4;for(0===o&&(c=138,u=3),t[2*(r+1)+1]=65535,n=0;r>=n;n++)i=o,o=t[2*(n+1)+1],++s<c&&i===o||(u>s?e.bl_tree[2*i]+=s:0!==i?(i!==a&&e.bl_tree[2*i]++,e.bl_tree[2*V]++):10>=s?e.bl_tree[2*K]++:e.bl_tree[2*Q]++,s=0,a=i,0===o?(c=138,u=3):i===o?(c=6,u=3):(c=7,u=4))}function y(e,t,r){var n,i,a=-1,c=t[1],u=0,f=7,l=4;for(0===c&&(f=138,l=3),n=0;r>=n;n++)if(i=c,c=t[2*(n+1)+1],!(++u<f&&i===c)){if(l>u){do s(e,i,e.bl_tree);while(0!==--u)}else 0!==i?(i!==a&&(s(e,i,e.bl_tree),u--),s(e,V,e.bl_tree),o(e,u-3,2)):10>=u?(s(e,K,e.bl_tree),o(e,u-3,3)):(s(e,Q,e.bl_tree),o(e,u-11,7));u=0,a=i,0===c?(f=138,l=3):i===c?(f=6,l=3):(f=7,l=4)}}function x(e){var t;for(w(e,e.dyn_ltree,e.l_desc.max_code),w(e,e.dyn_dtree,e.d_desc.max_code),b(e,e.bl_desc),t=G-1;t>=3&&0===e.bl_tree[2*re[t]+1];t--);return e.opt_len+=3*(t+1)+5+5+4,t}function k(e,t,r,n){var i;for(o(e,t-257,5),o(e,r-1,5),o(e,n-4,4),i=0;n>i;i++)o(e,e.bl_tree[2*re[i]+1],3);y(e,e.dyn_ltree,t-1),y(e,e.dyn_dtree,r-1)}function E(e){var t,r=4093624447;for(t=0;31>=t;t++,r>>>=1)if(1&r&&0!==e.dyn_ltree[2*t])return L;if(0!==e.dyn_ltree[18]||0!==e.dyn_ltree[20]||0!==e.dyn_ltree[26])return C;for(t=32;j>t;t++)if(0!==e.dyn_ltree[2*t])return C;return L}function S(e){ge||(h(),ge=!0),e.l_desc=new pe(e.dyn_ltree,fe),e.d_desc=new pe(e.dyn_dtree,le),e.bl_desc=new pe(e.bl_tree,he),e.bi_buf=0,e.bi_valid=0,d(e)}function A(e,t,r,n){o(e,(D<<1)+(n?1:0),3),g(e,t,r,!0)}function I(e){o(e,U<<1,3),s(e,J,ie),u(e)}function R(e,t,r,n){var i,a,s=0;e.level>0?(e.strm.data_type===O&&(e.strm.data_type=E(e)),b(e,e.l_desc),b(e,e.d_desc),s=x(e),i=e.opt_len+3+7>>>3,a=e.static_len+3+7>>>3,i>=a&&(i=a)):i=a=r+5,i>=r+4&&-1!==t?A(e,t,r,n):e.strategy===M||a===i?(o(e,(U<<1)+(n?1:0),3),_(e,ie,ae)):(o(e,(z<<1)+(n?1:0),3),k(e,e.l_desc.max_code+1,e.d_desc.max_code+1,s+1),_(e,e.dyn_ltree,e.dyn_dtree)),d(e),n&&p(e)}function P(e,t,r){return e.pending_buf[e.d_buf+2*e.last_lit]=t>>>8&255,e.pending_buf[e.d_buf+2*e.last_lit+1]=255&t,e.pending_buf[e.l_buf+e.last_lit]=255&r,e.last_lit++,0===t?e.dyn_ltree[2*r]++:(e.matches++,t--,e.dyn_ltree[2*(se[r]+j+1)]++,e.dyn_dtree[2*i(t)]++),e.last_lit===e.lit_bufsize-1}var T=e("../utils/common"),M=4,L=0,C=1,O=2,D=0,U=1,z=2,B=3,F=258,N=29,j=256,Z=j+1+N,q=30,G=19,H=2*Z+1,Y=15,W=16,X=7,J=256,V=16,K=17,Q=18,$=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0],ee=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],te=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7],re=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],ne=512,ie=new Array(2*(Z+2));n(ie);var ae=new Array(2*q);n(ae);var oe=new Array(ne);n(oe);var se=new Array(F-B+1);n(se);var ce=new Array(N);n(ce);var ue=new Array(q);n(ue);var fe,le,he,de=function(e,t,r,n,i){this.static_tree=e,this.extra_bits=t,this.extra_base=r,this.elems=n,this.max_length=i,this.has_stree=e&&e.length},pe=function(e,t){this.dyn_tree=e,this.max_code=0,this.stat_desc=t},ge=!1;r._tr_init=S,r._tr_stored_block=A,r._tr_flush_block=R,r._tr_tally=P,r._tr_align=I},{"../utils/common":37}],47:[function(e,t,r){"use strict";function n(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0}t.exports=n},{}],48:[function(e,t,r){(function(e){"use strict";function r(t){for(var r=new Array(arguments.length-1),n=0;n<r.length;)r[n++]=arguments[n];e.nextTick(function(){t.apply(null,r)})}!e.version||0===e.version.indexOf("v0.")||0===e.version.indexOf("v1.")&&0!==e.version.indexOf("v1.8.")?t.exports=r:t.exports=e.nextTick}).call(this,e("_process"))},{_process:49}],49:[function(e,t,r){function n(){f=!1,s.length?u=s.concat(u):l=-1,u.length&&i()}function i(){if(!f){var e=setTimeout(n);f=!0;for(var t=u.length;t;){for(s=u,u=[];++l<t;)s&&s[l].run();l=-1,t=u.length}s=null,f=!1,clearTimeout(e)}}function a(e,t){this.fun=e,this.array=t}function o(){}var s,c=t.exports={},u=[],f=!1,l=-1;c.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)t[r-1]=arguments[r];u.push(new a(e,t)),1!==u.length||f||setTimeout(i,0)},a.prototype.run=function(){this.fun.apply(null,this.array)},c.title="browser",c.browser=!0,c.env={},c.argv=[],c.version="",c.versions={},c.on=o,c.addListener=o,c.once=o,c.off=o,c.removeListener=o,c.removeAllListeners=o,c.emit=o,c.binding=function(e){throw new Error("process.binding is not supported")},c.cwd=function(){return"/"},c.chdir=function(e){throw new Error("process.chdir is not supported")},c.umask=function(){return 0}},{}],50:[function(e,t,r){"use strict";function n(e){return this instanceof n?(u.call(this,e),f.call(this,e),e&&e.readable===!1&&(this.readable=!1),e&&e.writable===!1&&(this.writable=!1),this.allowHalfOpen=!0,e&&e.allowHalfOpen===!1&&(this.allowHalfOpen=!1),void this.once("end",i)):new n(e)}function i(){this.allowHalfOpen||this._writableState.ended||s(a,this)}function a(e){e.end()}var o=Object.keys||function(e){var t=[];for(var r in e)t.push(r);return t};t.exports=n;var s=e("process-nextick-args"),c=e("core-util-is");c.inherits=e("inherits");var u=e("./_stream_readable"),f=e("./_stream_writable");c.inherits(n,u);for(var l=o(f.prototype),h=0;h<l.length;h++){var d=l[h];n.prototype[d]||(n.prototype[d]=f.prototype[d])}},{"./_stream_readable":51,"./_stream_writable":53,"core-util-is":22,inherits:28,"process-nextick-args":48}],51:[function(e,t,r){(function(r){"use strict";function n(t,r){O=O||e("./_stream_duplex"),t=t||{},this.objectMode=!!t.objectMode,r instanceof O&&(this.objectMode=this.objectMode||!!t.readableObjectMode);var n=t.highWaterMark,i=this.objectMode?16:16384;this.highWaterMark=n||0===n?n:i,this.highWaterMark=~~this.highWaterMark,this.buffer=[],this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.resumeScheduled=!1,this.defaultEncoding=t.defaultEncoding||"utf8",this.ranOut=!1,this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,t.encoding&&(C||(C=e("string_decoder/").StringDecoder),this.decoder=new C(t.encoding),this.encoding=t.encoding)}function i(t){return O=O||e("./_stream_duplex"),this instanceof i?(this._readableState=new n(t,this),this.readable=!0,t&&"function"==typeof t.read&&(this._read=t.read),void R.call(this)):new i(t)}function a(e,t,r,n,i){var a=u(t,r);if(a)e.emit("error",a);else if(null===r)t.reading=!1,f(e,t);else if(t.objectMode||r&&r.length>0)if(t.ended&&!i){var s=new Error("stream.push() after EOF");e.emit("error",s)}else if(t.endEmitted&&i){var s=new Error("stream.unshift() after end event");e.emit("error",s)}else{var c;!t.decoder||i||n||(r=t.decoder.write(r),c=!t.objectMode&&0===r.length),i||(t.reading=!1),c||(t.flowing&&0===t.length&&!t.sync?(e.emit("data",r),e.read(0)):(t.length+=t.objectMode?1:r.length,i?t.buffer.unshift(r):t.buffer.push(r),t.needReadable&&l(e))),d(e,t)}else i||(t.reading=!1);return o(t)}function o(e){return!e.ended&&(e.needReadable||e.length<e.highWaterMark||0===e.length)}function s(e){return e>=D?e=D:(e--,e|=e>>>1,e|=e>>>2,e|=e>>>4,e|=e>>>8,e|=e>>>16,e++),e}function c(e,t){return 0===t.length&&t.ended?0:t.objectMode?0===e?0:1:null===e||isNaN(e)?t.flowing&&t.buffer.length?t.buffer[0].length:t.length:0>=e?0:(e>t.highWaterMark&&(t.highWaterMark=s(e)),e>t.length?t.ended?t.length:(t.needReadable=!0,0):e)}function u(e,t){var r=null;return I.isBuffer(t)||"string"==typeof t||null===t||void 0===t||e.objectMode||(r=new TypeError("Invalid non-string/buffer chunk")),r}function f(e,t){if(!t.ended){if(t.decoder){var r=t.decoder.end();r&&r.length&&(t.buffer.push(r),t.length+=t.objectMode?1:r.length)}t.ended=!0,l(e)}}function l(e){var t=e._readableState;t.needReadable=!1,t.emittedReadable||(L("emitReadable",t.flowing),t.emittedReadable=!0,t.sync?S(h,e):h(e))}function h(e){L("emit readable"),e.emit("readable"),b(e)}function d(e,t){t.readingMore||(t.readingMore=!0,S(p,e,t))}function p(e,t){for(var r=t.length;!t.reading&&!t.flowing&&!t.ended&&t.length<t.highWaterMark&&(L("maybeReadMore read 0"),e.read(0),r!==t.length);)r=t.length;t.readingMore=!1}function g(e){return function(){var t=e._readableState;L("pipeOnDrain",t.awaitDrain),t.awaitDrain&&t.awaitDrain--,0===t.awaitDrain&&P(e,"data")&&(t.flowing=!0,b(e))}}function m(e){L("readable nexttick read 0"),e.read(0)}function v(e,t){t.resumeScheduled||(t.resumeScheduled=!0,S(_,e,t))}function _(e,t){t.reading||(L("resume read 0"),e.read(0)),t.resumeScheduled=!1,e.emit("resume"),b(e),t.flowing&&!t.reading&&e.read(0)}function b(e){var t=e._readableState;if(L("flow",t.flowing),t.flowing)do var r=e.read();while(null!==r&&t.flowing)}function w(e,t){var r,n=t.buffer,i=t.length,a=!!t.decoder,o=!!t.objectMode;if(0===n.length)return null;if(0===i)r=null;else if(o)r=n.shift();else if(!e||e>=i)r=a?n.join(""):1===n.length?n[0]:I.concat(n,i),n.length=0;else if(e<n[0].length){var s=n[0];r=s.slice(0,e),n[0]=s.slice(e)}else if(e===n[0].length)r=n.shift();else{r=a?"":new I(e);for(var c=0,u=0,f=n.length;f>u&&e>c;u++){var s=n[0],l=Math.min(e-c,s.length);a?r+=s.slice(0,l):s.copy(r,c,0,l),l<s.length?n[0]=s.slice(l):n.shift(),c+=l}}return r}function y(e){var t=e._readableState;if(t.length>0)throw new Error("endReadable called on non-empty stream");t.endEmitted||(t.ended=!0,S(x,t,e))}function x(e,t){e.endEmitted||0!==e.length||(e.endEmitted=!0,t.readable=!1,t.emit("end"))}function k(e,t){for(var r=0,n=e.length;n>r;r++)t(e[r],r)}function E(e,t){for(var r=0,n=e.length;n>r;r++)if(e[r]===t)return r;return-1}t.exports=i;var S=e("process-nextick-args"),A=e("isarray"),I=e("buffer").Buffer;i.ReadableState=n;var R,P=(e("events"),function(e,t){return e.listeners(t).length});!function(){try{R=e("stream")}catch(t){}finally{R||(R=e("events").EventEmitter)}}();var I=e("buffer").Buffer,T=e("core-util-is");T.inherits=e("inherits");var M=e("util"),L=void 0;L=M&&M.debuglog?M.debuglog("stream"):function(){};var C;T.inherits(i,R);var O,O;i.prototype.push=function(e,t){var r=this._readableState;return r.objectMode||"string"!=typeof e||(t=t||r.defaultEncoding,t!==r.encoding&&(e=new I(e,t),t="")),a(this,r,e,t,!1)},i.prototype.unshift=function(e){var t=this._readableState;return a(this,t,e,"",!0)},i.prototype.isPaused=function(){return this._readableState.flowing===!1},i.prototype.setEncoding=function(t){return C||(C=e("string_decoder/").StringDecoder),this._readableState.decoder=new C(t),this._readableState.encoding=t,this};var D=8388608;i.prototype.read=function(e){L("read",e);var t=this._readableState,r=e;if(("number"!=typeof e||e>0)&&(t.emittedReadable=!1),0===e&&t.needReadable&&(t.length>=t.highWaterMark||t.ended))return L("read: emitReadable",t.length,t.ended),0===t.length&&t.ended?y(this):l(this),null;if(e=c(e,t),0===e&&t.ended)return 0===t.length&&y(this),null;var n=t.needReadable;L("need readable",n),(0===t.length||t.length-e<t.highWaterMark)&&(n=!0,L("length less than watermark",n)),(t.ended||t.reading)&&(n=!1,L("reading or ended",n)),n&&(L("do read"),t.reading=!0,t.sync=!0,0===t.length&&(t.needReadable=!0),this._read(t.highWaterMark),t.sync=!1),n&&!t.reading&&(e=c(r,t));var i;return i=e>0?w(e,t):null,null===i&&(t.needReadable=!0,e=0),t.length-=e,0!==t.length||t.ended||(t.needReadable=!0),r!==e&&t.ended&&0===t.length&&y(this),null!==i&&this.emit("data",i),i},i.prototype._read=function(e){this.emit("error",new Error("not implemented"))},i.prototype.pipe=function(e,t){function n(e){L("onunpipe"),e===l&&a()}function i(){L("onend"),e.end()}function a(){L("cleanup"),e.removeListener("close",c),e.removeListener("finish",u),e.removeListener("drain",m),e.removeListener("error",s),e.removeListener("unpipe",n),l.removeListener("end",i),l.removeListener("end",a),l.removeListener("data",o),v=!0,!h.awaitDrain||e._writableState&&!e._writableState.needDrain||m()}function o(t){L("ondata");var r=e.write(t);!1===r&&(1!==h.pipesCount||h.pipes[0]!==e||1!==l.listenerCount("data")||v||(L("false write response, pause",l._readableState.awaitDrain),l._readableState.awaitDrain++),l.pause())}function s(t){L("onerror",t),f(),e.removeListener("error",s),0===P(e,"error")&&e.emit("error",t)}function c(){e.removeListener("finish",u),f()}function u(){L("onfinish"),e.removeListener("close",c),f()}function f(){L("unpipe"),l.unpipe(e)}var l=this,h=this._readableState;switch(h.pipesCount){case 0:h.pipes=e;break;case 1:h.pipes=[h.pipes,e];break;default:h.pipes.push(e)}h.pipesCount+=1,L("pipe count=%d opts=%j",h.pipesCount,t);var d=(!t||t.end!==!1)&&e!==r.stdout&&e!==r.stderr,p=d?i:a;h.endEmitted?S(p):l.once("end",p),e.on("unpipe",n);var m=g(l);e.on("drain",m);var v=!1;return l.on("data",o),e._events&&e._events.error?A(e._events.error)?e._events.error.unshift(s):e._events.error=[s,e._events.error]:e.on("error",s),e.once("close",c),e.once("finish",u),e.emit("pipe",l),h.flowing||(L("pipe resume"),l.resume()),e},i.prototype.unpipe=function(e){var t=this._readableState;if(0===t.pipesCount)return this;if(1===t.pipesCount)return e&&e!==t.pipes?this:(e||(e=t.pipes),t.pipes=null,t.pipesCount=0,t.flowing=!1,e&&e.emit("unpipe",this),this);if(!e){var r=t.pipes,n=t.pipesCount;t.pipes=null,t.pipesCount=0,t.flowing=!1;for(var i=0;n>i;i++)r[i].emit("unpipe",this);return this}var a=E(t.pipes,e);return-1===a?this:(t.pipes.splice(a,1),t.pipesCount-=1,1===t.pipesCount&&(t.pipes=t.pipes[0]),e.emit("unpipe",this),this)},i.prototype.on=function(e,t){var r=R.prototype.on.call(this,e,t);if("data"===e&&!1!==this._readableState.flowing&&this.resume(),"readable"===e&&!this._readableState.endEmitted){var n=this._readableState;n.readableListening||(n.readableListening=!0,n.emittedReadable=!1,n.needReadable=!0,n.reading?n.length&&l(this,n):S(m,this))}return r},i.prototype.addListener=i.prototype.on,i.prototype.resume=function(){var e=this._readableState;return e.flowing||(L("resume"),e.flowing=!0,v(this,e)),this},i.prototype.pause=function(){return L("call pause flowing=%j",this._readableState.flowing),!1!==this._readableState.flowing&&(L("pause"),this._readableState.flowing=!1,this.emit("pause")),this},i.prototype.wrap=function(e){var t=this._readableState,r=!1,n=this;e.on("end",function(){if(L("wrapped end"),t.decoder&&!t.ended){var e=t.decoder.end();e&&e.length&&n.push(e)}n.push(null)}),e.on("data",function(i){if(L("wrapped data"),t.decoder&&(i=t.decoder.write(i)),(!t.objectMode||null!==i&&void 0!==i)&&(t.objectMode||i&&i.length)){var a=n.push(i);a||(r=!0,e.pause())}});for(var i in e)void 0===this[i]&&"function"==typeof e[i]&&(this[i]=function(t){
return function(){return e[t].apply(e,arguments)}}(i));var a=["error","close","destroy","pause","resume"];return k(a,function(t){e.on(t,n.emit.bind(n,t))}),n._read=function(t){L("wrapped _read",t),r&&(r=!1,e.resume())},n},i._fromList=w}).call(this,e("_process"))},{"./_stream_duplex":50,_process:49,buffer:21,"core-util-is":22,events:25,inherits:28,isarray:30,"process-nextick-args":48,"string_decoder/":55,util:18}],52:[function(e,t,r){"use strict";function n(e){this.afterTransform=function(t,r){return i(e,t,r)},this.needTransform=!1,this.transforming=!1,this.writecb=null,this.writechunk=null,this.writeencoding=null}function i(e,t,r){var n=e._transformState;n.transforming=!1;var i=n.writecb;if(!i)return e.emit("error",new Error("no writecb in Transform class"));n.writechunk=null,n.writecb=null,null!==r&&void 0!==r&&e.push(r),i(t);var a=e._readableState;a.reading=!1,(a.needReadable||a.length<a.highWaterMark)&&e._read(a.highWaterMark)}function a(e){if(!(this instanceof a))return new a(e);s.call(this,e),this._transformState=new n(this);var t=this;this._readableState.needReadable=!0,this._readableState.sync=!1,e&&("function"==typeof e.transform&&(this._transform=e.transform),"function"==typeof e.flush&&(this._flush=e.flush)),this.once("prefinish",function(){"function"==typeof this._flush?this._flush(function(e){o(t,e)}):o(t)})}function o(e,t){if(t)return e.emit("error",t);var r=e._writableState,n=e._transformState;if(r.length)throw new Error("calling transform done when ws.length != 0");if(n.transforming)throw new Error("calling transform done when still transforming");return e.push(null)}t.exports=a;var s=e("./_stream_duplex"),c=e("core-util-is");c.inherits=e("inherits"),c.inherits(a,s),a.prototype.push=function(e,t){return this._transformState.needTransform=!1,s.prototype.push.call(this,e,t)},a.prototype._transform=function(e,t,r){throw new Error("not implemented")},a.prototype._write=function(e,t,r){var n=this._transformState;if(n.writecb=r,n.writechunk=e,n.writeencoding=t,!n.transforming){var i=this._readableState;(n.needTransform||i.needReadable||i.length<i.highWaterMark)&&this._read(i.highWaterMark)}},a.prototype._read=function(e){var t=this._transformState;null!==t.writechunk&&t.writecb&&!t.transforming?(t.transforming=!0,this._transform(t.writechunk,t.writeencoding,t.afterTransform)):t.needTransform=!0}},{"./_stream_duplex":50,"core-util-is":22,inherits:28}],53:[function(e,t,r){(function(r){"use strict";function n(){}function i(e,t,r){this.chunk=e,this.encoding=t,this.callback=r,this.next=null}function a(t,r){P=P||e("./_stream_duplex"),t=t||{},this.objectMode=!!t.objectMode,r instanceof P&&(this.objectMode=this.objectMode||!!t.writableObjectMode);var n=t.highWaterMark,i=this.objectMode?16:16384;this.highWaterMark=n||0===n?n:i,this.highWaterMark=~~this.highWaterMark,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1;var a=t.decodeStrings===!1;this.decodeStrings=!a,this.defaultEncoding=t.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(e){p(r,e)},this.writecb=null,this.writelen=0,this.bufferedRequest=null,this.lastBufferedRequest=null,this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1,this.bufferedRequestCount=0,this.corkedRequestsFree=new x(this),this.corkedRequestsFree.next=new x(this)}function o(t){return P=P||e("./_stream_duplex"),this instanceof o||this instanceof P?(this._writableState=new a(t,this),this.writable=!0,t&&("function"==typeof t.write&&(this._write=t.write),"function"==typeof t.writev&&(this._writev=t.writev)),void I.call(this)):new o(t)}function s(e,t){var r=new Error("write after end");e.emit("error",r),k(t,r)}function c(e,t,r,n){var i=!0;if(!S.isBuffer(r)&&"string"!=typeof r&&null!==r&&void 0!==r&&!t.objectMode){var a=new TypeError("Invalid non-string/buffer chunk");e.emit("error",a),k(n,a),i=!1}return i}function u(e,t,r){return e.objectMode||e.decodeStrings===!1||"string"!=typeof t||(t=new S(t,r)),t}function f(e,t,r,n,a){r=u(t,r,n),S.isBuffer(r)&&(n="buffer");var o=t.objectMode?1:r.length;t.length+=o;var s=t.length<t.highWaterMark;if(s||(t.needDrain=!0),t.writing||t.corked){var c=t.lastBufferedRequest;t.lastBufferedRequest=new i(r,n,a),c?c.next=t.lastBufferedRequest:t.bufferedRequest=t.lastBufferedRequest,t.bufferedRequestCount+=1}else l(e,t,!1,o,r,n,a);return s}function l(e,t,r,n,i,a,o){t.writelen=n,t.writecb=o,t.writing=!0,t.sync=!0,r?e._writev(i,t.onwrite):e._write(i,a,t.onwrite),t.sync=!1}function h(e,t,r,n,i){--t.pendingcb,r?k(i,n):i(n),e._writableState.errorEmitted=!0,e.emit("error",n)}function d(e){e.writing=!1,e.writecb=null,e.length-=e.writelen,e.writelen=0}function p(e,t){var r=e._writableState,n=r.sync,i=r.writecb;if(d(r),t)h(e,r,n,t,i);else{var a=_(r);a||r.corked||r.bufferProcessing||!r.bufferedRequest||v(e,r),n?E(g,e,r,a,i):g(e,r,a,i)}}function g(e,t,r,n){r||m(e,t),t.pendingcb--,n(),w(e,t)}function m(e,t){0===t.length&&t.needDrain&&(t.needDrain=!1,e.emit("drain"))}function v(e,t){t.bufferProcessing=!0;var r=t.bufferedRequest;if(e._writev&&r&&r.next){var n=t.bufferedRequestCount,i=new Array(n),a=t.corkedRequestsFree;a.entry=r;for(var o=0;r;)i[o]=r,r=r.next,o+=1;l(e,t,!0,t.length,i,"",a.finish),t.pendingcb++,t.lastBufferedRequest=null,t.corkedRequestsFree=a.next,a.next=null}else{for(;r;){var s=r.chunk,c=r.encoding,u=r.callback,f=t.objectMode?1:s.length;if(l(e,t,!1,f,s,c,u),r=r.next,t.writing)break}null===r&&(t.lastBufferedRequest=null)}t.bufferedRequestCount=0,t.bufferedRequest=r,t.bufferProcessing=!1}function _(e){return e.ending&&0===e.length&&null===e.bufferedRequest&&!e.finished&&!e.writing}function b(e,t){t.prefinished||(t.prefinished=!0,e.emit("prefinish"))}function w(e,t){var r=_(t);return r&&(0===t.pendingcb?(b(e,t),t.finished=!0,e.emit("finish")):b(e,t)),r}function y(e,t,r){t.ending=!0,w(e,t),r&&(t.finished?k(r):e.once("finish",r)),t.ended=!0,e.writable=!1}function x(e){var t=this;this.next=null,this.entry=null,this.finish=function(r){var n=t.entry;for(t.entry=null;n;){var i=n.callback;e.pendingcb--,i(r),n=n.next}e.corkedRequestsFree?e.corkedRequestsFree.next=t:e.corkedRequestsFree=t}}t.exports=o;var k=e("process-nextick-args"),E=!r.browser&&["v0.10","v0.9."].indexOf(r.version.slice(0,5))>-1?setImmediate:k,S=e("buffer").Buffer;o.WritableState=a;var A=e("core-util-is");A.inherits=e("inherits");var I,R={deprecate:e("util-deprecate")};!function(){try{I=e("stream")}catch(t){}finally{I||(I=e("events").EventEmitter)}}();var S=e("buffer").Buffer;A.inherits(o,I);var P;a.prototype.getBuffer=function(){for(var e=this.bufferedRequest,t=[];e;)t.push(e),e=e.next;return t},function(){try{Object.defineProperty(a.prototype,"buffer",{get:R.deprecate(function(){return this.getBuffer()},"_writableState.buffer is deprecated. Use _writableState.getBuffer instead.")})}catch(e){}}();var P;o.prototype.pipe=function(){this.emit("error",new Error("Cannot pipe. Not readable."))},o.prototype.write=function(e,t,r){var i=this._writableState,a=!1;return"function"==typeof t&&(r=t,t=null),S.isBuffer(e)?t="buffer":t||(t=i.defaultEncoding),"function"!=typeof r&&(r=n),i.ended?s(this,r):c(this,i,e,r)&&(i.pendingcb++,a=f(this,i,e,t,r)),a},o.prototype.cork=function(){var e=this._writableState;e.corked++},o.prototype.uncork=function(){var e=this._writableState;e.corked&&(e.corked--,e.writing||e.corked||e.finished||e.bufferProcessing||!e.bufferedRequest||v(this,e))},o.prototype.setDefaultEncoding=function(e){if("string"==typeof e&&(e=e.toLowerCase()),!(["hex","utf8","utf-8","ascii","binary","base64","ucs2","ucs-2","utf16le","utf-16le","raw"].indexOf((e+"").toLowerCase())>-1))throw new TypeError("Unknown encoding: "+e);this._writableState.defaultEncoding=e},o.prototype._write=function(e,t,r){r(new Error("not implemented"))},o.prototype._writev=null,o.prototype.end=function(e,t,r){var n=this._writableState;"function"==typeof e?(r=e,e=null,t=null):"function"==typeof t&&(r=t,t=null),null!==e&&void 0!==e&&this.write(e,t),n.corked&&(n.corked=1,this.uncork()),n.ending||n.finished||y(this,n,r)}}).call(this,e("_process"))},{"./_stream_duplex":50,_process:49,buffer:21,"core-util-is":22,events:25,inherits:28,"process-nextick-args":48,"util-deprecate":56}],54:[function(e,t,r){t.exports=e("./lib/_stream_transform.js")},{"./lib/_stream_transform.js":52}],55:[function(e,t,r){function n(e){if(e&&!c(e))throw new Error("Unknown encoding: "+e)}function i(e){return e.toString(this.encoding)}function a(e){this.charReceived=e.length%2,this.charLength=this.charReceived?2:0}function o(e){this.charReceived=e.length%3,this.charLength=this.charReceived?3:0}var s=e("buffer").Buffer,c=s.isEncoding||function(e){switch(e&&e.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}},u=r.StringDecoder=function(e){switch(this.encoding=(e||"utf8").toLowerCase().replace(/[-_]/,""),n(e),this.encoding){case"utf8":this.surrogateSize=3;break;case"ucs2":case"utf16le":this.surrogateSize=2,this.detectIncompleteChar=a;break;case"base64":this.surrogateSize=3,this.detectIncompleteChar=o;break;default:return void(this.write=i)}this.charBuffer=new s(6),this.charReceived=0,this.charLength=0};u.prototype.write=function(e){for(var t="";this.charLength;){var r=e.length>=this.charLength-this.charReceived?this.charLength-this.charReceived:e.length;if(e.copy(this.charBuffer,this.charReceived,0,r),this.charReceived+=r,this.charReceived<this.charLength)return"";e=e.slice(r,e.length),t=this.charBuffer.slice(0,this.charLength).toString(this.encoding);var n=t.charCodeAt(t.length-1);if(!(n>=55296&&56319>=n)){if(this.charReceived=this.charLength=0,0===e.length)return t;break}this.charLength+=this.surrogateSize,t=""}this.detectIncompleteChar(e);var i=e.length;this.charLength&&(e.copy(this.charBuffer,0,e.length-this.charReceived,i),i-=this.charReceived),t+=e.toString(this.encoding,0,i);var i=t.length-1,n=t.charCodeAt(i);if(n>=55296&&56319>=n){var a=this.surrogateSize;return this.charLength+=a,this.charReceived+=a,this.charBuffer.copy(this.charBuffer,a,0,a),e.copy(this.charBuffer,0,0,a),t.substring(0,i)}return t},u.prototype.detectIncompleteChar=function(e){for(var t=e.length>=3?3:e.length;t>0;t--){var r=e[e.length-t];if(1==t&&r>>5==6){this.charLength=2;break}if(2>=t&&r>>4==14){this.charLength=3;break}if(3>=t&&r>>3==30){this.charLength=4;break}}this.charReceived=t},u.prototype.end=function(e){var t="";if(e&&e.length&&(t=this.write(e)),this.charReceived){var r=this.charReceived,n=this.charBuffer,i=this.encoding;t+=n.slice(0,r).toString(i)}return t}},{buffer:21}],56:[function(e,t,r){(function(e){function r(e,t){function r(){if(!i){if(n("throwDeprecation"))throw new Error(t);n("traceDeprecation")?console.trace(t):console.warn(t),i=!0}return e.apply(this,arguments)}if(n("noDeprecation"))return e;var i=!1;return r}function n(t){try{if(!e.localStorage)return!1}catch(r){return!1}var n=e.localStorage[t];return null==n?!1:"true"===String(n).toLowerCase()}t.exports=r}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{}],57:[function(e,t,r){t.exports=function(e){return e&&"object"==typeof e&&"function"==typeof e.copy&&"function"==typeof e.fill&&"function"==typeof e.readUInt8}},{}],58:[function(e,t,r){(function(t,n){function i(e,t){var n={seen:[],stylize:o};return arguments.length>=3&&(n.depth=arguments[2]),arguments.length>=4&&(n.colors=arguments[3]),g(t)?n.showHidden=t:t&&r._extend(n,t),y(n.showHidden)&&(n.showHidden=!1),y(n.depth)&&(n.depth=2),y(n.colors)&&(n.colors=!1),y(n.customInspect)&&(n.customInspect=!0),n.colors&&(n.stylize=a),c(n,e,n.depth)}function a(e,t){var r=i.styles[t];return r?"["+i.colors[r][0]+"m"+e+"["+i.colors[r][1]+"m":e}function o(e,t){return e}function s(e){var t={};return e.forEach(function(e,r){t[e]=!0}),t}function c(e,t,n){if(e.customInspect&&t&&A(t.inspect)&&t.inspect!==r.inspect&&(!t.constructor||t.constructor.prototype!==t)){var i=t.inspect(n,e);return b(i)||(i=c(e,i,n)),i}var a=u(e,t);if(a)return a;var o=Object.keys(t),g=s(o);if(e.showHidden&&(o=Object.getOwnPropertyNames(t)),S(t)&&(o.indexOf("message")>=0||o.indexOf("description")>=0))return f(t);if(0===o.length){if(A(t)){var m=t.name?": "+t.name:"";return e.stylize("[Function"+m+"]","special")}if(x(t))return e.stylize(RegExp.prototype.toString.call(t),"regexp");if(E(t))return e.stylize(Date.prototype.toString.call(t),"date");if(S(t))return f(t)}var v="",_=!1,w=["{","}"];if(p(t)&&(_=!0,w=["[","]"]),A(t)){var y=t.name?": "+t.name:"";v=" [Function"+y+"]"}if(x(t)&&(v=" "+RegExp.prototype.toString.call(t)),E(t)&&(v=" "+Date.prototype.toUTCString.call(t)),S(t)&&(v=" "+f(t)),0===o.length&&(!_||0==t.length))return w[0]+v+w[1];if(0>n)return x(t)?e.stylize(RegExp.prototype.toString.call(t),"regexp"):e.stylize("[Object]","special");e.seen.push(t);var k;return k=_?l(e,t,n,g,o):o.map(function(r){return h(e,t,n,g,r,_)}),e.seen.pop(),d(k,v,w)}function u(e,t){if(y(t))return e.stylize("undefined","undefined");if(b(t)){var r="'"+JSON.stringify(t).replace(/^"|"$/g,"").replace(/'/g,"\\'").replace(/\\"/g,'"')+"'";return e.stylize(r,"string")}return _(t)?e.stylize(""+t,"number"):g(t)?e.stylize(""+t,"boolean"):m(t)?e.stylize("null","null"):void 0}function f(e){return"["+Error.prototype.toString.call(e)+"]"}function l(e,t,r,n,i){for(var a=[],o=0,s=t.length;s>o;++o)M(t,String(o))?a.push(h(e,t,r,n,String(o),!0)):a.push("");return i.forEach(function(i){i.match(/^\d+$/)||a.push(h(e,t,r,n,i,!0))}),a}function h(e,t,r,n,i,a){var o,s,u;if(u=Object.getOwnPropertyDescriptor(t,i)||{value:t[i]},u.get?s=u.set?e.stylize("[Getter/Setter]","special"):e.stylize("[Getter]","special"):u.set&&(s=e.stylize("[Setter]","special")),M(n,i)||(o="["+i+"]"),s||(e.seen.indexOf(u.value)<0?(s=m(r)?c(e,u.value,null):c(e,u.value,r-1),s.indexOf("\n")>-1&&(s=a?s.split("\n").map(function(e){return"  "+e}).join("\n").substr(2):"\n"+s.split("\n").map(function(e){return"   "+e}).join("\n"))):s=e.stylize("[Circular]","special")),y(o)){if(a&&i.match(/^\d+$/))return s;o=JSON.stringify(""+i),o.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)?(o=o.substr(1,o.length-2),o=e.stylize(o,"name")):(o=o.replace(/'/g,"\\'").replace(/\\"/g,'"').replace(/(^"|"$)/g,"'"),o=e.stylize(o,"string"))}return o+": "+s}function d(e,t,r){var n=0,i=e.reduce(function(e,t){return n++,t.indexOf("\n")>=0&&n++,e+t.replace(/\u001b\[\d\d?m/g,"").length+1},0);return i>60?r[0]+(""===t?"":t+"\n ")+" "+e.join(",\n  ")+" "+r[1]:r[0]+t+" "+e.join(", ")+" "+r[1]}function p(e){return Array.isArray(e)}function g(e){return"boolean"==typeof e}function m(e){return null===e}function v(e){return null==e}function _(e){return"number"==typeof e}function b(e){return"string"==typeof e}function w(e){return"symbol"==typeof e}function y(e){return void 0===e}function x(e){return k(e)&&"[object RegExp]"===R(e)}function k(e){return"object"==typeof e&&null!==e}function E(e){return k(e)&&"[object Date]"===R(e)}function S(e){return k(e)&&("[object Error]"===R(e)||e instanceof Error)}function A(e){return"function"==typeof e}function I(e){return null===e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||"symbol"==typeof e||"undefined"==typeof e}function R(e){return Object.prototype.toString.call(e)}function P(e){return 10>e?"0"+e.toString(10):e.toString(10)}function T(){var e=new Date,t=[P(e.getHours()),P(e.getMinutes()),P(e.getSeconds())].join(":");return[e.getDate(),D[e.getMonth()],t].join(" ")}function M(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var L=/%[sdj%]/g;r.format=function(e){if(!b(e)){for(var t=[],r=0;r<arguments.length;r++)t.push(i(arguments[r]));return t.join(" ")}for(var r=1,n=arguments,a=n.length,o=String(e).replace(L,function(e){if("%%"===e)return"%";if(r>=a)return e;switch(e){case"%s":return String(n[r++]);case"%d":return Number(n[r++]);case"%j":try{return JSON.stringify(n[r++])}catch(t){return"[Circular]"}default:return e}}),s=n[r];a>r;s=n[++r])o+=m(s)||!k(s)?" "+s:" "+i(s);return o},r.deprecate=function(e,i){function a(){if(!o){if(t.throwDeprecation)throw new Error(i);t.traceDeprecation?console.trace(i):console.error(i),o=!0}return e.apply(this,arguments)}if(y(n.process))return function(){return r.deprecate(e,i).apply(this,arguments)};if(t.noDeprecation===!0)return e;var o=!1;return a};var C,O={};r.debuglog=function(e){if(y(C)&&(C=t.env.NODE_DEBUG||""),e=e.toUpperCase(),!O[e])if(new RegExp("\\b"+e+"\\b","i").test(C)){var n=t.pid;O[e]=function(){var t=r.format.apply(r,arguments);console.error("%s %d: %s",e,n,t)}}else O[e]=function(){};return O[e]},r.inspect=i,i.colors={bold:[1,22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,39]},i.styles={special:"cyan",number:"yellow","boolean":"yellow",undefined:"grey","null":"bold",string:"green",date:"magenta",regexp:"red"},r.isArray=p,r.isBoolean=g,r.isNull=m,r.isNullOrUndefined=v,r.isNumber=_,r.isString=b,r.isSymbol=w,r.isUndefined=y,r.isRegExp=x,r.isObject=k,r.isDate=E,r.isError=S,r.isFunction=A,r.isPrimitive=I,r.isBuffer=e("./support/isBuffer");var D=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];r.log=function(){console.log("%s - %s",T(),r.format.apply(r,arguments))},r.inherits=e("inherits"),r._extend=function(e,t){if(!t||!k(t))return e;for(var r=Object.keys(t),n=r.length;n--;)e[r[n]]=t[r[n]];return e}}).call(this,e("_process"),"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./support/isBuffer":57,_process:49,inherits:28}],59:[function(e,t,r){var n=arguments[3],i=arguments[4],a=arguments[5],o=JSON.stringify;t.exports=function(e){for(var t,r=Object.keys(a),s=0,c=r.length;c>s;s++){var u=r[s],f=a[u].exports;if(f===e||f["default"]===e){t=u;break}}if(!t){t=Math.floor(Math.pow(16,8)*Math.random()).toString(16);for(var l={},s=0,c=r.length;c>s;s++){var u=r[s];l[u]=u}i[t]=[Function(["require","module","exports"],"("+e+")(self)"),l]}var h=Math.floor(Math.pow(16,8)*Math.random()).toString(16),d={};d[t]=t,i[h]=[Function(["require"],"var f = require("+o(t)+");(f.default ? f.default : f)(self);"),d];var p="("+n+")({"+Object.keys(i).map(function(e){return o(e)+":["+i[e][0]+","+o(i[e][1])+"]"}).join(",")+"},{},["+o(h)+"])",g=window.URL||window.webkitURL||window.mozURL||window.msURL;return new Worker(g.createObjectURL(new Blob([p],{type:"text/javascript"})))}},{}]},{},[1])(1)});